#!/usr/bin/python
# -*- coding: utf-8 -*-

import os, locale, glob, shutil
from PyQt4.QtCore import *
from PyQt4.QtGui import *
#### Enlevé le 30/03/11 #############################
#from PyQt4.QtCore import SIGNAL, Qt
#from PyQt4.QtGui import QVBoxLayout, QHBoxLayout, QWidget, QLabel, QSpinBox, QSlider, QStackedWidget, QSizePolicy, QMessageBox
#####################################################
from gui_modules_animation.animation_base_encodageFiltre import Base_EncodageFiltre
from gui_modules_common.mencoder_gui import WidgetMEncoder
# Création des objets: WidgetFFmpeg2theora et WidgetFFmpeg ... l'objet WidgetMEncoder a été changé en conséquence 
from gui_modules_common.ffmpeg2theora_gui import WidgetFFmpeg2theora
from gui_modules_common.ffmpeg_gui import WidgetFFmpeg
from gui_modules_common.EkdWidgets import EkdSaveDialog
from gui_modules_common.EkdWidgets import EkdCodecPropertie
from moteur_modules_common.EkdConfig import EkdConfig
from moteur_modules_common.EkdTools import debug

# Collecte des infos codec audio
from moteur_modules_animation.mplayer import getParamVideo
###############
from moteur_modules_common.EkdCompatiblePython2Et3 import EkdPrint
###############

# Vérif si le codec en question est supporté par FFmpeg
from moteur_modules_common.FFmpegProspect import FFmpegFormat  


# Les widgets des 4 1ères classes apparaissent alternativemement
# selon l'entrée de la boîte de combo sélectionnée (stacked)

class Codecs_SansReglages(QWidget):
	# -------------------------------------------------------------------
	# Widgets associés au codecs:
	# Copie (format original) - AVI-RAW Sans Compression - Codec XVID -
	# Qualite SVCD - Qualite DVD - Codec H264 MPEG 4
	# -------------------------------------------------------------------
	def __init__(self):
		QWidget.__init__(self)

		# label texte
		txt1=_(u"Réglage automatique pour ce choix")
		label=QLabel(u"<center>{0}</center>".format(txt1))

		vbox=QVBoxLayout()
		vbox.addWidget(label)
		self.setLayout(vbox)


class Codecs_AvecReglages(QWidget):
	# -------------------------------------------------------------------
	# Widgets associés aux codecs :
	# -------------------------------------------------------------------
	# Les données sont définies dans l'appel se trouvant dans la classe
	def __init__(self, choixCodec, min_range_1, max_range_1, min_range_2, max_range_2, txt1 = _(u"Réglage de la compression : "), txt5 = _(u"Réglage du bitrate vidéo : ")):
	
		'''
		Codecs_AvecReglages  : Crée un widget avec : 1 slider, 1 bare de progession et un texte explicatif
		          choixCodec : Nom du codec qui sera utilisé lors de l'enregistrement dans EkdConfig
			  min_range_1  : Valeur minimale du slider et de la barre
			  max_range_1  : Valeur maximale du slider et de la barre
			  min_range_2  : Valeur minimale du slider et de la barre
			  max_range_2  : Valeur maximale du slider et de la barre
			  txt1         : Texte intitulé du réglage (compression vidéo)
			  txt5         : Texte intitulé du réglage (bitrate vidéo)
		'''
		
		QWidget.__init__(self)

		self.choixCodec = choixCodec

		self.idSection = "animation_encodage_general"

		# label titre
		self.txt1 = txt1
		self.txt5 = txt5
		
		self.min_range_2 = min_range_2
		self.max_range_2 = max_range_2
		
		self.label_1=QLabel(u"<center><u>{0}</u></center>".format(txt1))

		# boite de spin pour la compression vidéo
		self.spinCompression=QSpinBox()		# self car on va récupérer la variable depuis le moteur
		self.spinCompression.setRange(min_range_1, max_range_1)
		
		self.label_2=QLabel(u"<center><u>{0}</u></center>".format(txt5))
		
		txt6 = _(u'Dimension de la vidéo :')
		self.label_3 = QLabel(u"<center><u>{0}</u></center>".format(txt6))
		
		self.label_4 = QLabel(u"<center><u>{0}</u></center>".format(txt6))
		self.label_5 = QLabel(u"<center><u>{0}</u></center>".format(txt6))
		
		# Boîte de spin pour le bitrate vidéo
		self.spinBitrateVideo=QSpinBox()
		self.spinBitrateVideo.setRange(min_range_2, max_range_2)

		# Curseur associé à spinCompression
		self.curseur_1 = QSlider(Qt.Horizontal)
		self.curseur_1.setRange(min_range_1, max_range_1)
		
		self.connect(self.spinCompression,SIGNAL("valueChanged(int)"),self.sauverSpin_1)
		self.connect(self.curseur_1, SIGNAL("sliderMoved(int)"), self.curseurBouge_1)
		
		# Curseur associé à spinBitrateVideo
		self.curseur_2 = QSlider(Qt.Horizontal)
		self.curseur_2.setRange(min_range_2, max_range_2)
		
		self.connect(self.spinBitrateVideo,SIGNAL("valueChanged(int)"),self.sauverSpin_2)
		self.connect(self.curseur_2, SIGNAL("sliderMoved(int)"), self.curseurBouge_2)
		
		# Liste pour la taille des vidéos
		# Le 01/12/12, ajout des presets HD 4K (3840x2160), HD 4K Cin (4096x2160), HD 4K Cin (4096x1716), 
		# HD 4K Cin (3996x2160), HD 2.7K (2716x1524), HD 2.7K Cin (2716x1440), HD 2K Cin (2048x1080), 
		# HD 2K Cin (2048x858), HD 2K Cin (1998x1080), HD 1440P (4/3): 1920x1440, ...
		self.liste_taille_generale_video = [_(u"Pas de changement (vidéo avec la même taille que l'original)"), 
		  _(u'HD 4K (3840x2160)'), _(u'HD 4K Cin (4096x2160)'), _(u'HD 4K Cin (4096x1716)'), 
		  _(u'HD 4K Cin (3996x2160)'), _(u'HD 2.7K (2716x1524)'), _(u'HD 2.7K Cin (2716x1440)'), 
		  _(u'HD 2K Cin (2048x1080)'), _(u'HD 2K Cin (2048x858)'), _(u'HD 2K Cin (1998x1080)'),
                  _(u'HD 1440P (4/3): 1920x1440'), _(u'HD 1080p (16/9): 1920x1080'), _(u'HD 720p (16/9): 1280x720'), 
                  _(u'HD 540p (16/9): 960x540'), _(u'HD 480p (16/9): 854x480'), 
                  _(u'PAL/SECAM (16/9): 1024x576'), _(u'PAL/SECAM Computer Video (4/3): 768x576'), 
                  _(u'PAL/SECAM (rapport 1.25): 720x576'), _(u'PAL/SECAM (4/3): 384x288'), 
                  _(u'PAL/SECAM Qualité VCD (rapport 1.22): 352x288'), _(u'PAL/SECAM (4/3): 320x240'), 
                  _(u'NTSC (rapport 1.5): 720x480'), _(u'NTSC Computer Video (4/3): 640x480'), 
                  _(u'NTSC Computer Video (4/3): 512x384'), _(u'NTSC SVCD (1/1): 480x480'), 
                  _(u'NTSC Qualité VCD (rapport 1.46): 352x240'), _(u'Affichage WHUXGA (rapport 1.6): 7680x4800'), 
                  _(u'Affichage WHSXGA (rapport 1.56): 6400x4096'), _(u'Affichage HSXGA (rapport 1.25): 5120x4096'), 
                  _(u'Affichage WQUXGA (rapport 1.6): 3840x2400'), _(u'Affichage WQSXGA (rapport 1.56): 3200x2048'), 
                  _(u'Affichage QSXGA (rapport 1.25): 2560x2048'), _(u'Affichage WOXGA (rapport 1.6): 2560x1600'), 
                  _(u'Affichage QXGA (4/3): 2048x1536'), _(u'Affichage WUXGA (rapport 1.6): 1920x1200'), 
                  _(u'Affichage WSXGA (rapport 1.56): 1600x1024'), _(u'Affichage WXGA (16/9): 1366x768'), 
                  _(u'Affichage SXGA (rapport 1.25): 1280x1024'), _(u'Affichage UXGA (4/3): 1600x1200'), 
                  _(u'Affichage XGA (4/3): 1024x768'), _(u'Affichage SVGA (4/3): 800x600'), 
                  _(u'Affichage VEGA (rapport 1.83): 640x350'), _(u'Affichage VGA (4/3): 640x480'), 
                  _(u'Affichage QQVGA (4/3): 160x120'), _(u'Smartphone (16/10): 800x480')]
		  
		### Pour le mkv
		txt7 = _(u'Format vidéo :')
		self.label_6 = QLabel(u"<center><u>{0}</u></center>".format(txt7))
		
		txt8 = _(u'Format audio :')
		self.label_7 = QLabel(u"<center><u>{0}</u></center>".format(txt8))
		
		### Pour le DVD
		txt9 = _(u'Mode :')
		self.label_8 = QLabel(u"<center><u>{0}</u></center>".format(txt9))
		
		txt10 = _(u'Apparence :')
		self.label_9 = QLabel(u"<center><u>{0}</u></center>".format(txt10))
		
		### Pour le désentrelacement vidéo
		txt11 = _(u"Désentrelacement")
		self.label_10 = QLabel(u"<center><u>{0}</u></center>".format(txt11))
		
		try:
			debug("{0}".format(EkdConfig.get(self.idSection,self.choixCodec)))
			self.spinCompression.setValue(int(EkdConfig.get(self.idSection,self.choixCodec)))
		except:
			debug("Pas de paramètre ou mauvais parametre de configuration pour:\n\
			DivX4, Codec Motion JPEG, Codec MPEG1, Codec MPEG2 ou Codec WMV2")
			#debug( "Pas de paramètre ou mauvais paramètre de configuration pour:\n\
			#DivX4, Codec Motion JPEG, Codec MPEG1, Codec MPEG2 ou Codec WMV2")

		# Rangement des widgets
		self.vbox = QVBoxLayout(self)
		self.grid=QGridLayout()
		# Label uniquement pour le Mkv (vidéo)
		self.grid.addWidget(self.label_6,0,2)
		# Label uniquement pour le Mkv (audio)
		self.grid.addWidget(self.label_7,2,2)
		# Label pour la compression vidéo
		self.grid.addWidget(self.label_1,4,2)
		# Slider de la qualité de la compression
		self.grid.addWidget(self.spinCompression,5,1)
		# Curseur associé à spinCompression
		self.grid.addWidget(self.curseur_1,5,2)
		# Label pour le bitrate vidéo
		self.grid.addWidget(self.label_2,6,2)
		# Slider du bitrate vidéo
		self.grid.addWidget(self.spinBitrateVideo,7,1)
		# Curseur associé à spinBitrateVideo
		self.grid.addWidget(self.curseur_2,7,2)
		self.grid.addWidget(self.label_3,8,2)
		self.grid.addWidget(self.label_4,10,2)
		# Label uniquement pour le DVD (Mode)
		self.grid.addWidget(self.label_8,11,2)
		# Label uniquement pour le DVD (Apparence)
		self.grid.addWidget(self.label_9,13,2)
		# Label pour le désentrelacement vidéo
		self.grid.addWidget(self.label_10,15,2)
		self.vbox.addStretch()
		self.vbox.addLayout(self.grid)
		self.vbox.addStretch()

		# On récupère la valeur du bitrate à partir de la configuration
		try:
			bitrate = EkdConfig.get('animation_encodage_general_bitrate_video',self.choixCodec)
			self.spinBitrateVideo.setValue(int(bitrate))
		except IndexError:
			pass
		      
		# On cache certains widgets suivant les codecs choisis dans 
		# la liste ... et on montre ceux qui doivent être montrés
		if self.choixCodec in ['codecoggtheora_ext_ogg', 'codecoggtheora_ext_ogv', 'codecoggtheora_ext_ogm', 'codec_vob_ffmpeg']:
			self.label_2.hide()
			self.spinBitrateVideo.hide()
			self.curseur_2.hide()
			self.label_3.hide()
			self.label_4.hide()
			self.label_6.hide()
			self.label_7.hide()
			self.label_8.hide()
			self.label_9.hide()
			self.label_10.hide()

	def sauverSpin_1(self,i):
		"""conserver le spin dans le fichier de configuration et modifie le curseur"""
		debug("{0} {1}".format(self.choixCodec,i))
		EkdConfig.set(self.idSection,self.choixCodec,i)
		# sauver curseur
		self.curseur_1.setValue(i)

	def curseurBouge_1(self, i):
		"""Quand on change la position du curseur la valeur du spin est automatiquement modifiée"""
		self.spinCompression.setValue(i)
	
	def sauverSpin_2(self,i):
		"""conserver le spin dans le fichier de configuration et modifie le curseur"""
		debug("{0} {1}".format(self.choixCodec,i))
		#EkdConfig.set(self.idSection,self.choixCodec,i)
		EkdConfig.set('animation_encodage_general_bitrate_video',self.choixCodec,i)
		# sauver curseur
		self.curseur_2.setValue(i)

	def curseurBouge_2(self, i):
		"""Quand on change la position du curseur la valeur du spin est automatiquement modifiée"""
		self.spinBitrateVideo.setValue(i)
	
	
class Codec_AVI_RAW(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_AVI_RAW, self).__init__('avirawsanscompression', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_1.hide()
	self.spinCompression.hide()
	self.curseur_1.hide()
	self.label_2.hide()
	self.spinBitrateVideo.hide()
	self.curseur_2.hide()
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()

        ## On utilise EkdPropertie pour gérer le réglage du codec
        self.label_3.show()
        section=u"animation_encodage_general" 
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
        
        prop='taille_video_avi_raw_mencoder'
        params = self.liste_taille_generale_video
        self.resoSortieAviRawMencoder = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_mencoder_tous'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementMencoder = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
             
	self.grid.addWidget(self.resoSortieAviRawMencoder.widget,13,2)
	self.grid.addWidget(self.label_10,14,2)
	self.grid.addWidget(self.choixDesentrelacementMencoder.widget,15,2)

    def get_taill_video_avi_raw_mencoder(self):
       taillVidAviRawMencoder = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_avi_raw_mencoder'][int(self.resoSortieAviRawMencoder.value)])
       return taillVidAviRawMencoder
       
    def get_desentrelacement_mencoder(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_mencoder_tous'][int(self.choixDesentrelacementMencoder.value)])
	return choixDesentrelacement
       
       
class Codec_HFYU(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_HFYU, self).__init__('codec_hfyu_ffmpeg', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_1.hide()
	self.spinCompression.hide()
	self.curseur_1.hide()
	self.label_2.hide()
	self.spinBitrateVideo.hide()
	self.curseur_2.hide()
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
        ## On utilise EkdPropertie pour gérer le réglage du codec
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
 
        prop='taille_video_general_ffmpeg'
        params = self.liste_taille_generale_video
        self.resoSortieGeneralFFmpeg = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_ffmpeg'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementFFmpeg = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
           
        self.grid.addWidget(self.label_5,12,2)
        self.grid.addWidget(self.resoSortieGeneralFFmpeg.widget,13,2)
	self.grid.addWidget(self.label_10,14,2)
	self.grid.addWidget(self.choixDesentrelacementFFmpeg.widget,15,2)
        
    def get_taill_video_general_ffmpeg(self):
       taillVidGenFFmpeg = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_ffmpeg'][int(self.resoSortieGeneralFFmpeg.value)])
       return taillVidGenFFmpeg

    def get_desentrelacement_ffmpeg(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_ffmpeg'][int(self.choixDesentrelacementFFmpeg.value)])
	return choixDesentrelacement
       
       
class Codec_JPEGsansPerte(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_JPEGsansPerte, self).__init__('jpeg_sans_perte', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_1.hide()
	self.spinCompression.hide()
	self.curseur_1.hide()
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
	
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
        
        prop='taille_video_general_mencoder'
        params = self.liste_taille_generale_video
        self.resoSortieJpegSansPerte = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_mencoder_tous'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementMencoder = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
             
        self.grid.addWidget(self.label_5,12,2)             
	self.grid.addWidget(self.resoSortieJpegSansPerte.widget,13,2)
	self.grid.addWidget(self.label_10,14,2)
	self.grid.addWidget(self.choixDesentrelacementMencoder.widget,15,2)

    def get_taill_video_jpeg_sans_p_mencoder(self):
       taillVidJpegSansPerteMencoder = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_mencoder'][int(self.resoSortieJpegSansPerte.value)])
       return taillVidJpegSansPerteMencoder
       
    def get_desentrelacement_mencoder(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_mencoder_tous'][int(self.choixDesentrelacementMencoder.value)])
	return choixDesentrelacement
       
       
class Codec_FFv1(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_FFv1, self).__init__('ffv1', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_1.hide()
	self.spinCompression.hide()
	self.curseur_1.hide()
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
	
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
        
        prop='taille_video_general_mencoder'
        params = self.liste_taille_generale_video
        self.resoSortieFFv1 = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_mencoder_tous'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementMencoder = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
                                                
        self.grid.addWidget(self.label_5,12,2)
	self.grid.addWidget(self.resoSortieFFv1.widget,13,2)
	self.grid.addWidget(self.label_10,14,2)
	self.grid.addWidget(self.choixDesentrelacementMencoder.widget,15,2)	

    def get_taill_video_ffv1_mencoder(self):
       taillVidFFv1Mencoder = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_mencoder'][int(self.resoSortieFFv1.value)])
       return taillVidFFv1Mencoder
       
    def get_desentrelacement_mencoder(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_mencoder_tous'][int(self.choixDesentrelacementMencoder.value)])
	return choixDesentrelacement       
       
       
class Codec_MOV(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_MOV, self).__init__('codec_mov_ffmpeg', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_1.show()
	self.curseur_1.show()
	self.label_2.hide()
	self.spinBitrateVideo.hide()
	self.curseur_2.hide()
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
	
        ## On utilise EkdPropertie pour gérer le réglage du codec
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
 
        prop='taille_video_general_ffmpeg'
        params = self.liste_taille_generale_video
        self.resoSortieGeneralFFmpeg = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_ffmpeg'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementFFmpeg = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
              
        self.grid.addWidget(self.label_5,12,2)
        self.grid.addWidget(self.resoSortieGeneralFFmpeg.widget,13,2)
	self.grid.addWidget(self.label_10,14,2)
	self.grid.addWidget(self.choixDesentrelacementFFmpeg.widget,15,2)
        
    def get_taill_video_general_ffmpeg(self):
       taillVidGenFFmpeg = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_ffmpeg'][int(self.resoSortieGeneralFFmpeg.value)])
       return taillVidGenFFmpeg
       
    def get_desentrelacement_ffmpeg(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_ffmpeg'][int(self.choixDesentrelacementFFmpeg.value)])
	return choixDesentrelacement
       
       
class Codec_XVID(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_XVID, self).__init__('codecxvid', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_1.hide()
	self.spinCompression.hide()
	self.curseur_1.hide()
	self.label_2.show()
	self.spinBitrateVideo.show()
	self.curseur_2.show()
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
	
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
        
        prop='taille_video_xvid_mencoder'
        params = self.liste_taille_generale_video
        self.resoSortieXvid = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_mencoder_tous'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementMencoder = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)

        self.grid.addWidget(self.label_5,12,2)
	self.grid.addWidget(self.resoSortieXvid.widget,13,2)
	self.grid.addWidget(self.label_10,14,2)
	self.grid.addWidget(self.choixDesentrelacementMencoder.widget,15,2)
	
    def get_taill_video_xvid_mencoder(self):
       taillVidXvidMencoder = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_xvid_mencoder'][int(self.resoSortieXvid.value)])
       return taillVidXvidMencoder

    def get_desentrelacement_mencoder(self):
	choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_mencoder_tous'][int(self.choixDesentrelacementMencoder.value)])
	return choixDesentrelacement
       
       
class Codec_WEBM(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_WEBM, self).__init__('codec_webm_ffmpeg', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_1.hide()
	self.spinCompression.hide()
	self.curseur_1.hide()
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
	
        ## On utilise EkdPropertie pour gérer le réglage du codec
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
	
        prop='taille_video_general_ffmpeg'
        params = self.liste_taille_generale_video
        self.resoSortieGeneralFFmpeg = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
 
	prop='choix_desentrelacement_ffmpeg'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementFFmpeg = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
             
        self.grid.addWidget(self.label_5,12,2)
        self.grid.addWidget(self.resoSortieGeneralFFmpeg.widget,13,2)
	self.grid.addWidget(self.label_10,14,2)
	self.grid.addWidget(self.choixDesentrelacementFFmpeg.widget,15,2)
        
    def get_taill_video_general_ffmpeg(self):
       taillVidGenFFmpeg = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_ffmpeg'][int(self.resoSortieGeneralFFmpeg.value)])
       return taillVidGenFFmpeg 
       
    def get_desentrelacement_ffmpeg(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_ffmpeg'][int(self.choixDesentrelacementFFmpeg.value)])
	return choixDesentrelacement
       
       
class Codec_MKV(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_MKV, self).__init__('conteneur_mkv_ffmpeg', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
        self.label_3.hide()
        self.label_4.hide()
        self.label_2.hide()
        self.spinBitrateVideo.hide()
        self.curseur_2.hide()
	self.label_8.hide()
	self.label_9.hide()
	## Désentrelacement
	#self.label_10.hide()
	
        ### FIXME: Ajout de deux EkdStylePropertie pour gérer sousCodecMkvVideo et sousCodecMkvAudio
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
        
        prop='mkvvideo'
        params = [_(u'Pas de sélection (mpeg4 par défaut)'), _(u'FFV1 sans perte (FFmpeg)'),
                  _(u'MPEG 2'), _(u'H263 Plus'), _(u'MPEG 4'), _(u'MS MPEG 4 version 2'),
                  _(u'MPEG 1'), _(u'WMV 2')]
        self.sousCodecMkvVideo = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
        prop='mkvaudio'
        params =  [_(u'Pas de sélection (copie par défaut)'), _(u'PCM'),
                  _(u'Free Lossless Audio Codec (FLAC)'), (u'ATJC A/52A (AC-3)'),
                  _(u'MPEG Audio Layer 2'), _(u'Vorbis'), _(u'Windows Media Audio 2'),
                  _(u'Windows Media Audio 1'), _(u'MP3 (Lame)')]
        self.sousCodecMkvAudio = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
        prop='taille_video_general_ffmpeg'
        params = self.liste_taille_generale_video
        self.resoSortieGeneralFFmpeg = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_ffmpeg'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementFFmpeg = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
                                                
        self.grid.addWidget(self.sousCodecMkvVideo.widget,1,2)
        self.grid.addWidget(self.sousCodecMkvAudio.widget,3,2)
        self.grid.addWidget(self.label_5,12,2)
        self.grid.addWidget(self.resoSortieGeneralFFmpeg.widget,13,2)
	self.grid.addWidget(self.label_10,14,2)
	self.grid.addWidget(self.choixDesentrelacementFFmpeg.widget,15,2)
        
    def get_audio(self):
       acodec_mkv = u"-acodec {0}".format(EkdConfig.CODEC_PROPERTIES['mkvaudio'][int(self.sousCodecMkvAudio.value)])
       if acodec_mkv == "-acodec ": return u""
       else: return acodec_mkv

    def get_video(self):
       vcodec_mkv = u"-vcodec {0}".format(EkdConfig.CODEC_PROPERTIES['mkvvideo'][int(self.sousCodecMkvVideo.value)])
       if vcodec_mkv == "-vcodec ": return u""
       else: return vcodec_mkv
       
    def get_taill_video_general_ffmpeg(self):
       taillVidGenFFmpeg = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_ffmpeg'][int(self.resoSortieGeneralFFmpeg.value)])
       return taillVidGenFFmpeg
       
    def get_desentrelacement_ffmpeg(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_ffmpeg'][int(self.choixDesentrelacementFFmpeg.value)])
	return choixDesentrelacement
       
       
class Codec_DIVX4(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_DIVX4, self).__init__('codecdivx4', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
	
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
        
        prop='taille_video_general_mencoder'
        params = self.liste_taille_generale_video
        self.resoSortieDivx4 = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_mencoder_tous'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementMencoder = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
                         
        self.grid.addWidget(self.label_5,12,2)
	self.grid.addWidget(self.resoSortieDivx4.widget,13,2)
	self.grid.addWidget(self.label_10,14,2)
	self.grid.addWidget(self.choixDesentrelacementMencoder.widget,15,2)

    def get_taill_video_divx4_mencoder(self):
       taillVidDivx4Mencoder = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_mencoder'][int(self.resoSortieDivx4.value)])
       return taillVidDivx4Mencoder
       
    def get_desentrelacement_mencoder(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_mencoder_tous'][int(self.choixDesentrelacementMencoder.value)])
	return choixDesentrelacement
	
       
class Codec_MotionJPEG(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_MotionJPEG, self).__init__('codecmotionjpeg', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
	
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
        
        prop='taille_video_general_mencoder'
        params = self.liste_taille_generale_video
        self.resoSortieMotionJPEG = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_mencoder_tous'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementMencoder = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
                  
        self.grid.addWidget(self.label_5,12,2)
	self.grid.addWidget(self.resoSortieMotionJPEG.widget,13,2)
	self.grid.addWidget(self.label_10,14,2)
	self.grid.addWidget(self.choixDesentrelacementMencoder.widget,15,2)

    def get_taill_video_motion_jpeg_mencoder(self):
       taillVidMotionJpegMencoder = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_mencoder'][int(self.resoSortieMotionJPEG.value)])
       return taillVidMotionJpegMencoder
       
    def get_desentrelacement_mencoder(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_mencoder_tous'][int(self.choixDesentrelacementMencoder.value)])
	return choixDesentrelacement
       
       
class Codec_Mpeg1(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_Mpeg1, self).__init__('codecmpeg1', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
	
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
        
        prop='taille_video_general_mencoder'
        params = self.liste_taille_generale_video
        self.resoSortieMpeg1 = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_mencoder_tous'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementMencoder = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
            
        self.grid.addWidget(self.label_5,12,2)
	self.grid.addWidget(self.resoSortieMpeg1.widget,13,2)
	self.grid.addWidget(self.label_10,14,2)
	self.grid.addWidget(self.choixDesentrelacementMencoder.widget,15,2)

    def get_taill_video_mpeg1_mencoder(self):
       taillVidMpeg1Mencoder = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_mencoder'][int(self.resoSortieMpeg1.value)])
       return taillVidMpeg1Mencoder
       
    def get_desentrelacement_mencoder(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_mencoder_tous'][int(self.choixDesentrelacementMencoder.value)])
	return choixDesentrelacement
       
       
class Codec_Mpeg2(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_Mpeg2, self).__init__('codecmpeg2', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
	
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
        
        prop='taille_video_general_mencoder'
        params = self.liste_taille_generale_video
        self.resoSortieMpeg2 = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_mencoder_tous'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementMencoder = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
             
        self.grid.addWidget(self.label_5,12,2)
	self.grid.addWidget(self.resoSortieMpeg2.widget,13,2)
	self.grid.addWidget(self.label_10,14,2)
	self.grid.addWidget(self.choixDesentrelacementMencoder.widget,15,2)

    def get_taill_video_mpeg2_mencoder(self):
       taillVidMpeg2Mencoder = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_mencoder'][int(self.resoSortieMpeg2.value)])
       return taillVidMpeg2Mencoder
       
    def get_desentrelacement_mencoder(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_mencoder_tous'][int(self.choixDesentrelacementMencoder.value)])
	return choixDesentrelacement
       
       
class Codec_FLV(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_FLV, self).__init__('macromediaflashvideo', min_range_1=1,\
                                    max_range_1=100, min_range_2=10,
                                    max_range_2=5000,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
	
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
        
        prop='taille_video_general_mencoder'
        params = self.liste_taille_generale_video
        self.resoSortieFLV = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_mencoder_tous'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementMencoder = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
           
        self.grid.addWidget(self.label_5,12,2)
	self.grid.addWidget(self.resoSortieFLV.widget,13,2)
	self.grid.addWidget(self.label_10,14,2)
	self.grid.addWidget(self.choixDesentrelacementMencoder.widget,15,2)

    def get_taill_video_flv_mencoder(self):
       taillVidFlvMencoder = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_mencoder'][int(self.resoSortieFLV.value)])
       return taillVidFlvMencoder
       
    def get_desentrelacement_mencoder(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_mencoder_tous'][int(self.choixDesentrelacementMencoder.value)])
	return choixDesentrelacement
       
       
class Codec_WMV2(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_WMV2, self).__init__('codecwmv2', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
	
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
        
        prop='taille_video_general_mencoder'
        params = self.liste_taille_generale_video
        self.resoSortieWmv2 = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_mencoder_tous'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementMencoder = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
                
        self.grid.addWidget(self.label_5,12,2)
	self.grid.addWidget(self.resoSortieWmv2.widget,13,2)
	self.grid.addWidget(self.label_10,14,2)
	self.grid.addWidget(self.choixDesentrelacementMencoder.widget,15,2)

    def get_taill_video_wmv2_mencoder(self):
       taillVidWmv2Mencoder = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_mencoder'][int(self.resoSortieWmv2.value)])
       return taillVidWmv2Mencoder
       
    def get_desentrelacement_mencoder(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_mencoder_tous'][int(self.choixDesentrelacementMencoder.value)])
	return choixDesentrelacement
       

class Codec_H264_ext_mp4(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_H264_ext_mp4, self).__init__('codech264mpeg4_ffmpeg', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_1.hide()
	self.spinCompression.hide()
	self.curseur_1.hide()
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()

        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
        
        prop='taille_video_general_ffmpeg'
        params = self.liste_taille_generale_video
        self.resoSortieH264ExtMp4 = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_ffmpeg'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementFFmpeg = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
             
	self.grid.addWidget(self.label_5,12,2)
	self.grid.addWidget(self.resoSortieH264ExtMp4.widget,13,2)
	self.grid.addWidget(self.label_10,14,2)
	self.grid.addWidget(self.choixDesentrelacementFFmpeg.widget,15,2)

    def get_taill_video_h264_ext_mp4_ffmpeg(self):
       taillVidH264ExtMp4FFmpeg = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_ffmpeg'][int(self.resoSortieH264ExtMp4.value)])
       return taillVidH264ExtMp4FFmpeg
       
    def get_desentrelacement_ffmpeg(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_ffmpeg'][int(self.choixDesentrelacementFFmpeg.value)])
	return choixDesentrelacement
       
       
class Codec_H264_ext_h264(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_H264_ext_h264, self).__init__('codech264mpeg4_ext_h264', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_1.hide()
	self.spinCompression.hide()
	self.curseur_1.hide()
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
	
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
        
        prop='taille_video_general_mencoder'
        params = self.liste_taille_generale_video
        self.resoSortieH264ExtH264 = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_mencoder_particulier'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementMencoder = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
               
        self.grid.addWidget(self.label_5,12,2)
	self.grid.addWidget(self.resoSortieH264ExtH264.widget,13,2)
	self.grid.addWidget(self.label_10,14,2)
	self.grid.addWidget(self.choixDesentrelacementMencoder.widget,15,2)

    def get_taill_video_h264_ext_h264_mencoder(self):
       taillVidH264ExtH264Mencoder = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_mencoder'][int(self.resoSortieH264ExtH264.value)])
       return taillVidH264ExtH264Mencoder
       
    def get_desentrelacement_mencoder(self):
       choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_mencoder_particulier'][int(self.choixDesentrelacementMencoder.value)])
       return choixDesentrelacement	
       
       
class Codec_H263_Plus_ext_mp4(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_H263_Plus_ext_mp4, self).__init__('codech263p', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
	
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
        
        prop='taille_video_general_mencoder'
        params = self.liste_taille_generale_video
        self.resoSortieH263P = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_mencoder_tous'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementMencoder = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
                
        self.grid.addWidget(self.label_5,12,2)
	self.grid.addWidget(self.resoSortieH263P.widget,13,2)
	self.grid.addWidget(self.label_10,14,2)
	self.grid.addWidget(self.choixDesentrelacementMencoder.widget,15,2)

    def get_taill_video_h263_plus_mencoder(self):
       taillVidH263PMencoder = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_mencoder'][int(self.resoSortieH263P.value)])
       return taillVidH263PMencoder
       
    def get_desentrelacement_mencoder(self):
       choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_mencoder_tous'][int(self.choixDesentrelacementMencoder.value)])
       return choixDesentrelacement
       
       
class Codec_3GP(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_3GP, self).__init__('codec_3GP_ffmpeg', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
        self.label_1.hide()
        self.spinCompression.hide()
        self.curseur_1.hide()
        self.label_2.hide()
        self.spinBitrateVideo.hide()
        self.curseur_2.hide()
        self.label_4.hide()
        self.label_6.hide()
        self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
        self.label_3.show()
	
        ## On utilise EkdPropertie pour gérer le réglage du codec
        section=u"animation_encodage_general"
        self.prop='reso3gp'
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
        self.resoSortie3gp = EkdCodecPropertie( self.prop,
                                                EkdConfig.PROPERTIES[self.prop],
                                                allprops[self.prop],
                                                EkdConfig.CODEC_PROPERTIES[self.prop],
                                                section=section )
						
	prop='choix_desentrelacement_ffmpeg'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementFFmpeg = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
                          
        self.grid.addWidget(self.resoSortie3gp.widget,9,2)
	self.grid.addWidget(self.label_10,14,2) 
	self.grid.addWidget(self.choixDesentrelacementFFmpeg.widget,15,2) 

    def get(self):
       return EkdConfig.CODEC_PROPERTIES[self.prop][int(self.resoSortie3gp.value)]
       
    def get_desentrelacement_ffmpeg(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_ffmpeg'][int(self.choixDesentrelacementFFmpeg.value)])
	return choixDesentrelacement


class Codec_AMV(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_AMV, self).__init__('codec_AMV_ffmpeg', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_1.hide()
	self.spinCompression.hide()
	self.curseur_1.hide()
	self.label_2.hide()
	self.spinBitrateVideo.hide()
	self.curseur_2.hide()
	self.label_3.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
        self.label_4.show()
	
        ## On utilise EkdPropertie pour gérer le réglage du codec
        section=u"animation_encodage_general"
        self.prop='resoamv'
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
        self.resoSortieAMV = EkdCodecPropertie( self.prop,
                                                EkdConfig.PROPERTIES[self.prop],
                                                allprops[self.prop],
                                                EkdConfig.CODEC_PROPERTIES[self.prop],
                                                section=section )
						
	prop='choix_desentrelacement_ffmpeg'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementFFmpeg = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
                                                
        self.grid.addWidget(self.resoSortieAMV.widget,11,2)
	self.grid.addWidget(self.label_10,14,2) 
	self.grid.addWidget(self.choixDesentrelacementFFmpeg.widget,15,2)

    def get(self):
       return EkdConfig.CODEC_PROPERTIES[self.prop][int(self.resoSortieAMV.value)]
       
    def get_desentrelacement_ffmpeg(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_ffmpeg'][int(self.choixDesentrelacementFFmpeg.value)])
	return choixDesentrelacement
       
       
class Codec_ShockWave_Flash_SWF(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_ShockWave_Flash_SWF, self).__init__('codec_shockwave_swf_ffmpeg', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_1.show()
	self.curseur_1.show()
	self.label_2.hide()
	self.spinBitrateVideo.hide()
	self.curseur_2.hide()
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
	
        ## On utilise EkdPropertie pour gérer le réglage du codec
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
 
        prop='taille_video_general_ffmpeg'
        params = self.liste_taille_generale_video
        self.resoSortieGeneralFFmpeg = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_ffmpeg'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementFFmpeg = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
              
        self.grid.addWidget(self.label_5,12,2)
        self.grid.addWidget(self.resoSortieGeneralFFmpeg.widget,13,2)
	self.grid.addWidget(self.label_10,14,2) 
	self.grid.addWidget(self.choixDesentrelacementFFmpeg.widget,15,2)
        
    def get_taill_video_general_ffmpeg(self):
       taillVidGenFFmpeg = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_ffmpeg'][int(self.resoSortieGeneralFFmpeg.value)])
       return taillVidGenFFmpeg
       
    def get_desentrelacement_ffmpeg(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_ffmpeg'][int(self.choixDesentrelacementFFmpeg.value)])
	return choixDesentrelacement

       
class Codec_TransportStreamTS(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_TransportStreamTS, self).__init__('codec_transport_stream_ts_ffmpeg', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_1.show()
	self.curseur_1.show()
	self.label_2.hide()
	self.spinBitrateVideo.hide()
	self.curseur_2.hide()
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
	
        ## On utilise EkdPropertie pour gérer le réglage du codec
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
 
        prop='taille_video_general_ffmpeg'
        params = self.liste_taille_generale_video
        self.resoSortieGeneralFFmpeg = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_ffmpeg'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementFFmpeg = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
              
        self.grid.addWidget(self.label_5,12,2)
        self.grid.addWidget(self.resoSortieGeneralFFmpeg.widget,13,2)
	self.grid.addWidget(self.label_10,14,2) 
	self.grid.addWidget(self.choixDesentrelacementFFmpeg.widget,15,2)
        
    def get_taill_video_general_ffmpeg(self):
       taillVidGenFFmpeg = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_ffmpeg'][int(self.resoSortieGeneralFFmpeg.value)])
       return taillVidGenFFmpeg
       
    def get_desentrelacement_ffmpeg(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_ffmpeg'][int(self.choixDesentrelacementFFmpeg.value)])
	return choixDesentrelacement


class Codec_ProRes(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_ProRes, self).__init__('codec_pro_res_ffmpeg', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_1.hide()
	self.spinCompression.hide()
	self.curseur_1.hide()
	self.label_2.hide()
	self.spinBitrateVideo.hide()
	self.curseur_2.hide()
	self.label_3.hide()
	self.label_4.hide()
	self.label_6.hide()
	self.label_7.hide()
	self.label_8.hide()
	self.label_9.hide()
	
        ## On utilise EkdPropertie pour gérer le réglage du codec
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
 
        prop='taille_video_general_ffmpeg'
        params = self.liste_taille_generale_video
        self.resoSortieGeneralFFmpeg = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
						
	prop='choix_desentrelacement_ffmpeg'
        params = [_(u'Non'), _(u'Oui')]
        self.choixDesentrelacementFFmpeg = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
             
        self.grid.addWidget(self.label_5,12,2)
        self.grid.addWidget(self.resoSortieGeneralFFmpeg.widget,13,2)
	self.grid.addWidget(self.label_10,14,2) 
	self.grid.addWidget(self.choixDesentrelacementFFmpeg.widget,15,2)
        
    def get_taill_video_general_ffmpeg(self):
       taillVidGenFFmpeg = "{0}".format(EkdConfig.CODEC_PROPERTIES['taille_video_general_ffmpeg'][int(self.resoSortieGeneralFFmpeg.value)])
       return taillVidGenFFmpeg

    def get_desentrelacement_ffmpeg(self):
        choixDesentrelacement = "{0}".format(EkdConfig.CODEC_PROPERTIES['choix_desentrelacement_ffmpeg'][int(self.choixDesentrelacementFFmpeg.value)])
	return choixDesentrelacement
       
       
class Codec_DVD(Codecs_AvecReglages):
    """ Classe pour le codec présent ici (liste déroulante). Des appels sont faits dans l'itemStacked 
    correspondant dans l'init de Animation_Encodage_General. On récupère la sélection (choix de 
    l'utilisateur) dans la fonction appliquer. Utilisation de la config de EkdConfig.py (contenu de la
    balise animation_encodage_general, dans EkdConfig.PROPERTIES et dans EkdConfig.CODEC_PROPERTIES) """
    def __init__(self):
        super(Codec_DVD, self).__init__('codec_dvd_ffmpeg', min_range_1=1,\
                                    max_range_1=100, min_range_2=800,
                                    max_range_2=2800,
                                    txt1=_(u"Réglage de la compression : "),
                                    txt5=_(u"Réglage du bitrate vidéo : "))
	self.label_1.hide()
	self.spinCompression.hide()
	self.curseur_1.hide()
	self.label_2.hide()
	self.spinBitrateVideo.hide()
	self.curseur_2.hide()
	self.label_3.hide()
	self.label_4.hide()
	self.label_5.hide()
	self.label_6.hide()
	self.label_7.hide()
	## Désentrelacement
	self.label_10.hide()
	
        ### Ajout de deux EkdStylePropertie pour gérer modeCodecDVD et apparenceCodecDVD
        section=u"animation_encodage_general"
        allprops = EkdConfig.getAllProperties(EkdConfig.getConfigSection(section))
        
        prop='dvd_mode'
        params = [_(u'PAL'), _(u'NTSC')]
        self.modeCodecDVD = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
        prop='dvd_apparence'
        params =  [_(u'Pas de sélection'), _(u'4/3'), _(u'16/9')]
        self.apparenceCodecDVD = EkdCodecPropertie(prop,
                                                EkdConfig.PROPERTIES[prop],
                                                allprops[prop],
                                                params,
                                                section=section)
                                                
        self.grid.addWidget(self.modeCodecDVD.widget,12,2)
        self.grid.addWidget(self.apparenceCodecDVD.widget,14,2)
        
    def get_mode_dvd(self):
       mode_dvd = u"{0}".format(EkdConfig.CODEC_PROPERTIES['dvd_mode'][int(self.modeCodecDVD.value)])
       return mode_dvd

    def get_apparence_dvd(self):
       apparence_dvd= u"-aspect {0}".format(EkdConfig.CODEC_PROPERTIES['dvd_apparence'][int(self.apparenceCodecDVD.value)])
       if apparence_dvd == "-aspect ": return u""
       else: return apparence_dvd


class Animation_Encodage_General(Base_EncodageFiltre):
	# -------------------------------------------------------------------
	# Cadre accueillant les widgets de : Animation >> Encodage
	# -------------------------------------------------------------------

	def __init__(self):

		#=== Identifiant de la classe ===#
		self.idSection = "animation_encodage_general"
		
		# ------------------------------------------------------------------- #
		# Chemin des répertoires temporaires pour la gestion des fichiers
		# mod (extension .mod). Ce sont (apparemment) des fichiers mpeg avec
		# une extension .mod. Les fichiers en question ont juste besoin
		# d'être renommés avec une extension .mpg avant le traitement.
		# ------------------------------------------------------------------- #
		self.repTempEntree = EkdConfig.getTempDir() + os.sep
		# création des répertoires temporaires
		if os.path.isdir(self.repTempEntree) is False: os.makedirs(self.repTempEntree)	
        	# Chemin exact d'écriture pour le tampon des fichiers mod
        	self.repTempFichiersMod = self.repTempEntree+'transcodage'+os.sep+'fichiers_mod'+os.sep
		# Création du chemin
		if os.path.isdir(self.repTempFichiersMod) is False: os.makedirs(self.repTempFichiersMod)
		# Epuration/elimination des fichiers tampon contenus dans le rep tampon
		for toutRepTemp in glob.glob(self.repTempFichiersMod+'*.*'): os.remove(toutRepTemp)

		# -------------------------------------------------------------------
		# Widgets intégrés à la boîte de groupe "Réglage de sortie de l'encodage".
		# La boîte de combo définie ci-dessus 'sélectionne' ceux qui vont s'afficher
		# -> utilisation d'un stacked
		# -------------------------------------------------------------------

		# === Widgets associés au codecs: Copie (format original) - AVI-RAW Sans
		# Compression - Codec XVID - Qualite SVCD - Qualite DVD - Codec H264 MPEG 4

		# création de stacked pour les QWidget
		self.stacked=QStackedWidget()
		self.stacked.setSizePolicy(QSizePolicy(QSizePolicy.MinimumExpanding, QSizePolicy.Fixed))

		self.itemStacked_sansReglages=Codecs_SansReglages()
		# par défaut
		self.indexStacked_sansReglages=self.stacked.addWidget(self.itemStacked_sansReglages)
		
		# === Widgets associés aux codecs qui possèdent des réglages (itemStacked)
		self.itemStacked_AVI_RAW = Codec_AVI_RAW()
		self.itemStacked_HFYU = Codec_HFYU()
		self.itemStacked_JPEGsansPerte = Codec_JPEGsansPerte()
		self.itemStacked_FFv1 = Codec_FFv1()
		self.itemStacked_DIVX4 = Codec_DIVX4()
		self.itemStacked_XVID = Codec_XVID()
		self.itemStacked_MJPEG = Codec_MotionJPEG()
		self.itemStacked_WEBM = Codec_WEBM()
		self.itemStacked_MPEG1 = Codec_Mpeg1()
		self.itemStacked_MPEG2 = Codec_Mpeg2()
		self.itemStacked_TS = Codec_TransportStreamTS()
		self.itemStacked_WMV2 = Codec_WMV2()
		# Pas de liste déroulante pour le VOB donc non impacté par EkdConfig.PROPERTIES et EkdConfig.CODEC_PROPERTIES
		self.itemStacked_VOB=Codecs_AvecReglages('codec_vob_ffmpeg', min_range_1=1, max_range_1=100, min_range_2=800, max_range_2=2800, txt1=_(u"Réglage de la compression : "), txt5=_(u"Réglage du bitrate vidéo : "))
		self.itemStacked_swf = Codec_ShockWave_Flash_SWF()
		self.itemStacked_flash = Codec_FLV()
		# Pas de liste déroulante pour le Ogg Theora (.ogg) donc non impacté par EkdConfig.PROPERTIES et EkdConfig.CODEC_PROPERTIES
		self.itemStacked_oggTheora_ext_ogg=Codecs_AvecReglages('codecoggtheora_ext_ogg', min_range_1=0 , max_range_1=10, min_range_2=800, max_range_2=2800, txt1=_(u"Réglage de la compression : "), txt5=_(u"Réglage du bitrate vidéo : "))
		# Pas de liste déroulante pour le Ogg Theora (.ogv) donc non impacté par EkdConfig.PROPERTIES et EkdConfig.CODEC_PROPERTIES
		self.itemStacked_oggTheora_ext_ogm=Codecs_AvecReglages('codecoggtheora_ext_ogv', min_range_1=0 , max_range_1=10, min_range_2=800, max_range_2=2800, txt1=_(u"Réglage de la compression : "), txt5=_(u"Réglage du bitrate vidéo : "))
		# Pas de liste déroulante pour le Ogg Theora (.ogm) donc non impacté par EkdConfig.PROPERTIES et EkdConfig.CODEC_PROPERTIES
		self.itemStacked_oggTheora_ext_ogv=Codecs_AvecReglages('codecoggtheora_ext_ogm', min_range_1=0 , max_range_1=10, min_range_2=800, max_range_2=2800, txt1=_(u"Réglage de la compression : "), txt5=_(u"Réglage du bitrate vidéo : "))
		self.itemStacked_Matroska = Codec_MKV()
		self.itemStacked_mpeg4_h264 = Codec_H264_ext_mp4()
		self.itemStacked_mpeg4_h264_ext_h264 = Codec_H264_ext_h264()
		self.itemStacked_H263P_ext_mp4 = Codec_H263_Plus_ext_mp4()
		self.itemStacked_3GP = Codec_3GP()
		self.itemStacked_AMV = Codec_AMV()
		self.itemStacked_MOV = Codec_MOV()
		self.itemStacked_ProRes = Codec_ProRes()
		self.itemStacked_DVD = Codec_DVD()
		
		# === Widgets associés aux codecs qui possèdent des réglages (indexStacked)
		self.indexStacked_AVI_RAW=self.stacked.addWidget(self.itemStacked_AVI_RAW)
		self.indexStacked_HFYU=self.stacked.addWidget(self.itemStacked_HFYU)
		self.indexStacked_JPEGsansPerte=self.stacked.addWidget(self.itemStacked_JPEGsansPerte)
		self.indexStacked_FFv1=self.stacked.addWidget(self.itemStacked_FFv1)
		self.indexStacked_DIVX4=self.stacked.addWidget(self.itemStacked_DIVX4)
		self.indexStacked_XVID=self.stacked.addWidget(self.itemStacked_XVID)
		self.indexStacked_MJPEG=self.stacked.addWidget(self.itemStacked_MJPEG)
		self.indexStacked_MPEG1=self.stacked.addWidget(self.itemStacked_MPEG1)
		self.indexStacked_MPEG2=self.stacked.addWidget(self.itemStacked_MPEG2)
		self.indexStacked_TS=self.stacked.addWidget(self.itemStacked_TS)
		self.indexStacked_WMV2=self.stacked.addWidget(self.itemStacked_WMV2)
		self.indexStacked_VOB=self.stacked.addWidget(self.itemStacked_VOB)
		self.indexStacked_swf=self.stacked.addWidget(self.itemStacked_swf)
		self.indexStacked_flash=self.stacked.addWidget(self.itemStacked_flash)
		self.indexStacked_WEBM=self.stacked.addWidget(self.itemStacked_WEBM)
		self.indexStacked_oggTheora_ext_ogg=self.stacked.addWidget(self.itemStacked_oggTheora_ext_ogg)
		self.indexStacked_oggTheora_ext_ogm=self.stacked.addWidget(self.itemStacked_oggTheora_ext_ogm)
		self.indexStacked_oggTheora_ext_ogv=self.stacked.addWidget(self.itemStacked_oggTheora_ext_ogv)
		self.indexStacked_Matroska=self.stacked.addWidget(self.itemStacked_Matroska)
		self.indexStacked_mpeg4_h264=self.stacked.addWidget(self.itemStacked_mpeg4_h264)
		self.indexStacked_mpeg4_h264_ext_h264=self.stacked.addWidget(self.itemStacked_mpeg4_h264_ext_h264)
		self.indexStacked_H263P_ext_mp4=self.stacked.addWidget(self.itemStacked_H263P_ext_mp4)
		self.indexStacked_3GP=self.stacked.addWidget(self.itemStacked_3GP)
		self.indexStacked_AMV=self.stacked.addWidget(self.itemStacked_AMV)
		self.indexStacked_MOV=self.stacked.addWidget(self.itemStacked_MOV)
		self.indexStacked_ProRes=self.stacked.addWidget(self.itemStacked_ProRes)
		self.indexStacked_DVD=self.stacked.addWidget(self.itemStacked_DVD)

		#----------------------------------------------------------------------------------
		# Paramètres de la liste de combo: [(identifiant, nom entrée, index du stacked,
		# 	instance stacked, extension fichier sortie, valeur spin à récupérer?),...]
		#----------------------------------------------------------------------------------
		self.listeCombo =	[\
		('copie',		_(u'Copie (format original)'),		self.indexStacked_sansReglages,\
			self.itemStacked_sansReglages,	'',		0),\
		('codec_pro_res_ffmpeg',_(u'Apple ProRes 422 (.mov)'),	self.indexStacked_ProRes,\
			self.itemStacked_ProRes,	'.mov',		1),\
		('avirawsanscompression',_(u'AVI-RAW i420 (sans compression) (.avi)'),	self.indexStacked_AVI_RAW,\
			self.itemStacked_AVI_RAW,	'.avi',		1),\
		('codec_dv_ffmpeg',_(u'Codec DV (.dv)'),	self.indexStacked_sansReglages,\
			self.itemStacked_sansReglages,	'.dv',		0),\
		('codec_hfyu_ffmpeg',_(u'Codec HFYU: Huffman Lossless YUV (yuv422p) (.avi)'), self.indexStacked_HFYU,\
			self.itemStacked_HFYU,	        '.avi',		1),\
		('jpeg_sans_perte',    _(u'Codec JPEG sans perte (.avi)'),      self.indexStacked_JPEGsansPerte,\
			self.itemStacked_JPEGsansPerte,	        '.avi',		1),\
		('ffv1',               _(u'Codec FFV1 sans perte FFmpeg (.avi)'), self.indexStacked_FFv1,\
			self.itemStacked_FFv1,	        '.avi',		1),\
		('codec_mov_ffmpeg',_(u'Codec QuickTime MOV (.mov)'),	self.indexStacked_MOV,\
			self.itemStacked_MOV,	        '.mov',		1),\
		('codecmotionjpeg',	_(u'Codec Motion JPEG (.avi)'),		self.indexStacked_MJPEG,\
			self.itemStacked_MJPEG,		'.avi',		1),\
		('codec_dvd_ffmpeg',      _(u'Codec DVD (.mpg)'),	self.indexStacked_DVD,\
			self.itemStacked_DVD,	        '.mpg',		1),\
		('codec_webm_ffmpeg',	   	_(u'Codec WebM (.webm)'),	self.indexStacked_WEBM,\
			self.itemStacked_WEBM,		'.webm',		1),\
		('codecoggtheora_ext_ogg',	_(u'Codec OGG THEORA (.ogg)'),	self.indexStacked_oggTheora_ext_ogg,\
			self.itemStacked_oggTheora_ext_ogg,	'.ogg',		1),\
		('codecoggtheora_ext_ogv',	_(u'Codec OGG THEORA (.ogv)'),	self.indexStacked_oggTheora_ext_ogv,\
			self.itemStacked_oggTheora_ext_ogv,	'.ogv',		1),\
		('codecoggtheora_ext_ogm',	_(u'Codec OGG THEORA (.ogm)'),	self.indexStacked_oggTheora_ext_ogm,\
			self.itemStacked_oggTheora_ext_ogm,	'.ogm',		1),\
		('conteneur_mkv_ffmpeg',      _(u'Conteneur Matroska (.mkv)'),	self.indexStacked_Matroska,\
			self.itemStacked_Matroska,	        '.mkv',		1),\
		('codec_vob_ffmpeg',_(u'Codec VOB (DVD-Video stream MPEG-2) (.vob)'),	self.indexStacked_VOB,\
			self.itemStacked_VOB,	'.vob',		1),\
		('codecmpeg2',		_(u'Codec MPEG 2 (.mpg)'),		self.indexStacked_MPEG2,\
			self.itemStacked_MPEG2,		'.mpg',		1),\
		('codec_transport_stream_ts_ffmpeg', _(u'Codec Transport Stream (.ts)'), self.indexStacked_TS,\
			self.itemStacked_TS,		'.ts',		1),\
		('codech264mpeg4_ffmpeg',	_(u'Codec H264 MPEG 4 (.mp4)'),		self.indexStacked_mpeg4_h264,\
			self.itemStacked_mpeg4_h264,	'.mp4',		1),\
		('codech264mpeg4_ext_h264', _(u'Codec H264 MPEG 4 (.h264)'),	self.indexStacked_mpeg4_h264_ext_h264,\
			self.itemStacked_mpeg4_h264_ext_h264,	'.h264',	1),\
		('codech263p',          _(u'Codec H263 Plus (.mp4)'),	        self.indexStacked_H263P_ext_mp4,\
			self.itemStacked_H263P_ext_mp4,	'.mp4',	        1),\
		('codecxvid',		_(u'Codec XVID (.avi)'),		self.indexStacked_XVID,\
			self.itemStacked_XVID,	  '.avi',		1),\
		('codecdivx4',		_(u'Codec DIVX4 (.avi)'),		self.indexStacked_DIVX4,\
			self.itemStacked_DIVX4,		'.avi',		1),\
		('codecmpeg1',		_(u'Codec MPEG 1 (.mpg)'),		self.indexStacked_MPEG1,\
			self.itemStacked_MPEG1,		'.mpg',		1),\
		('codec_shockwave_swf_ffmpeg',_(u'ShockWave Flash (.swf)'),	self.indexStacked_swf,\
			self.itemStacked_swf,		'.swf',		1),\
		('macromediaflashvideo',_(u'Macromedia Flash Video (.flv)'),	self.indexStacked_flash,\
			self.itemStacked_flash,		'.flv',		1),\
		('codecwmv2',		_(u'Codec WMV2 (.wmv)'),		self.indexStacked_WMV2,\
			self.itemStacked_WMV2,		'.wmv',		1),\
		('codec_3GP_ffmpeg',_(u'Codec 3GP (3rd Generation Partnership Project) (.3gp)'), self.indexStacked_3GP,\
			self.itemStacked_3GP,	'.3gp',		1),\
		('codec_AMV_ffmpeg',		_(u'Codec AMV: pour lecteurs mp4 (.avi)'),  self.indexStacked_AMV,\
			self.itemStacked_AMV,		'.avi',		1),\
					]
		
		#---------------------------
		# Dérivation de la classe
		#---------------------------
		super(Animation_Encodage_General, self).__init__(_(u"Transcodage: Général"))



	def afficherAide(self):
		""" Boîte de dialogue de l'aide du cadre Animation > Encodage """
		
		super(Animation_Encodage_General,self).afficherAide(_(u"<p><b>Vous pouvez ici coder ou plutôt transcoder une vidéo d'un format vers un autre. Dans certains cas le transcodage permet de compresser la vidéo, c'est à dire d'en réduire le poids.</b></p><p>Dans l'onglet <b>'Vidéo(s) source'</b> cliquez sur le bouton <b>Ajouter</b>, une boîte de dialogue apparaît, sur la partie gauche sélectionnez le répertoire (au besoin dépliez les sous-répertoires), allez chercher la/les vidéo(s). Si vous voulez sélectionner plusieurs vidéos d'un coup, maintenez la touche <b>CTRL</b> (ou <b>SHIFT</b>) du clavier enfoncée (tout en sélectionnant vos vidéos), cliquez sur <b>Ajouter</b>.</p><p>Vous pouvez dès lors sélectionner une vidéo dans la liste et la visionner (par le bouton juste à la droite de cette liste), vous noterez que vous pouvez visionner la vidéo en quatre tiers, en seize neuvième ou avec les proportions d'origine de la vidéo (w;h). De même si vous le désirez, vous pouvez obtenir des informations complètes sur la vidéo sélectionnée, et ce par le bouton <b>'Infos'</b> (en bas).</p><p>Dans l'onglet <b>'Réglages'</b> sélectionnez le codec, et s'il le faut, changez le/les réglage(s) proposé(s).</p><p>Une fois tout ceci fait, cliquez sur le bouton <b>'Appliquer'</b>, sélectionnez le répertoire de sauvegarde, indiquez votre <b>'Nom de fichier'</b>, cliquez sur le bouton <b>'Enregistrer'</b> et attendez le temps de la conversion. A la fin cliquez sur le bouton <b>'Voir les informations d'encodage'</b> et fermez cette dernière fenêtre après avoir vu les informations en question.</p><p>Dans l'onglet <b>'Visionner vidéo'</b> vous pouvez visionner le résultat (avant la conversion) en sélectionnant <b>'vidéo(s) source(s)'</b>, après la conversion <b>'vidéo convertie'</b> ou bien encore les deux en même temps, en cliquant sur le bouton <b>'Comparateur de vidéos'</b>.</p><p>L'onglet <b>'Infos'</b> vous permet de voir les vidéos chargées (avec leurs chemins exacts) avant et après conversion.</p>"))


	def fenetreErreur(self):
		"""Fonction pour gérer les quelques fenêtres d'erreur"""
		
		index=self.combo.currentIndex()
		chemin = unicode(self.getFile())
		ext_chargee = os.path.splitext(chemin)[1]
		codec_reglage = self.listeCombo[index][1]
		
		messErrTranscod=QMessageBox(self)
		messErrTranscod.setText(_(u"<p>Il n'est pas possible de donner suite au traitement <b>en ayant chargé une vidéo avec extension: ") + unicode(ext_chargee) + _(u" et choisi: ") + unicode(codec_reglage) + _(u".</b></p><p><b>Veuillez choisir un autre codec dans la liste proposée.</b>"))
		messErrTranscod.setWindowTitle(_(u"Erreur"))
		messErrTranscod.setIcon(QMessageBox.Warning)
		messErrTranscod.exec_()
		return
		
		
	def messLectureMplayerVidGrdTailles(self):
		""" Fonction pour gérer le message d'information pour l'utilisateur, dans le
		cas des traitements en très haute définition (4K, 4K Cin, 2.7K et 2.7K Cin) """
	
		messMplayerVidGrdTail=QMessageBox(self)
		messMplayerVidGrdTail.setText(_(u"<p>Vous allez transcoder votre vidéo avec une très haute définition ...</p><p>A la fin du traitement, <b>il se peut que la vidéo ne puisse pas être lue dans l'onglet: Visionner vidéo et que vous ayez des messages d'erreur à répétition</b> (cela est du à la configuration de votre carte graphique en association à MPlayer, le lecteur d'EKD).</p><p><b>Si vous rencontrez ce problème, sachez que votre vidéo a bien été convertie mais ne pourra pas être lue par les lecteurs présents sur votre ordinateur.</b></p>"))
		messMplayerVidGrdTail.setWindowTitle(_(u"Avertissement"))
		messMplayerVidGrdTail.setIcon(QMessageBox.Information)
		messMplayerVidGrdTail.exec_()
		
		
	def fenetreTailleFichierTS(self):
		"""Fonction pour gérer l'info sur la taille sélectionnée lors du chargement d'une vidéo TS"""
		
		from moteur_modules_animation.mplayer import getParamVideo
		
		index=self.combo.currentIndex()
		chemin = unicode(self.getFile())
		ext_chargee = os.path.splitext(chemin)[1]
		codec_reglage = self.listeCombo[index][1]
		
		infos = {'Fichier':chemin}
		getParamVideo(chemin, ['ID_VIDEO_WIDTH', 'ID_VIDEO_HEIGHT'], infos)
		w = int(infos['ID_VIDEO_WIDTH'])
		h = int(infos['ID_VIDEO_HEIGHT'])
		
		messTailleFichierTS=QMessageBox(self)
		messTailleFichierTS.setText(_(u"<p>Vous avez chargé une vidéo avec extension: ") + unicode(ext_chargee) + _(u" et choisi: ") + unicode(codec_reglage) + _(u".</p><p><b>Le traitement se fera avec la taille de la vidéo chargée (c'est à dire ") + unicode(w) + u"x" + unicode(h) + u")" + _(u" et pas celle que vous avez choisi.</b>"))
		messTailleFichierTS.setWindowTitle(_(u"Taille de la vidéo"))
		messTailleFichierTS.setIcon(QMessageBox.Warning)
		messTailleFichierTS.exec_()
		return
	  
	  
	def aspectMencoder(self, taille_sortie_video):
		""" Utilisé pour la plupart des traitements par Mencoder. La correspondance 
		(les deux listes juste en dessous) doit être faite quant à la taille et l'aspect """
		
		# taille: [u'', u'-vf scale=3840:2160', u'-vf scale=4096:2160', u'-vf scale=4096:1716', u'-vf scale=3996:2160', u'-vf scale=2716:1524', 
		# u'-vf scale=2716:1440', u'-vf scale=2048:1080', u'-vf scale=2048:858', u'-vf scale=1998:1080', u'-vf scale=1920:1440', 
		# u'-vf scale=1920:1080', u'-vf scale=1280:720', u'-vf scale=960:540', u'-vf scale=854:480', u'-vf scale=1024:576', 
		# u'-vf scale=768:576', u'-vf scale=720:576', u'-vf scale=384:288', u'-vf scale=352:288', u'-vf scale=320:240', u'-vf scale=720:480', 
		# u'-vf scale=640:480', u'-vf scale=512:384', u'-vf scale=480:480', u'-vf scale=352:240', u'-vf scale=7680:4800', u'-vf scale=6400:4096', 
		# u'-vf scale=5120:4096', u'-vf scale=3840:2400', u'-vf scale=3200:2048', u'-vf scale=2560:2048', u'-vf scale=2560:1600', 
		# u'-vf scale=2048:1536', u'-vf scale=1920:1200', u'-vf scale=1600:1024', u'-vf scale=1366:768', u'-vf scale=1280:1024', 
		# u'-vf scale=1600:1200', u'-vf scale=1024:768', u'-vf scale=800:600', u'-vf scale=640:350', u'-vf scale=640:480', u'-vf scale=160:120',
		# u'-vf scale=800:480']
		#
		# aspect: [u'', u'-aspect 16:9', u'-aspect 1.8962962962962964', u'-aspect 2.386946386946387', u'-aspect 1.85', 
		# u'-aspect 1.7821522309711286', u'-aspect 1.886111111111111', u'-aspect 1.8962962962962964', 
		# u'-aspect 2.386946386946387', u'-aspect 1.85', u'-aspect 4:3', u'-aspect 16:9', u'-aspect 16:9', u'-aspect 16:9', 
		# u'-aspect 16:9', u'-aspect 16:9', u'-aspect 4:3', u'', u'-aspect 4:3', u'', u'-aspect 4:3', u'', u'-aspect 4:3', u'-aspect 4:3', 
		# u'', u'', u'', u'', u'', u'', u'', u'', u'', u'-aspect 4:3', u'', u'', u'-aspect 16:9', u'', u'-aspect 4:3', u'-aspect 4:3', u'-aspect 4:3', 
		# u'', u'-aspect 4:3', u'-aspect 4:3', u'-aspect 16:10']
		
		if taille_sortie_video == u'': aspect_mencoder = u''
		# Le 01/12/12, ajout des presets HD 4K (3840x2160), HD 4K Cin (4096x2160), HD 4K Cin (4096x1716), 
		# HD 4K Cin (3996x2160), HD 2.7K (2716x1524), HD 2.7K Cin (2716x1440), HD 2K Cin (2048x1080), 
		# HD 2K Cin (2048x858), HD 2K Cin (1998x1080), HD 1440P (4/3): 1920x1440, ...
		elif taille_sortie_video == u'-vf scale=3840:2160': aspect_mencoder = u'-aspect 16:9'
		elif taille_sortie_video == u'-vf scale=4096:2160': aspect_mencoder = u'-aspect 1.8962962962962964'
		elif taille_sortie_video == u'-vf scale=2716:1524': aspect_mencoder = u'-aspect 1.7821522309711286'
		elif taille_sortie_video == u'-vf scale=2716:1440': aspect_mencoder = u'-aspect 1.886111111111111'
		elif taille_sortie_video == u'-vf scale=1920:1440': aspect_mencoder = u'-aspect 4:3'
		elif taille_sortie_video == u'-vf scale=4096:1716': aspect_mencoder = u'-aspect 2.386946386946387'
		elif taille_sortie_video == u'-vf scale=3996:2160': aspect_mencoder = u'-aspect 1.85'
		elif taille_sortie_video == u'-vf scale=2048:1080': aspect_mencoder = u'-aspect 1.8962962962962964'
		elif taille_sortie_video == u'-vf scale=2048:858': aspect_mencoder = u'-aspect 2.386946386946387'
		elif taille_sortie_video == u'-vf scale=1998:1080': aspect_mencoder = u'-aspect 1.85'
		# ------------- 
		elif taille_sortie_video == u'-vf scale=1920:1080': aspect_mencoder = u'-aspect 16:9'
		elif taille_sortie_video == u'-vf scale=1280:720': aspect_mencoder = u'-aspect 16:9'
		elif taille_sortie_video == u'-vf scale=960:540': aspect_mencoder = u'-aspect 16:9'
		elif taille_sortie_video == u'-vf scale=854:480': aspect_mencoder = u'-aspect 16:9'
		elif taille_sortie_video == u'-vf scale=1024:576': aspect_mencoder = u'-aspect 16:9'
		elif taille_sortie_video == u'-vf scale=768:576': aspect_mencoder = u'-aspect 4:3'
		elif taille_sortie_video == u'-vf scale=720:576': aspect_mencoder = u''
		elif taille_sortie_video == u'-vf scale=384:288': aspect_mencoder = u'-aspect 4:3'
		elif taille_sortie_video == u'-vf scale=352:288': aspect_mencoder = u''
		elif taille_sortie_video == u'-vf scale=320:240': aspect_mencoder = u'-aspect 4:3'
		elif taille_sortie_video == u'-vf scale=720:480': aspect_mencoder = u''
		elif taille_sortie_video == u'-vf scale=640:480': aspect_mencoder = u'-aspect 4:3'
		elif taille_sortie_video == u'-vf scale=512:384': aspect_mencoder = u'-aspect 4:3'
		elif taille_sortie_video == u'-vf scale=480:480': aspect_mencoder = u''
		elif taille_sortie_video == u'-vf scale=352:240': aspect_mencoder = u''
		elif taille_sortie_video == u'-vf scale=7680:4800': aspect_mencoder = u''
		elif taille_sortie_video == u'-vf scale=6400:4096': aspect_mencoder = u''
		elif taille_sortie_video == u'-vf scale=5120:4096': aspect_mencoder = u''
		elif taille_sortie_video == u'-vf scale=3840:2400': aspect_mencoder = u''
		elif taille_sortie_video == u'-vf scale=3200:2048': aspect_mencoder = u''
		elif taille_sortie_video == u'-vf scale=2560:2048': aspect_mencoder = u''
		elif taille_sortie_video == u'-vf scale=2560:1600': aspect_mencoder = u''
		elif taille_sortie_video == u'-vf scale=2048:1536': aspect_mencoder = u'-aspect 4:3',
		elif taille_sortie_video == u'-vf scale=1920:1200': aspect_mencoder = u''
		elif taille_sortie_video == u'-vf scale=1600:1024': aspect_mencoder = u''
		elif taille_sortie_video == u'-vf scale=1366:768': aspect_mencoder = u'-aspect 16:9'
		elif taille_sortie_video == u'-vf scale=1280:1024': aspect_mencoder = u''
		elif taille_sortie_video == u'-vf scale=1600:1200': aspect_mencoder = u'-aspect 4:3'
		elif taille_sortie_video == u'-vf scale=1024:768': aspect_mencoder = u'-aspect 4:3'
		elif taille_sortie_video == u'-vf scale=800:600': aspect_mencoder = u'-aspect 4:3'
		elif taille_sortie_video == u'-vf scale=640:350': aspect_mencoder = u''
		elif taille_sortie_video == u'-vf scale=640:480': aspect_mencoder = u'-aspect 4:3'
		elif taille_sortie_video == u'-vf scale=160:120': aspect_mencoder = u'-aspect 4:3'
		elif taille_sortie_video == u'-vf scale=800:480': aspect_mencoder = u'-aspect 16:10'
		
		return aspect_mencoder
		

	def desentrelacementParticulierMencoder(self, taille_sortie_video, desentrelacement):
		""" Cas particuliers pour le réglage de la taille de la vidéo et du désentrelacement """
		
		# Le désentrelacement est à gérer dans les fichiers: moteur_modules_common/EkdConfig.py et
		# gui_modules_animation/animation_encodage_general.py (ici)
		
		# Si l'utilisateur sélectionne: Pas de changement (vidéo avec la même taille que l'original) et s'il choisit  
		# en même temps: Oui pour le Désentrelacement, la valeur du désentrelacement doit être forcée. Cela  
		# n'est pas affecté quand l'utilisateur choisit une des .
		if taille_sortie_video == u'' and desentrelacement == u",yadif=0":
			desentrelacement_final = u"-vf yadif=0"
			return desentrelacement_final
		# Si l'utilisateur sélectionne d'autres entrées de la liste: Dimensions de la vidéo, 
		# la syntaxe Mencoder pour le désentrelacement reste celle d'origine.
		else: 
			desentrelacement_final = desentrelacement
			return desentrelacement_final


	def appliquer(self, nomSortie=None, ouvert=1):
		""" Appel du moteur de ekd -> encodage """

		if not nomSortie:
			index=self.combo.currentIndex()
			chemin = unicode(self.getFile())

			# suffix du codec actif
			suffix=self.listeCombo[index][4]
			if suffix=='':
				suffix=os.path.splitext(chemin)[1]
				
			ext_chargee = os.path.splitext(chemin)[1]
			codec_reglage = self.listeCombo[index][1]
			
			# ------------------------------------------------------------------- #
			# Gestion des fichiers mod (extension .mod). Ce sont (apparemment)
			# des fichiers mpeg avec une extension .mod. Les fichiers en question 
			# ont juste besoin d'être renommés avec une extension .mpg avant le 
			# traitement.
			# ------------------------------------------------------------------- #
			nom_fich_sans_ext = os.path.splitext(os.path.basename(chemin))[0]
			if ext_chargee in ['.mod', '.MOD']:
				# Copie du fichier concerné dans le rep tampon et renommage avec ext .mpg
				shutil.copy(chemin, self.repTempFichiersMod+nom_fich_sans_ext + '.mpg')
				chemin = unicode(self.repTempFichiersMod + nom_fich_sans_ext + '.mpg')

                        saveDialog = EkdSaveDialog(self, mode="video", suffix=suffix, title=_(u"Sauver"))
			cheminFichierEnregistrerVideo = saveDialog.getFile()

		else: # module séquentiel
			chemin=cheminFichierEnregistrerVideo=nomSortie

		if not cheminFichierEnregistrerVideo:
			return

		# quel est l'index du dernier item sélectionné de la boîte de combo?
		i=self.combo.currentIndex()
		# identifiant du codec actif
		idCodec=str(self.combo.itemData(i).toStringList()[0]) # méthode de QVariant

		# pas de spin pour Copie (format original) - AVI-RAW Sans Compression
		# Codec XVID - Qualite SVCD - Qualite DVD - Codec H264 MPEG 4
		spin=None # par défaut

		for j in self.listeCombo: # attribution de la valeur du spin s'il existe
			if j[0]==idCodec and j[5]==1:
				if j[0] in ['codecmotionjpeg', 'codecmpeg2', 'codech264mpeg4_ffmpeg', 'codech264mpeg4_ext_h264', 'codecdivx4', 'codecmpeg1', 'macromediaflashvideo', 'codecwmv2', 'codech263p']:
					# La valeur de compression vidéo va de 31 à 1 (31 --> mauvaise qualité
					# jusqu'à à 1 --> très bonne qualité). Ici on va calculer en mettant
					# en place un réglage qui partira de 1 à 100 (1 --> mauvaise qualité
					# et 100 --> très bonne qualité)
					calculValComp = (31 * j[3].spinCompression.value()) / 100
					# Il faut soustraire le résultat à 31 pour
					# avoir une valeur reconnue par Mencoder
					calculValComp = 31 - calculValComp
					# Si la la valeur de réglage de la compression est réglée sur 100,
					# on passe la syntaxe de la compression directement ici. Quand
					# l'utilisateur règle à 100, vqmin est enlevé, au contraire si
					# l'utilisateur règle à 81 (par exemple), vqmin aura pour valeur 6
					if j[3].spinCompression.value() == 100: calculValComp = ''
					else: calculValComp = ':vqmin='+str(calculValComp)
					# Récup des valeurs de la dimension de la vidéo dans la liste déroulante
					taillVideoDIVX4Mencoder = self.itemStacked_DIVX4.get_taill_video_divx4_mencoder()
					taillVideoMotionJPEGMencoder = self.itemStacked_MJPEG.get_taill_video_motion_jpeg_mencoder()
					taillVideoMpeg1Mencoder = self.itemStacked_MPEG1.get_taill_video_mpeg1_mencoder()
					taillVideoMpeg2Mencoder = self.itemStacked_MPEG2.get_taill_video_mpeg2_mencoder()
					taillVideoFLVMencoder = self.itemStacked_flash.get_taill_video_flv_mencoder()
					taillVideoWMV2Mencoder = self.itemStacked_WMV2.get_taill_video_wmv2_mencoder()
					taillVideoH264ExtMp4FFmpeg = self.itemStacked_mpeg4_h264.get_taill_video_h264_ext_mp4_ffmpeg()
					taillVideoH264ExtH264Mencoder = self.itemStacked_mpeg4_h264_ext_h264.get_taill_video_h264_ext_h264_mencoder()
					taillVideoH263PExtMp4Mencoder = self.itemStacked_H263P_ext_mp4.get_taill_video_h263_plus_mencoder()
					# Récup du désentrelacement 
					choixDesentDIVX4Mencoder = self.itemStacked_DIVX4.get_desentrelacement_mencoder()
					choixDesentMotionJPEGMencoder = self.itemStacked_MJPEG.get_desentrelacement_mencoder()
					choixDesentMpeg1Mencoder = self.itemStacked_MPEG1.get_desentrelacement_mencoder()
					choixDesentMpeg2Mencoder = self.itemStacked_MPEG2.get_desentrelacement_mencoder()
					choixDesentFLVMencoder = self.itemStacked_flash.get_desentrelacement_mencoder()
					choixDesentWMV2Mencoder = self.itemStacked_WMV2.get_desentrelacement_mencoder()
					choixDesentH264ExtH264Mencoder = self.itemStacked_mpeg4_h264_ext_h264.get_desentrelacement_mencoder()
					choixDesentH264ExtMp4FFmpeg = self.itemStacked_mpeg4_h264.get_desentrelacement_ffmpeg()
					choixDesentH263PExtMp4Mencoder = self.itemStacked_H263P_ext_mp4.get_desentrelacement_mencoder()
					# Récup de l'aspect (par la fonction aspectMencoder)
					aspectDIVX4Mencoder = self.aspectMencoder(taillVideoDIVX4Mencoder)
					aspectMotionJPEGMencoder = self.aspectMencoder(taillVideoMotionJPEGMencoder)
					aspectMpeg1Mencoder = self.aspectMencoder(taillVideoMpeg1Mencoder)
					aspectMpeg2Mencoder = self.aspectMencoder(taillVideoMpeg2Mencoder)
					aspectFLVMencoder = self.aspectMencoder(taillVideoFLVMencoder)
					aspectWMV2Mencoder = self.aspectMencoder(taillVideoWMV2Mencoder)
					aspectH264ExtH264Mencoder = self.aspectMencoder(taillVideoH264ExtH264Mencoder)
					aspectH263PExtMp4Mencoder = self.aspectMencoder(taillVideoH263PExtMp4Mencoder)
					# Pas de récup de l'aspect pour le H264 Mpeg4 extension mp4 car géré par FFmpeg (et aspect est inclus dans la commande FFmpeg)
					#
					# Cas particuliers pour le réglage de la taille de la vidéo et du désentrelacement (appels de la fonction: desentrelacementParticulierMencoder)
					choixDesentDIVX4Mencoder = self.desentrelacementParticulierMencoder(taillVideoDIVX4Mencoder, choixDesentDIVX4Mencoder)
					choixDesentMotionJPEGMencoder = self.desentrelacementParticulierMencoder(taillVideoMotionJPEGMencoder, choixDesentMotionJPEGMencoder)
					choixDesentMpeg1Mencoder = self.desentrelacementParticulierMencoder(taillVideoMpeg1Mencoder, choixDesentMpeg1Mencoder)
					choixDesentMpeg2Mencoder = self.desentrelacementParticulierMencoder(taillVideoMpeg2Mencoder, choixDesentMpeg2Mencoder)
					choixDesentFLVMencoder = self.desentrelacementParticulierMencoder(taillVideoFLVMencoder, choixDesentFLVMencoder)
					choixDesentWMV2Mencoder = self.desentrelacementParticulierMencoder(taillVideoWMV2Mencoder, choixDesentWMV2Mencoder)
					# Pas de choix de désentrelacement particulier pour le H264 Mpeg extension h264 (cas particulier traitement Mencoder)
					choixDesentH263PExtMp4Mencoder = self.desentrelacementParticulierMencoder(taillVideoH263PExtMp4Mencoder, choixDesentH263PExtMp4Mencoder)
					# La valeur est sous forme de tuple et contient au moins 2 valeurs
					# Attention, de puis le 18/09/2012, codech264mpeg4 est géré par FFmpeg et la valeur du bitrate doit être multiplié 
					# par 1000 (en quelque sorte pour avoir l'équivalence tout en gardant visuellement le même style de réglage entre 
					# les traitements venant de mencoder et ceux venant de ffmpeg).
					# ---------------------- #
					# Attention si le traitement se fait à partir d'une vidéo TS, le traitement fait avec 
					# Mencoder ne pourra pas redimensiooner la vidéo, la valeur de la future taille de
					# la vidéo sera donc vide (sauf pour le MPEG 4 H264 (.mp4))
					if ext_chargee == '.ts':
						if j[0] == 'codecdivx4': 
							self.fenetreTailleFichierTS()
							spin = (str(j[3].spinBitrateVideo.value()), str(calculValComp), '', str(choixDesentDIVX4Mencoder), '')
						elif j[0] == 'codecmotionjpeg': 
							self.fenetreTailleFichierTS()
							spin = (str(j[3].spinBitrateVideo.value()), str(calculValComp), '', str(choixDesentMotionJPEGMencoder), '')
						elif j[0] == 'codecmpeg1': 
							self.fenetreTailleFichierTS()
							spin = (str(j[3].spinBitrateVideo.value()), str(calculValComp), '', str(choixDesentMpeg1Mencoder), '')
						elif j[0] == 'codecmpeg2': 
							self.fenetreTailleFichierTS()
							spin = (str(j[3].spinBitrateVideo.value()), str(calculValComp), '', str(choixDesentMpeg2Mencoder), '')
						elif j[0] == 'macromediaflashvideo': 
							self.fenetreTailleFichierTS()
							spin = (str(j[3].spinBitrateVideo.value()), str(calculValComp), '', str(choixDesentFLVMencoder), '')
						elif j[0] == 'codecwmv2': 
							self.fenetreTailleFichierTS()
							spin = (str(j[3].spinBitrateVideo.value()), str(calculValComp), '', str(choixDesentWMV2Mencoder), '')
						elif j[0] == 'codech264mpeg4_ffmpeg': 
							# Là pas de problème avec le redimensionnement des vidéos TS
							spin = (str(j[3].spinBitrateVideo.value()*1000), str(calculValComp), str(taillVideoH264ExtMp4FFmpeg), str(choixDesentH264ExtMp4FFmpeg))
						elif j[0] == 'codech263p': 
							self.fenetreTailleFichierTS()
							spin = (str(j[3].spinBitrateVideo.value()), str(calculValComp), '', str(taillVideoH263PExtMp4Mencoder), '')
					# Si le traitement se fait à partir d'une autre vidéo que TS ...
					else:
						if j[0] == 'codecdivx4': spin = (str(j[3].spinBitrateVideo.value()), str(calculValComp), str(taillVideoDIVX4Mencoder), str(choixDesentDIVX4Mencoder), str(aspectDIVX4Mencoder))
						elif j[0] == 'codecmotionjpeg': spin = (str(j[3].spinBitrateVideo.value()), str(calculValComp), str(taillVideoMotionJPEGMencoder), str(choixDesentMotionJPEGMencoder), str(aspectMotionJPEGMencoder))
						elif j[0] == 'codecmpeg1': spin = (str(j[3].spinBitrateVideo.value()), str(calculValComp), str(taillVideoMpeg1Mencoder), str(choixDesentMpeg1Mencoder), str(aspectMpeg1Mencoder ))
						elif j[0] == 'codecmpeg2': spin = (str(j[3].spinBitrateVideo.value()), str(calculValComp), str(taillVideoMpeg2Mencoder), str(choixDesentMpeg2Mencoder), str(aspectMpeg2Mencoder ))
						elif j[0] == 'macromediaflashvideo': spin = (str(j[3].spinBitrateVideo.value()), str(calculValComp), str(taillVideoFLVMencoder), str(choixDesentFLVMencoder), str(aspectFLVMencoder))
						elif j[0] == 'codecwmv2': spin = (str(j[3].spinBitrateVideo.value()), str(calculValComp), str(taillVideoWMV2Mencoder), str(choixDesentWMV2Mencoder), str(aspectWMV2Mencoder))
						elif j[0] == 'codech264mpeg4_ffmpeg': spin = (str(j[3].spinBitrateVideo.value()*1000), str(calculValComp), str(taillVideoH264ExtMp4FFmpeg), str(choixDesentH264ExtMp4FFmpeg))
						elif j[0] == 'codech264mpeg4_ext_h264': spin = (str(j[3].spinBitrateVideo.value()), str(calculValComp), str(taillVideoH264ExtH264Mencoder), str(choixDesentH264ExtH264Mencoder), str(aspectH264ExtH264Mencoder))
						elif j[0] == 'codech263p': spin = (str(j[3].spinBitrateVideo.value()), str(calculValComp), str(taillVideoH263PExtMp4Mencoder), str(choixDesentH263PExtMp4Mencoder), str(aspectH263PExtMp4Mencoder))
					# Affichage de la boîte de dialogue d'information dans le cas des choix en très haite définition avec les presets:  
					# HD 4K (3840x2160), HD 4K Cin (4096x2160), HD 4K Cin (4096x1716),  HD 4K Cin (3996x2160), 
					# HD 2.7K (2716x1524), HD 2.7K Cin (2716x1440) (pour la taille de la vidéo en sortie)  ... et les autres presets de 
					# taille supérieurs à 2046x2046
					if spin[2] in [u'-vf scale=3840:2160', u'-vf scale=4096:2160', u'-vf scale=4096:1716', \
					    u'-vf scale=3996:2160', u'-vf scale=2716:1524', u'-vf scale=2716:1440', u'-vf scale=7680:4800', \
					    u'-vf scale=6400:4096', u'-vf scale=5120:4096', u'-vf scale=3840:2400', u'-vf scale=3200:2048', \
					    u'-vf scale=2560:2048', u'-vf scale=2560:1600', u'-vf scale=2048:1536']:
						    self.messLectureMplayerVidGrdTailles()
					
				elif j[0] in ['conteneur_mkv_ffmpeg']:
					# La valeur de compression vidéo va de 31 à 1 (31 --> mauvaise qualité
					# jusqu'à à 1 --> très bonne qualité). Ici on va calculer en mettant
					# en place un réglage qui partira de 1 à 100 (1 --> mauvaise qualité
					# et 100 --> très bonne qualité)
					calculValComp = (31 * j[3].spinCompression.value()) / 100
					# Il faut soustraire le résultat à 31 pour
					# avoir une valeur reconnue par Mencoder
					calculValComp = 31 - calculValComp
					# Si la la valeur de réglage de la compression est réglée sur 100,
					# on passe la syntaxe de la compression directement ici. Quand
					# l'utilisateur règle à 100, on passe à la commande '-sameq' à FFmpeg
					if j[3].spinCompression.value() == 100: calculValComp = '-qscale 0'
					else: calculValComp = '-q:v '+str(calculValComp)
					# Sélection du format vidéo (preset)
					sousCodecMkvVideo = self.itemStacked_Matroska.get_video()
					# Sélection du format audio (preset)
					sousCodecMkvAudio = self.itemStacked_Matroska.get_audio()
					# Récup de la valeur de la dimension de la vidéo dans la liste déroulante
					taillVideoGeneralFFmpeg = self.itemStacked_Matroska.get_taill_video_general_ffmpeg()
					# Récup du désentrelacement
					desentMatroska = self.itemStacked_Matroska.get_desentrelacement_ffmpeg()
					# La valeur est sous forme de tuple et contient au moins 5 valeurs
					self.valeursMKV = (str(sousCodecMkvVideo), str(sousCodecMkvAudio), str(calculValComp), str(taillVideoGeneralFFmpeg), str(desentMatroska))
					# Affichage de la boîte de dialogue d'information dans le cas des choix en très haite définition avec les presets:  
					# HD 4K (3840x2160), HD 4K Cin (4096x2160), HD 4K Cin (4096x1716),  HD 4K Cin (3996x2160), 
					# HD 2.7K (2716x1524), HD 2.7K Cin (2716x1440) (pour la taille de la vidéo en sortie) ... et les autres presets de 
					# taille supérieurs à 2046x2046
					if taillVideoGeneralFFmpeg in [u'-s 3840x2160 -aspect 16:9', u'-s 4096x2160 -aspect 1.8962962962962964', u'-s 4096x1716 -aspect 2.386946386946387', \
					    u'-s 3996x2160 -aspect 1.85', u'-s 2716x1524 -aspect 1.7821522309711286',  u'-s 2716x1440 -aspect 1.886111111111111', \
					    u'-s 7680x4800', u'-s 6400x4096', u'-s 5120x4096', u'-s 3840x2400', u'-s 3200x2048', u'-s 2560x2048', u'-s 2560x1600',  u'-s 2048x1536']: 
						    self.messLectureMplayerVidGrdTailles()

				elif j[0] in ['codec_vob_ffmpeg']:
					# La valeur de compression vidéo va de 255 à 1 (255 --> mauvaise qualité
					# jusqu'à 1 --> très bonne qualité). Ici on va calculer en mettant
					# en place un réglage qui partira de 1 à 100 (1 --> mauvaise qualité
					# et 100 --> très bonne qualité)
					calculValComp = (255 * j[3].spinCompression.value()) / 100
					# Il faut soustraire le résultat à 255 pour
					# avoir une valeur reconnue par Mencoder
					calculValComp = 255 - calculValComp
					# Si la la valeur de réglage de la compression est réglée sur 100,
					# on passe la syntaxe de la compression directement ici. Quand
					# l'utilisateur règle à 100, on passe à la commande '-sameq' à FFmpeg
					if j[3].spinCompression.value() == 100: spin = '-qscale 0'
					else: spin = '-q:v '+str(calculValComp)
					
				elif j[0] in ['codec_3GP_ffmpeg']:
					# On affecte la valeur de la résolution pour le 3GP
					# sélectionnée par l'utilisateur
					valeurSize3GP = self.itemStacked_3GP.get()
					# Récup du désentrelacement
					desent3GP = self.itemStacked_3GP.get_desentrelacement_ffmpeg()
					# Taille vidéo + Désentrelacement
					self.valeurs3GP = (str(valeurSize3GP), str(desent3GP))
	
				elif j[0] in ['codec_AMV_ffmpeg']:
					# On affecte la valeur de la résolution pour l'AMV
					# sélectionnée par l'utilisateur
					valeurSizeAMV = self.itemStacked_AMV.get()
					# Récup du désentrelacement
					desentAMV = self.itemStacked_AMV.get_desentrelacement_ffmpeg()
					# Taille vidéo + Désentrelacement
					self.valeursAMV = (str(valeurSizeAMV), str(desentAMV))
					
				elif j[0] in ['codec_mov_ffmpeg', 'codec_shockwave_swf_ffmpeg', 'codec_transport_stream_ts_ffmpeg']: 
					# La valeur de compression vidéo va de 31 à 1 (31 --> mauvaise qualité
					# jusqu'à à 1 --> très bonne qualité). Ici on va calculer en mettant
					# en place un réglage qui partira de 1 à 100 (1 --> mauvaise qualité
					# et 100 --> très bonne qualité)
					calculValComp = (31 * j[3].spinCompression.value()) / 100
					# Il faut soustraire le résultat à 31 pour
					# avoir une valeur reconnue par Mencoder
					calculValComp = 31 - calculValComp
					# Si la la valeur de réglage de la compression est réglée sur 100,
					# on passe la syntaxe de la compression directement ici. Quand
					# l'utilisateur règle à 100, on passe à la commande '-sameq' à FFmpeg
					if j[3].spinCompression.value() == 100: calculValComp = '-qscale 0'
					else: calculValComp = '-q:v '+str(calculValComp)
					# Récup de la valeur de la dimension de la vidéo dans la liste déroulante
					taillVideoMovFFmpeg = self.itemStacked_MOV.get_taill_video_general_ffmpeg()
					taillVideoShockWaveFFmpeg = self.itemStacked_swf.get_taill_video_general_ffmpeg()
					taillVideoTransportStreamFFmpeg = self.itemStacked_TS.get_taill_video_general_ffmpeg()
					# Récup du désentrelacement
					desentMOV = self.itemStacked_MOV.get_desentrelacement_ffmpeg()
					desentSWF = self.itemStacked_swf.get_desentrelacement_ffmpeg()
					desentTS = self.itemStacked_TS.get_desentrelacement_ffmpeg()
					# Affichage de la boîte de dialogue d'information dans le cas des choix en très haite définition avec les presets:  
					# HD 4K (3840x2160), HD 4K Cin (4096x2160), HD 4K Cin (4096x1716),  HD 4K Cin (3996x2160), 
					# HD 2.7K (2716x1524), HD 2.7K Cin (2716x1440) (pour la taille de la vidéo en sortie) ... et les autres presets de 
					# taille supérieurs à 2046x2046
					if j[0] == 'codec_mov_ffmpeg': taille_v = taillVideoMovFFmpeg
					elif j[0] == 'codec_shockwave_swf_ffmpeg': taille_v = taillVideoShockWaveFFmpeg
					elif j[0] == 'codec_transport_stream_ts_ffmpeg': taille_v = taillVideoTransportStreamFFmpeg
					if taille_v in [u'-s 3840x2160 -aspect 16:9', u'-s 4096x2160 -aspect 1.8962962962962964', u'-s 4096x1716 -aspect 2.386946386946387', \
					    u'-s 3996x2160 -aspect 1.85', u'-s 2716x1524 -aspect 1.7821522309711286',  u'-s 2716x1440 -aspect 1.886111111111111', \
					    u'-s 7680x4800', u'-s 6400x4096', u'-s 5120x4096', u'-s 3840x2400', u'-s 3200x2048', u'-s 2560x2048', u'-s 2560x1600', u'-s 2048x1536']: 
						    self.messLectureMplayerVidGrdTailles()
					# La valeur est sous forme de tuple et contient au moins 3 valeurs
					if j[0] == 'codec_mov_ffmpeg':
						# Compression + Taille vidéo + Désentrelacement
						self.valeursMOV = (str(calculValComp), str(taillVideoMovFFmpeg), str(desentMOV))
					elif j[0] == 'codec_shockwave_swf_ffmpeg':
						# Compression + Taille vidéo + Désentrelacement
						self.valeursShockWave = (str(calculValComp), str(taillVideoShockWaveFFmpeg), str(desentSWF))
					elif j[0] == 'codec_transport_stream_ts_ffmpeg':
						# Compression + Taille vidéo + Désentrelacement
						self.valeursTS = (str(calculValComp), str(taillVideoTransportStreamFFmpeg), str(desentTS))
						
				elif j[0] in ['codec_pro_res_ffmpeg']:
					# Récup de la valeur de la dimension de la vidéo dans la liste déroulante
					taillVideoProResFFmpeg = str(self.itemStacked_ProRes.get_taill_video_general_ffmpeg())
					self.valeurSizeProRes = str(taillVideoProResFFmpeg)
					# Récup du désentrelacement
					desentProRes = self.itemStacked_ProRes.get_desentrelacement_ffmpeg()
					# Taille vidéo + Désentrelacement
					self.valeursProRes = (str(taillVideoProResFFmpeg), str(desentProRes))
					# Affichage de la boîte de dialogue d'information dans le cas des choix en très haite définition avec les presets:  
					# HD 4K (3840x2160), HD 4K Cin (4096x2160), HD 4K Cin (4096x1716),  HD 4K Cin (3996x2160), 
					# HD 2.7K (2716x1524), HD 2.7K Cin (2716x1440) (pour la taille de la vidéo en sortie)  ... et les autres presets de 
					# taille supérieurs à 2046x2046
					if taillVideoProResFFmpeg in [u'-s 3840x2160 -aspect 16:9', u'-s 4096x2160 -aspect 1.8962962962962964', u'-s 4096x1716 -aspect 2.386946386946387', \
					    u'-s 3996x2160 -aspect 1.85', u'-s 2716x1524 -aspect 1.7821522309711286',  u'-s 2716x1440 -aspect 1.886111111111111', \
					    u'-s 7680x4800', u'-s 6400x4096', u'-s 5120x4096', u'-s 3840x2400', u'-s 3200x2048', u'-s 2560x2048', u'-s 2560x1600', u'-s 2048x1536']: 
						    self.messLectureMplayerVidGrdTailles()
					# L'utilisateur est prévenu par une boîte de dialogue que la vidéo (une fois transcodée) ne
					# sera pas lue corrextement par certains lecteurs ... et ce en ce qui concerne le ProRes
					ok = QMessageBox.information(self, _(u"Information"), _(u"<p>Vous êtes sur le point de transcoder votre/vos vidéo(s) en Apple ProRes, <b>sachez qu'une fois l'opération terminée, vous pourrez visionner sans aucun souci la/les vidéo(s) avec les lecteurs suivants: MPlayer, SMPlayer, mais elles ne seront pas lues correctement par certaines versions de VLC ; en effet des artefacts (distorsions visuelles) pourraient apparaître sur la/les vidéo(s)</b>.</p>"), QMessageBox.Ok)
					
				elif j[0] in ['avirawsanscompression']:
					# Récup de la valeur de désentrelacement
					desentAVI_RAW = self.itemStacked_AVI_RAW.get_desentrelacement_mencoder()
					if ext_chargee == '.ts': 
						self.fenetreTailleFichierTS()
						# Taiile vidéo (ici rien) + Désentrelacement
						self.valeursAVI_RAW = ('', str(desentAVI_RAW))
					else:
						# Récup de la valeur de la dimension de la vidéo dans la liste déroulante
						taillVideoAviRawMencoder = self.itemStacked_AVI_RAW.get_taill_video_avi_raw_mencoder()
						# Taiile vidéo + Désentrelacement
						self.valeursAVI_RAW = (str(taillVideoAviRawMencoder), str(desentAVI_RAW))
						# Affichage de la boîte de dialogue d'information dans le cas des choix en très haite définition avec les presets:  
						# HD 4K (3840x2160), HD 4K Cin (4096x2160), HD 4K Cin (4096x1716),  HD 4K Cin (3996x2160), 
						# HD 2.7K (2716x1524), HD 2.7K Cin (2716x1440) (pour la taille de la vidéo en sortie)  ... et les autres presets de 
						# taille supérieurs à 2046x2046
						if taillVideoAviRawMencoder in [u'scale=3840:2160,', u'scale=4096:2160,', u'scale=4096:1716,', \
						    u'scale=3996:2160,', u'scale=2716:1524,', u'scale=2716:1440,', u'scale=7680:4800,', \
					            u'scale=6400:4096,', u'scale=5120:4096,', u'scale=3840:2400,', u'scale=3200:2048,', \
						    u'scale=2560:2048,', u'scale=2560:1600,', u'scale=2048:1536,']:
						    self.messLectureMplayerVidGrdTailles()
						
				elif j[0] in ['codecxvid', 'jpeg_sans_perte', 'ffv1']:
					# Récup du désentrelacement
					desentJPEGsansPerteMencoder = self.itemStacked_JPEGsansPerte.get_desentrelacement_mencoder()
					desentFFV1Mencoder = self.itemStacked_FFv1.get_desentrelacement_mencoder()
					desentXvidMencoder = self.itemStacked_XVID.get_desentrelacement_mencoder()
					if ext_chargee == '.ts':
						self.fenetreTailleFichierTS()
						# Pas de taille, ni d'aspect quand l'utilisateur charge une vidéo TS
						if j[0] == 'jpeg_sans_perte': spin = (str(j[3].spinBitrateVideo.value()), '', desentJPEGsansPerteMencoder, '')
						elif j[0] == 'ffv1': spin = (str(j[3].spinBitrateVideo.value()), '', desentFFV1Mencoder, '')
						elif j[0] == 'codecxvid': spin = (str(j[3].spinBitrateVideo.value()), '', desentXvidMencoder, '')
					else:	
						# Récup des valeurs de la dimension de la vidéo dans la liste déroulante
						taillVideoJpegSansPerteMencoder = self.itemStacked_JPEGsansPerte.get_taill_video_jpeg_sans_p_mencoder()
						taillVideoFFv1Mencoder = self.itemStacked_FFv1.get_taill_video_ffv1_mencoder()
						taillVideoXvidMencoder = self.itemStacked_XVID.get_taill_video_xvid_mencoder()
						# Récup de l'aspect (par la fonction aspectMencoder)
						aspectJPEGsansPerteMencoder = self.aspectMencoder(taillVideoJpegSansPerteMencoder)
						aspectFFv1Mencoder = self.aspectMencoder(taillVideoFFv1Mencoder)
						aspectXvidMencoder = self.aspectMencoder(taillVideoXvidMencoder)
						# Cas particuliers pour le réglage de la taille de la vidéo et du désentrelacement (appels de la fonction: desentrelacementParticulierMencoder)
						desentJPEGsansPerteMencoder = self.desentrelacementParticulierMencoder(taillVideoJpegSansPerteMencoder, desentJPEGsansPerteMencoder)
						desentFFV1Mencoder = self.desentrelacementParticulierMencoder(taillVideoFFv1Mencoder, desentFFV1Mencoder)
						desentXvidMencoder = self.desentrelacementParticulierMencoder(taillVideoXvidMencoder, desentXvidMencoder)
						# Affichage de la boîte de dialogue d'information dans le cas des choix en très haite définition avec les presets:  
						# HD 4K (3840x2160), HD 4K Cin (4096x2160), HD 4K Cin (4096x1716),  HD 4K Cin (3996x2160), 
						# HD 2.7K (2716x1524), HD 2.7K Cin (2716x1440) (pour la taille de la vidéo en sortie)  ... et les autres presets de 
						# taille supérieurs à 2046x2046
						if j[0] == 'codecxvid': taille_v = taillVideoXvidMencoder
						elif j[0] == 'jpeg_sans_perte': taille_v = taillVideoJpegSansPerteMencoder
						elif j[0] == 'ffv1': taille_v = taillVideoFFv1Mencoder
						if taille_v in [u'-vf scale=3840:2160', u'-vf scale=4096:2160', u'-vf scale=4096:1716', \
						    u'-vf scale=3996:2160', u'-vf scale=2716:1524', u'-vf scale=2716:1440', u'-vf scale=7680:4800', \
					            u'-vf scale=6400:4096', u'-vf scale=5120:4096', u'-vf scale=3840:2400', u'-vf scale=3200:2048', \
						    u'-vf scale=2560:2048', u'-vf scale=2560:1600', u'-vf scale=2048:1536']:
						    self.messLectureMplayerVidGrdTailles()
						# La valeur est sous forme de tuple et contient au moins 2 valeurs
						if j[0] == 'jpeg_sans_perte': spin = (str(j[3].spinBitrateVideo.value()), taillVideoJpegSansPerteMencoder, desentJPEGsansPerteMencoder, aspectJPEGsansPerteMencoder)
						elif j[0] == 'ffv1': spin = (str(j[3].spinBitrateVideo.value()), taillVideoFFv1Mencoder, desentFFV1Mencoder, aspectFFv1Mencoder)
						elif j[0] == 'codecxvid': spin = (str(j[3].spinBitrateVideo.value()), taillVideoXvidMencoder, desentXvidMencoder, aspectXvidMencoder)

				elif j[0] in ['codec_hfyu_ffmpeg', 'codec_webm_ffmpeg']:
					# Pour le HFYU # ---------
					# Récup des valeurs de la dimension de la vidéo dans la liste déroulante
					valeurSizeHFYU = self.itemStacked_HFYU.get_taill_video_general_ffmpeg()
					# Désentrelacement
					desentHFYU = self.itemStacked_HFYU.get_desentrelacement_ffmpeg() 
					self.valeursHFYU = (str(valeurSizeHFYU), str(desentHFYU))
					# Pour le WebM # ---------
					valeurSizeWebM = self.itemStacked_WEBM.get_taill_video_general_ffmpeg()
					# Désentrelacement
					desentWEBM = self.itemStacked_WEBM.get_desentrelacement_ffmpeg() 
					# Taille de la vidéo + Bitrate vidéo + Désentrelacement
					self.valeursWEBM = (str(valeurSizeWebM), str(j[3].spinBitrateVideo.value()), str(desentWEBM))
					# Affichage de la boîte de dialogue d'information dans le cas des choix en très haite définition avec les presets:  
					# HD 4K (3840x2160), HD 4K Cin (4096x2160), HD 4K Cin (4096x1716),  HD 4K Cin (3996x2160), 
					# HD 2.7K (2716x1524), HD 2.7K Cin (2716x1440) (pour la taille de la vidéo en sortie)  ... et les autres presets de 
					# taille supérieurs à 2046x2046
					if j[0] == 'codec_hfyu_ffmpeg': taille_v = valeurSizeHFYU
					elif j[0] == 'codec_webm_ffmpeg': taille_v = valeurSizeWebM
					if taille_v in [u'-s 3840x2160 -aspect 16:9', u'-s 4096x2160 -aspect 1.8962962962962964', u'-s 4096x1716 -aspect 2.386946386946387', \
					    u'-s 3996x2160 -aspect 1.85', u'-s 2716x1524 -aspect 1.7821522309711286',  u'-s 2716x1440 -aspect 1.886111111111111', \
					    u'-s 7680x4800', u'-s 6400x4096', u'-s 5120x4096', u'-s 3840x2400', u'-s 3200x2048', u'-s 2560x2048', u'-s 2560x1600', u'-s 2048x1536']: 
						    self.messLectureMplayerVidGrdTailles()
					
				elif j[0] in ['codec_dvd_ffmpeg']:
					# Sélection du mode  (preset)
					modeCodecDVD = self.itemStacked_DVD.get_mode_dvd()
					# Sélection de l'apparence (preset)
					apparenceCodecDVD = self.itemStacked_DVD.get_apparence_dvd()
					# La valeur est sous forme de tuple et contient au moins 2 valeurs
					self.valeurSpecsDVD = (str(modeCodecDVD), str(apparenceCodecDVD))

				elif j[0] in ['codecoggtheora_ext_ogg', 'codecoggtheora_ext_ogv', 'codecoggtheora_ext_ogm']:
					spin = str(j[3].spinCompression.value())

				else:
					spin = str(j[3].spinCompression.value())
					
		
		debug(u"{0} {1} {2} {3}".format(idCodec, chemin, spin, type(spin)))
		
		# Collecte des infos codec audio
		infosCodecAudio = {'Fichier':chemin}
		getParamVideo(chemin, ['ID_AUDIO_CODEC'], infosCodecAudio)
		try: audioCodec = infosCodecAudio['ID_AUDIO_CODEC']
		except: audioCodec = "codec audio non disponible"

		# Appel des classes après séparation des traitements gérés par Mencoder, FFmpeg
		# et FFmpeg2theora.
		# Appel du moteur -> animation encodage avec un codec particulier
		try:
			if idCodec in ['codecdivx4', 'codecmotionjpeg', 'codecmpeg1', 'codecmpeg2', 'codecwmv2', 'codecxvid', 'macromediaflashvideo', 'codech264mpeg4_ext_h264', 'codech263p', 'jpeg_sans_perte', 'ffv1']:
				if idCodec == 'codech264mpeg4_ext_h264':
					# Pour le vidéos Mpeg4 H264 (ext .h264), si celle-ci
					# comporte une piste audio, le traitement ne se fera pas
					if audioCodec != "codec audio non disponible":
						messErrH264ExtH264=QMessageBox(self)
						messErrH264ExtH264.setText(_(u"<p>Le transcodage des vidéos comportant une piste audio en Mpeg4 H264 (extension .h264) a momentanément été désactivé.</p>"))
						messErrH264ExtH264.setWindowTitle(_(u"Erreur"))
						messErrH264ExtH264.setIcon(QMessageBox.Warning)
						messErrH264ExtH264.exec_()
						return
					elif ext_chargee in ['.ogg', '.ogm', '.ogv']:
						# Uniquement pour Linux et MacOSX
						if os.name in ['posix', 'mac']:
							if idCodec in ['codech264mpeg4_ext_h264']:
							      self.fenetreErreur()
						# Uniquement pour windows
						elif os.name == 'nt':
							self.fenetreErreur()
					else:
						mencoder = WidgetMEncoder(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = spin, laisserOuvert=ouvert)
						mencoder.setWindowTitle(_(u"Transcodage vidéo"))
						mencoder.exec_()
				
				else:
					mencoder = WidgetMEncoder(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = spin, laisserOuvert=ouvert)
					mencoder.setWindowTitle(_(u"Transcodage vidéo"))
					mencoder.exec_()
				
			elif idCodec in ['copie']:
				# Pour gestion en entrée des fichiers Ogg theora et le MKV
				if ext_chargee in ['.ogg', '.ogm', '.ogv', '.mkv']:
					self.fenetreErreur()
				else: 
					mencoder = WidgetMEncoder(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = spin, laisserOuvert=ouvert)
					mencoder.setWindowTitle(_(u"Transcodage vidéo"))
					mencoder.exec_()
			  
			elif idCodec in ['codecoggtheora_ext_ogg', 'codecoggtheora_ext_ogv', 'codecoggtheora_ext_ogm']:
				# Pour gestion en entrée des fichiers Ogg theora
				if ext_chargee in ['.h264', '.ogg', '.ogm', '.ogv']:
					self.fenetreErreur()
				else:	
					ffmpeg2theora = WidgetFFmpeg2theora(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = spin, laisserOuvert=ouvert)
					ffmpeg2theora.setWindowTitle(_(u"Transcodage vidéo"))
					ffmpeg2theora.exec_()

			elif idCodec in ['avirawsanscompression']:
				# Pour gestion en entrée des fichiers Ogg theora
				if ext_chargee in ['.ogg', '.ogm', '.ogv']:
					# Uniquement pour windows
					if os.name == 'nt':
						self.fenetreErreur()
					else:
						mencoder = WidgetMEncoder(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = self.valeursAVI_RAW, laisserOuvert=ouvert)
						mencoder.setWindowTitle(_(u"Transcodage vidéo"))
						mencoder.exec_()
						  
				else:
					mencoder = WidgetMEncoder(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = self.valeursAVI_RAW, laisserOuvert=ouvert)
					mencoder.setWindowTitle(_(u"Transcodage vidéo"))
					mencoder.exec_()
				
			elif idCodec in ['codec_hfyu_ffmpeg']:
				# Pour gestion en entrée des fichiers Ogg theora
				if ext_chargee in ['.h264', '.ogg', '.ogm', '.ogv', '.ts']:
					self.fenetreErreur()
				else:
					ffmpeg = WidgetFFmpeg(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = self.valeursHFYU, laisserOuvert=ouvert)
					ffmpeg.setWindowTitle(_(u"Transcodage vidéo"))
					ffmpeg.exec_()
				
			elif idCodec == 'codec_3GP_ffmpeg':
				# Pour gestion en entrée des fichiers Ogg theora
				if ext_chargee in ['.h264', '.ogg', '.ogm', '.ogv']:
					self.fenetreErreur()
				# Pour le transcodage 3GP, si on charge une vidéo qui
				# comporte un canal audio, le transcodage n'a pas lieu
				elif audioCodec == "codec audio non disponible":
					ffmpeg = WidgetFFmpeg(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = self.valeurs3GP, laisserOuvert=ouvert)
					ffmpeg.setWindowTitle(_(u"Transcodage vidéo"))
					ffmpeg.exec_()
				else:
					messErr3GP=QMessageBox(self)
					messErr3GP.setText(_(u"<p>Le transcodage des vidéos comportant une piste audio en 3GP a momentanément été désactivé.</p>"))
					messErr3GP.setWindowTitle(_(u"Erreur"))
					messErr3GP.setIcon(QMessageBox.Warning)
					messErr3GP.exec_()
					return
					
			elif idCodec == 'codec_AMV_ffmpeg':
				# Pour gestion en entrée des fichiers Ogg theora
				if ext_chargee in ['.h264', '.ogg', '.ogm', '.ogv', '.ts']:
					self.fenetreErreur()
				else:
					ffmpeg = WidgetFFmpeg(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = self.valeursAMV, laisserOuvert=ouvert)
					ffmpeg.setWindowTitle(_(u"Transcodage vidéo"))
					ffmpeg.exec_()

			elif idCodec == 'codec_mov_ffmpeg':
				# Pour gestion en entrée des fichiers Ogg theora
				if ext_chargee in ['.h264', '.ogg', '.ogm', '.ogv', '.ts']:
					self.fenetreErreur()
				else:
					ffmpeg = WidgetFFmpeg(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = self.valeursMOV, laisserOuvert=ouvert)
					ffmpeg.setWindowTitle(_(u"Transcodage vidéo"))
					ffmpeg.exec_()
					
			elif idCodec == 'codec_pro_res_ffmpeg':
				# Pour gestion en entrée des fichiers Ogg theora
				if ext_chargee in ['.h264', '.ogg', '.ogm', '.ogv', '.ts']:
					self.fenetreErreur()
				else:
					ffmpeg = WidgetFFmpeg(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = self.valeursProRes, laisserOuvert=ouvert)
					ffmpeg.setWindowTitle(_(u"Transcodage vidéo"))
					ffmpeg.exec_()
					
			elif idCodec == 'codec_shockwave_swf_ffmpeg':
				# Pour gestion en entrée des fichiers Ogg theora et DV
				if ext_chargee in ['.ogg', '.ogm', '.ogv', '.dv', '.DV']:
					self.fenetreErreur()
				else:
					ffmpeg = WidgetFFmpeg(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = self.valeursShockWave, laisserOuvert=ouvert)
					ffmpeg.setWindowTitle(_(u"Transcodage vidéo"))
					ffmpeg.exec_()
					
			elif idCodec == 'codec_transport_stream_ts_ffmpeg':
				# Pour gestion en entrée des fichiers Codec Transport Stream (.ts) eux-mêmes
				if ext_chargee in ['.ts']:
					self.fenetreErreur()
				else:
					ffmpeg = WidgetFFmpeg(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = self.valeursTS, laisserOuvert=ouvert)
					ffmpeg.setWindowTitle(_(u"Transcodage vidéo"))
					ffmpeg.exec_()
				
			elif idCodec == 'codec_dv_ffmpeg':
				# Pour gestion en entrée des fichiers Ogg theora
				if ext_chargee in ['.ogg', '.ogm', '.ogv','.ts']:
					self.fenetreErreur()
				else:
					ffmpeg = WidgetFFmpeg(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = spin, laisserOuvert=ouvert)
					ffmpeg.setWindowTitle(_(u"Transcodage vidéo"))
					ffmpeg.exec_()
					
			elif idCodec == 'codec_vob_ffmpeg':
				# Pour gestion en entrée des fichiers Ogg theora
				if ext_chargee in ['.h264', '.ogg', '.ogm', '.ogv','.ts']:
					self.fenetreErreur()
				else:
					ffmpeg = WidgetFFmpeg(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = spin, laisserOuvert=ouvert)
					ffmpeg.setWindowTitle(_(u"Transcodage vidéo"))
					ffmpeg.exec_()
					
			elif idCodec == 'codec_webm_ffmpeg':
				if os.name == 'nt' :
					fffwm = 1
				else :
					# Appel de la classe pour le WebM
					self.ffmpeg_format_webm = FFmpegFormat('webm')
					# Appel du drapeau (on regarde si le WebM est supporté)
					fffwm = self.ffmpeg_format_webm.vrai_faux
				
				if fffwm == 1:
					ffmpeg = WidgetFFmpeg(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = self.valeursWEBM, laisserOuvert=ouvert)
					ffmpeg.setWindowTitle(_(u"Transcodage vidéo"))
					ffmpeg.exec_()
				else:
					messWebM=QMessageBox(self)
					messWebM.setText(_(u"<p>Votre version de FFmpeg n'intègre malheureusement pas le support du WebM ! <b>Arrêt du processus.</b></p>"))
					messWebM.setWindowTitle(_(u"Erreur"))
					messWebM.setIcon(QMessageBox.Warning)
					messWebM.exec_()
					return
					
			elif idCodec in ['conteneur_mkv_ffmpeg']:
				try:
					# Pour gestion en entrée des fichiers Codec Transport Stream (.ts)
					if ext_chargee in ['.ts']:
						self.fenetreErreur()
					else:
						ffmpeg = WidgetFFmpeg(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = self.valeursMKV, laisserOuvert=ouvert)
						ffmpeg.setWindowTitle(_(u"Transcodage vidéo"))
						ffmpeg.exec_()
				except:
					messMKV=QMessageBox(self)
					messMKV.setText(_(u"<p>Votre version de FFmpeg n'intègre malheureusement pas le support du Mkv ! (ou l'une des sélections ; Format vidéo et/ou Format audio est incompatble). <b>Arrêt du processus.</b></p>"))
					messMKV.setWindowTitle(_(u"Erreur"))
					messMKV.setIcon(QMessageBox.Warning)
					messMKV.exec_()
					return
					
			elif idCodec in ['codech264mpeg4_ffmpeg']:
				ffmpeg = WidgetFFmpeg(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = spin, laisserOuvert=ouvert)
				ffmpeg.setWindowTitle(_(u"Transcodage vidéo"))
				ffmpeg.exec_()
				
			elif idCodec in ['codec_dvd_ffmpeg']:
				# Pour gestion en entrée des fichiers Codec Transport Stream (.ts)
				if ext_chargee in ['.ts']:
					self.fenetreErreur()
				else:
					ffmpeg = WidgetFFmpeg(idCodec, chemin, cheminFichierEnregistrerVideo, valeurNum = self.valeurSpecsDVD, laisserOuvert=ouvert)
					ffmpeg.setWindowTitle(_(u"Transcodage vidéo"))
					ffmpeg.exec_()
				 
		#except Exception, e:
		except None:
			messageErreur=QMessageBox(self)
			messageErreur.setText(_(u"Un problème est survenu.")+str(e))
			messageErreur.setWindowTitle(_(u"Erreur"))
			messageErreur.setIcon(QMessageBox.Warning)
			messageErreur.exec_()
			return


		self.lstFichiersSortie =  cheminFichierEnregistrerVideo # pour la boite de dialogue de comparaison
		self.radioConvert.setChecked(True)
		self.radioSource.setEnabled(True)
		self.radioSource.setChecked(False)
		self.radioConvert.setEnabled(True)
		self.boutCompare.setEnabled(True)
		### Information à l'utilisateur
		self.infoLog(None, chemin, None, cheminFichierEnregistrerVideo)

		return cheminFichierEnregistrerVideo # module séquentiel
