#!/usr/bin/python
# -*- coding: utf-8 -*-

import ConfigParser, os, getpass
import platform
from xml.dom import minidom
from xml.dom.minidom import Document
from PyQt4.QtCore import QDir, QObject, Qt
from PyQt4.QtGui import QStyleFactory
###############
from moteur_modules_common.EkdCompatiblePython2Et3 import EkdPrintConfig
###############
isPortable = 1

class EkdConfig(QObject):
    if os.name == 'nt':
        defaultLocation = u'windows' + os.sep + u'config.ekd'
        coding = "cp1252"
        urlFFmpeg = u"windows\\FFmpeg\\"
        urlSox = u"windows\\sox\\sox-14.3.0\\"
        urlFFmpeg2theora = u"windows\\ffmpeg2theora\\"
        urlMencoder = u"windows\\MPlayer\\"
        urlIdentify = u"windows\\ImageMagick\\identify.exe"
        urlConvert = u"windows\\ImageMagick\\convert.exe"
        urlGmic = u"windows\\gmic\\gmic.exe"
    else :
        defaultLocation = unicode(QDir.homePath()) + os.sep + u'.config' + os.sep + u'ekd' + os.sep + u'config.ekd'
        coding = "utf-8"
        urlFFmpeg = u"linux_dependances_portables/ffmpeg/"
        urlSox = u""
        urlFFmpeg2theora = u""
        urlMencoder = u""
        urlIdentify = u"identify"
        urlConvert = u"convert"
        urlGmic = u"linux_dependances_portables/gmic/gmic"
		
    location = unicode(QDir.homePath()) + os.sep + u'.config' + os.sep + u'ekd' + os.sep + u'config.ekd'

    configuration = None

    # -------------------------------------------------------------------------
    # En suivant l'idée de Florent sur la liste lprod (très bonne idée et justifiée):
    # "Je me suis rendu compte que tu mettais le traitement dans le répertoire /tmp,
    # je pense que c'est risqué. Il vaut mieux le mettre dans ~/tmp. Généralement (et
    # c'est mon cas) j'accorde plus de place aux données qu'au système. Dans notre cas,
    # le fichier final devrait faire 7,9 Go et ma racine / ne dispose que de 6,1 Go"
    # -------------------------------------------------------------------------
    # On pourra toujours revenir à la normale si problème il y avait --> j'ai juste
    # laissé toute la section en commentaire plus bas.
    # -------------------------------------------------------------------------

    # Pour windows uniquement
    if os.name == 'nt':
        if isPortable :
            temp = unicode(QDir.currentPath())+os.sep+ u"ekd_tmp"
        else :
            temp = os.path.expanduser('~') + os.sep + "ekd_tmp"
    # Pour Linux et MacOSX
    elif os.name in ['posix', 'mac']:
        temp = os.path.expanduser('~') + os.sep + ".ekd_tmp"


    defaultConf=u"\
            <ekdconfig>\
                    <general>\
                        <boite_de_dialogue_de_fermeture>1</boite_de_dialogue_de_fermeture>\
                        <sauvegarder_parametres>2</sauvegarder_parametres>\
                        <charger_split>0</charger_split>\
                        <show_warning_messages>"+ str(Qt.Checked) +"</show_warning_messages>\
                        <effacer_config>0</effacer_config>\
                        <temporaire>" + temp + "</temporaire>\
                        <qtstyle>Cleanlooks</qtstyle>\
                        <video_input_path>" + os.path.expanduser('~') + os.sep + "</video_input_path>\
                        <image_input_path>" + os.path.expanduser('~') + os.sep + "</image_input_path>\
                        <sound_input_path>" + os.path.expanduser('~') + os.sep + "</sound_input_path>\
                        <video_output_path>" + os.path.expanduser('~') + os.sep + "</video_output_path>\
                        <image_output_path>" + os.path.expanduser('~') + os.sep + "</image_output_path>\
                        <sound_output_path>" + os.path.expanduser('~') + os.sep + "</sound_output_path>\
                        <show_hidden_files>0</show_hidden_files>\
                        <ignore_case>0</ignore_case>\
                        <display_mode>auto</display_mode>\
                        <interval_speed>2.0</interval_speed>\
                    </general>\
                    <animation_encodage_general>\
					 <codec>copie</codec>\
					 <codec_mov_ffmpeg>94</codec_mov_ffmpeg>\
					 <codecmotionjpeg>94</codecmotionjpeg>\
                        <codecoggtheora>5</codecoggtheora>\
                        <codec_vob_ffmpeg>94</codec_vob_ffmpeg>\
                        <codecmpeg2>94</codecmpeg2>\
					 <codec_transport_stream_ts_ffmpeg>94</codec_transport_stream_ts_ffmpeg>\
					 <codecdivx4>94</codecdivx4>\
                        <codecmpeg1>94</codecmpeg1>\
					 <codec_shockwave_swf_ffmpeg>94</codec_shockwave_swf_ffmpeg>\
                        <macromediaflashvideo>94</macromediaflashvideo>\
                        <codecwmv2>94</codecwmv2>\
                        <codecoggtheora_ext_ogg>7</codecoggtheora_ext_ogg>\
                        <codecoggtheora_ext_ogv>7</codecoggtheora_ext_ogv>\
                        <codecoggtheora_ext_ogm>7</codecoggtheora_ext_ogm>\
                        <conteneur_mkv_ffmpeg>94</conteneur_mkv_ffmpeg>\
                        <codech263p>94</codech263p>\
                        <reso3gp>0</reso3gp>\
                        <resoamv>0</resoamv>\
                        <mkvaudio>0</mkvaudio>\
                        <mkvvideo>0</mkvvideo>\
					 <dvd_mode>0</dvd_mode>\
					 <dvd_apparence>0</dvd_apparence>\
					 <choix_desentrelacement_ffmpeg>0</choix_desentrelacement_ffmpeg>\
					 <choix_desentrelacement_mencoder_particulier>0</choix_desentrelacement_mencoder_particulier>\
					 <choix_desentrelacement_mencoder_tous>0</choix_desentrelacement_mencoder_tous>\
                        <taille_video_general_ffmpeg>0</taille_video_general_ffmpeg>\
                        <taille_video_general_mencoder>0</taille_video_general_mencoder>\
                        <taille_video_avi_raw_mencoder>0</taille_video_avi_raw_mencoder>\
                        <taille_video_xvid_mencoder>0</taille_video_xvid_mencoder>\
                    </animation_encodage_general>\
				  <animation_encodage_general_bitrate_video>\
					 <codec_mov_ffmpeg>1200</codec_mov_ffmpeg>\
					 <codecmotionjpeg>1200</codecmotionjpeg>\
					 <codecmpeg2>1200</codecmpeg2>\
					 <codech264mpeg4>1200</codech264mpeg4>\
					 <codech264mpeg4_ext_h264>1200</codech264mpeg4_ext_h264>\
					 <codecdivx4>1200</codecdivx4>\
					 <codecxvid>1200</codecxvid>\
					 <codecmpeg1>1200</codecmpeg1>\
					 <macromediaflashvideo>500</macromediaflashvideo>\
					 <codecwmv2>1200</codecwmv2>\
					 <jpeg_sans_perte>1200</jpeg_sans_perte>\
					 <ffv1>1200</ffv1>\
					 <codech263p>1200</codech263p>\
				  </animation_encodage_general_bitrate_video>\
                    <animation_encodage_web>\
                        <codec>youtube_16/9_HQ</codec>\
                    </animation_encodage_web>\
                    <animation_encodage_hd>\
                        <codec>hd_1920x1080_mov__pcm_s16be__16/9</codec>\
                    </animation_encodage_hd>\
                    <animation_encodage_avchd>\
                        <codec>0</codec>\
                        <resolution>0</resolution>\
					 <spec_DNxHD>0</spec_DNxHD>\
					 <audio_DNxHD>0</audio_DNxHD>\
					 <mode_DV>0</mode_DV>\
					 <aspect_DV>0</aspect_DV>\
					 <audio_General>0</audio_General>\
                        <images_par_seconde>25</images_par_seconde>\
                        <qualite>94</qualite>\
                    </animation_encodage_avchd>\
                    <animation_filtresvideo>\
                        <codec>niveaudegris</codec>\
                        <valeur_bruit_luma>23</valeur_bruit_luma>\
                        <valeur_bruit_chroma>25</valeur_bruit_chroma>\
                        <type_bruit_luma>bruituniforme</type_bruit_luma>\
                        <type_bruit_chroma>bruituniforme</type_bruit_chroma>\
                        <luminosite>0</luminosite>\
                        <contraste>0</contraste>\
                        <decouper_largeur>800</decouper_largeur>\
                        <decouper_hauteur>600</decouper_hauteur>\
                        <decouper_position_largeur>0</decouper_position_largeur>\
                        <decouper_position_hauteur>0</decouper_position_hauteur>\
                        <couleur>0</couleur>\
                        <saturation>0</saturation>\
                        <flou_boite_rayon>1</flou_boite_rayon>\
                        <flou_boite_puissance>1</flou_boite_puissance>\
                        <resolution_redim_largeur>640</resolution_redim_largeur>\
                        <resolution_redim_hauteur>480</resolution_redim_hauteur>\
                        <codec>tournervideo</codec>\
                        <codec>desentrelacer</codec>\
                        <selection_bande_taille_video></selection_bande_taille_video>\
                        <couleur_r_bande_ext>128</couleur_r_bande_ext>\
                        <couleur_g_bande_ext>128</couleur_g_bande_ext>\
                        <couleur_b_bande_ext>128</couleur_b_bande_ext>\
                    </animation_filtresvideo>\
                    <animation_separer_audio_et_video>\
                        <type_extraction>video_audio</type_extraction>\
                    </animation_separer_audio_et_video>\
                    <animation_convertir_des_images_en_video>\
                        <codec>mpeg1video</codec>\
                        <nbr_img_sec>25</nbr_img_sec>\
                        <nbr_img_sec_mpeg1video>25</nbr_img_sec_mpeg1video>\
                    </animation_convertir_des_images_en_video>\
                    <animation_convertir_une_video_en_images>\
                    </animation_convertir_une_video_en_images>\
                    <animation_decouper_une_video>\
                    </animation_decouper_une_video>\
                    <animation_montage_video_seul>\
                        <type_ordre_montage>sans_ordre_alpha</type_ordre_montage>\
                    </animation_montage_video_seul>\
                    <animation_montage_video_et_audio>\
                        <type_ordre_montage>sans_ordre_alpha</type_ordre_montage>\
                    </animation_montage_video_et_audio>\
                    <animation_conversion_video_16_9_4_3>\
                        <type>16_9</type>\
                    </animation_conversion_video_16_9_4_3>\
                    <animation_reglages_divers>\
                        <spin>22</spin>\
                    </animation_reglages_divers>\
				  <animation_tag_video>\
				  </animation_tag_video>\
                    <image_divers_infos>\
                    </image_divers_infos>\
                    <image_filtres_image>\
                        <filtre>vieux_films</filtre>\
                        <pointillisme>impulse</pointillisme>\
                        <couleurs_predefinies>bleu_roi</couleurs_predefinies>\
                        <evanescence>fond_blanc_lignes_noires</evanescence>\
                        <negatif>negatif_couleur</negatif>\
                        <rotation_image>rot_img_90_gauche</rotation_image>\
                        <encadre_photo>noir</encadre_photo>\
                        <laplacien_1>laplacien_1_noir_et_blanc</laplacien_1>\
                        <peintur_degrade_de_coul>bleu_roi</peintur_degrade_de_coul>\
                        <contraste_couleur>6</contraste_couleur>\
                        <sepia>60</sepia>\
                        <charcoal_traits_noirs>1</charcoal_traits_noirs>\
                        <edge>40</edge>\
                        <huile>1</huile>\
                        <gamma>1</gamma>\
                        <fonce_clair>100</fonce_clair>\
                        <liquidite>6</liquidite>\
                        <bas_relief>1</bas_relief>\
                        <charcoal_crayon_1>1</charcoal_crayon_1>\
                        <spread_crayon_1>1</spread_crayon_1>\
                        <radius>1</radius>\
                        <sigma>1</sigma>\
                        <precision_trait>1</precision_trait>\
                        <largeur_trait>1</largeur_trait>\
                        <seuillage_bas>1</seuillage_bas>\
                        <seuillage_haut>128</seuillage_haut>\
                        <intensite_du_trait_bd_1>28</intensite_du_trait_bd_1>\
                        <reduction_couleur>2</reduction_couleur>\
                        <peinture_huile>6</peinture_huile>\
                        <couleur_11></couleur_11>\
                        <couleur_12></couleur_12>\
                        <couleur_13></couleur_13>\
                        <couleur_21></couleur_21>\
                        <couleur_22></couleur_22>\
                        <couleur_23></couleur_23>\
                        <couleur_31></couleur_31>\
                        <couleur_32></couleur_32>\
                        <couleur_33></couleur_33>\
                        <taille_mini_forme>14</taille_mini_forme>\
                        <taille_maxi_forme>18</taille_maxi_forme>\
                        <coul_omb_lum_a_la_coul_11></coul_omb_lum_a_la_coul_11>\
                        <coul_omb_lum_a_la_coul_12></coul_omb_lum_a_la_coul_12>\
                        <coul_omb_lum_a_la_coul_21></coul_omb_lum_a_la_coul_21>\
                        <coul_omb_lum_a_la_coul_22></coul_omb_lum_a_la_coul_22>\
                        <coul_omb_lum_a_la_coul_31></coul_omb_lum_a_la_coul_31>\
                        <coul_omb_lum_a_la_coul_32></coul_omb_lum_a_la_coul_32>\
                        <coul_omb_lum_a_la_coul_41></coul_omb_lum_a_la_coul_41>\
                        <coul_omb_lum_a_la_coul_42></coul_omb_lum_a_la_coul_42>\
                        <intensite_du_trait_bd_2>28</intensite_du_trait_bd_2>\
                        <flou_couleurs>8</flou_couleurs>\
                        <coul_contour_couleur_00></coul_contour_couleur_00>\
                        <coul_contour_couleur_11></coul_contour_couleur_11>\
                        <coul_contour_couleur_12></coul_contour_couleur_12>\
                        <coul_contour_couleur_13></coul_contour_couleur_13>\
                        <coul_contour_couleur_21></coul_contour_couleur_21>\
                        <coul_contour_couleur_22></coul_contour_couleur_22>\
                        <coul_contour_couleur_23></coul_contour_couleur_23>\
                        <coul_contour_couleur_31></coul_contour_couleur_31>\
                        <coul_contour_couleur_32></coul_contour_couleur_32>\
                        <coul_contour_couleur_33></coul_contour_couleur_33>\
                        <coul_contour_couleur_41></coul_contour_couleur_41>\
                        <coul_contour_couleur_42></coul_contour_couleur_42>\
                        <coul_contour_couleur_43></coul_contour_couleur_43>\
                        <amplitude_imit_hdr>1</amplitude_imit_hdr>\
                        <rayon_imit_hdr>6</rayon_imit_hdr>\
                        <douc_voisin_imit_hdr>5</douc_voisin_imit_hdr>\
                        <finess_moy_imit_hdr>16</finess_moy_imit_hdr>\
                        <exposition_vintage>200</exposition_vintage>\
                        <contraste_vintage>85</contraste_vintage>\
                        <saturation_vintage>160</saturation_vintage>\
                        <seuil_ombr_vintage>8000</seuil_ombr_vintage>\
                        <seuil_lumier_vintage>20000</seuil_lumier_vintage>\
                        <douc_transition_vintage>1</douc_transition_vintage>\
                        <flou_video_super_8>10</flou_video_super_8>\
                        <epaiss_bordur_video_super_8>30</epaiss_bordur_video_super_8>\
                        <amp_coul_bordur_video_super_8>700</amp_coul_bordur_video_super_8>\
					 <gamma_video_cinema_1>170</gamma_video_cinema_1>\
					 <contraste_cinema_1>76</contraste_cinema_1>\
					 <luminosite_cinema_1>100</luminosite_cinema_1>\
					 <douceur_cinema_1>1</douceur_cinema_1>\
					 <flou_cinema_1>1</flou_cinema_1>\
					 <epaiss_bordur_cinema_1>20</epaiss_bordur_cinema_1>\
                        <echelle_vieil_ecol_8bits>40</echelle_vieil_ecol_8bits>\
                        <complex_vieil_ecol_8bits>1000</complex_vieil_ecol_8bits>\
                        <niveaux_vieil_ecol_8bits>32</niveaux_vieil_ecol_8bits>\
                        <amplitude_dessin_aux_traits>200</amplitude_dessin_aux_traits>\
                        <dens_lignes_dessin_aux_traits>100</dens_lignes_dessin_aux_traits>\
                        <contraint_coul_dessin_aux_traits>6</contraint_coul_dessin_aux_traits>\
                        <flou_taits_dessin_aux_traits>2</flou_taits_dessin_aux_traits>\
                        <flou_coul_dessin_aux_traits>2</flou_coul_dessin_aux_traits>\
					 <debut_iterations_cubisme_analytique>240</debut_iterations_cubisme_analytique>\
					 <fin_iterations_cubisme_analytique>240</fin_iterations_cubisme_analytique>\
					 <debut_taille_bloc_cubisme_analytique>8</debut_taille_bloc_cubisme_analytique>\
					 <fin_taille_bloc_cubisme_analytique>8</fin_taille_bloc_cubisme_analytique>\
					 <debut_angle_cubisme_analytique>114</debut_angle_cubisme_analytique>\
					 <fin_angle_cubisme_analytique>114</fin_angle_cubisme_analytique>\
					 <nbre_img_ligne_andy_warhol>3</nbre_img_ligne_andy_warhol>\
					 <nbre_img_colonne_andy_warhol>3</nbre_img_colonne_andy_warhol>\
					 <lissage_andy_warhol>1</lissage_andy_warhol>\
					 <couleur_andy_warhol>40</couleur_andy_warhol>\
					 <seuil_coul_correct_yeux_rouges>80</seuil_coul_correct_yeux_rouges>\
					 <lissage_correct_yeux_rouges>1</lissage_correct_yeux_rouges>\
					 <attenuation_correct_yeux_rouges>1</attenuation_correct_yeux_rouges>\
					 <resol_x_bull_en_tableau>1024</resol_x_bull_en_tableau>\
					 <resol_y_bull_en_tableau>1024</resol_y_bull_en_tableau>\
					 <rayon_bull_en_tableau>70</rayon_bull_en_tableau>\
					 <nbre_par_ligne_bull_en_tableau>3</nbre_par_ligne_bull_en_tableau>\
					 <nbre_par_ligne_bull_en_tableau>3</nbre_par_ligne_bull_en_tableau>\
					 <larg_bordur_bull_en_tableau>25</larg_bordur_bull_en_tableau>\
					 <haut_bordur_bull_en_tableau>25</haut_bordur_bull_en_tableau>\
					 <larg_final_img_bull_en_tableau>800</larg_final_img_bull_en_tableau>\
					 <haut_final_img_bull_en_tableau>800</haut_final_img_bull_en_tableau>\
					 <pos_doubles_planete_1>2</pos_doubles_planete_1>\
					 <rayon_planete_1>100</rayon_planete_1>\
					 <dilatation_planete_1>60</dilatation_planete_1>\
					 <larg_final_img_planete_1>800</larg_final_img_planete_1>\
					 <haut_final_img_planete_1>800</haut_final_img_planete_1>\
					 <debut_abstraction_expressionnisme>2</debut_abstraction_expressionnisme>\
					 <fin_abstraction_expressionnisme>2</fin_abstraction_expressionnisme>\
					 <debut_lissage_expressionnisme>180</debut_lissage_expressionnisme>\
					 <fin_lissage_expressionnisme>180</fin_lissage_expressionnisme>\
					 <debut_couleur_expressionnisme>340</debut_couleur_expressionnisme>\
					 <fin_couleur_expressionnisme>340</fin_couleur_expressionnisme>\
					 <dessin_13_amplitude>1874</dessin_13_amplitude>\
					 <dessin_14_taille>3</dessin_14_taille>\
					 <taill_bord_polaroid>10</taill_bord_polaroid>\
					 <taill_larg_ombre_polaroid>4</taill_larg_ombre_polaroid>\
					 <taill_haut_ombre_polaroid>4</taill_haut_ombre_polaroid>\
					 <rot_photo_polaroid>10</rot_photo_polaroid>\
					 <taill_larg_ombre_vieil_photo>4</taill_larg_ombre_vieil_photo>\
					 <taill_haut_ombre_vieil_photo>4</taill_haut_ombre_vieil_photo>\
					 <rot_photo_vieil_photo>10</rot_photo_vieil_photo>\
					 <pos_larg_oeilleton>50</pos_larg_oeilleton>\
					 <pos_haut_oeilleton>50</pos_haut_oeilleton>\
					 <rayon_oeilleton>50</rayon_oeilleton>\
					 <amplitude_oeilleton>1</amplitude_oeilleton>\
					 <vision_thermique_min>1</vision_thermique_min>\
					 <vision_thermique_max>255</vision_thermique_max>\
					 <nett_trait_bord_tendu>1</nett_trait_bord_tendu>\
					 <fluct_coul_bord_tendu>1</fluct_coul_bord_tendu>\
					 <transp_trait_bord_tendu>1</transp_trait_bord_tendu>\
					 <floutage_bord_tendu>1</floutage_bord_tendu>\
					 <coul_debut_bord_tendu>1</coul_debut_bord_tendu>\
					 <coul_fin_img_bord_tendu>255</coul_fin_img_bord_tendu>\
					 <erosion>5</erosion>\
					 <dilatation>5</dilatation>\
					 <douceur_bd_3>3</douceur_bd_3>\
					 <nettete_bd_3>84</nettete_bd_3>\
					 <seuil_contour_bd_3>16</seuil_contour_bd_3>\
					 <epaisseur_contour_bd_3>36</epaisseur_contour_bd_3>\
					 <influence_couleur_bd_3>100</influence_couleur_bd_3>\
					 <nbre_couleurs_bd_3>32</nbre_couleurs_bd_3>\
					 <iterations_touches_de_peintur>2</iterations_touches_de_peintur>\
					 <rayon_touches_de_peintur>4</rayon_touches_de_peintur>\
					 <canevas_touches_de_peintur>1000</canevas_touches_de_peintur>\
					 <debut_amplitude_figuration_libre_1>1238</debut_amplitude_figuration_libre_1>\
					 <fin_amplitude_figuration_libre_1>1238</fin_amplitude_figuration_libre_1>\
					 <debut_abstraction_figuration_libre_1>1</debut_abstraction_figuration_libre_1>\
					 <fin_abstraction_figuration_libre_1>1</fin_abstraction_figuration_libre_1>\
					 <debut_douc_peint_figuration_libre_1>150</debut_douc_peint_figuration_libre_1>\
					 <fin_douc_peint_figuration_libre_1>150</fin_douc_peint_figuration_libre_1>\
					 <debut_couleur_figuration_libre_1>200</debut_couleur_figuration_libre_1>\
					 <fin_couleur_figuration_libre_1>200</fin_couleur_figuration_libre_1>\
					 <debut_seuil_bord_figuration_libre_1>310</debut_seuil_bord_figuration_libre_1>\
					 <fin_seuil_bord_figuration_libre_1>310</fin_seuil_bord_figuration_libre_1>\
					 <debut_douc_seg_figuration_libre_1>1</debut_douc_seg_figuration_libre_1>\
					 <fin_douc_seg_figuration_libre_1>1</fin_douc_seg_figuration_libre_1>\
					 <debut_intensite_du_trait_peint_aguarelle>22</debut_intensite_du_trait_peint_aguarelle>\
					 <fin_intensite_du_trait_peint_aguarelle>22</fin_intensite_du_trait_peint_aguarelle>\
					 <debut_flou_couleurs_peint_aguarelle>7</debut_flou_couleurs_peint_aguarelle>\
					 <fin_flou_couleurs_peint_aguarelle>7</fin_flou_couleurs_peint_aguarelle>\
					 <debut_amplitude_peint_aguarelle>80</debut_amplitude_peint_aguarelle>\
					 <fin_amplitude_peint_aguarelle>80</fin_amplitude_peint_aguarelle>\
					 <debut_abstraction_peint_aguarelle>4</debut_abstraction_peint_aguarelle>\
					 <fin_abstraction_peint_aguarelle>4</fin_abstraction_peint_aguarelle>\
					 <debut_douc_peint_peint_aguarelle>202</debut_douc_peint_peint_aguarelle>\
					 <fin_douc_peint_peint_aguarelle>202</fin_douc_peint_peint_aguarelle>\
					 <debut_couleur_peint_aguarelle>254</debut_couleur_peint_aguarelle>\
					 <fin_couleur_peint_aguarelle>254</fin_couleur_peint_aguarelle>\
					 <debut_seuil_bord_peint_aguarelle>310</debut_seuil_bord_peint_aguarelle>\
					 <fin_seuil_bord_peint_aguarelle>310</fin_seuil_bord_peint_aguarelle>\
					 <debut_douc_seg_peint_aguarelle>102</debut_douc_seg_peint_aguarelle>\
					 <fin_douc_seg_peint_aguarelle>102</fin_douc_seg_peint_aguarelle>\
					 <debut_opacite_ombre_peint_aguarelle>100</debut_opacite_ombre_peint_aguarelle>\
					 <fin_opacite_ombre_peint_aguarelle>100</fin_opacite_ombre_peint_aguarelle>\
					 <debut_tail_bord_horiz_peint_aguarelle>20</debut_tail_bord_horiz_peint_aguarelle>\
					 <fin_tail_bord_horiz_peint_aguarelle>20</fin_tail_bord_horiz_peint_aguarelle>\
					 <debut_tail_bord_vertic_peint_aguarelle>20</debut_tail_bord_vertic_peint_aguarelle>\
					 <fin_tail_bord_vertic_peint_aguarelle>20</fin_tail_bord_vertic_peint_aguarelle>\
					 <debut_distors_bord_peint_aguarelle>30</debut_distors_bord_peint_aguarelle>\
					 <fin_distors_bord_peint_aguarelle>30</fin_distors_bord_peint_aguarelle>\
					 <debut_douceur_bord_peint_aguarelle>3</debut_douceur_bord_peint_aguarelle>\
					 <fin_douceur_bord_peint_aguarelle>3</fin_douceur_bord_peint_aguarelle>\
					 <debut_bords_effet_flamme>70</debut_bords_effet_flamme>\
					 <fin_bords_effet_flamme>70</fin_bords_effet_flamme>\
					 <debut_attenuation_effet_flamme>25</debut_attenuation_effet_flamme>\
					 <fin_attenuation_effet_flamme>25</fin_attenuation_effet_flamme>\
					 <debut_douceur_effet_flamme>50</debut_douceur_effet_flamme>\
					 <fin_douceur_effet_flamme>50</fin_douceur_effet_flamme>\
					 <debut_seuil_effet_flamme>25</debut_seuil_effet_flamme>\
					 <fin_seuil_effet_flamme>25</fin_seuil_effet_flamme>\
					 <debut_img_depart_effet_flamme>20</debut_img_depart_effet_flamme>\
					 <fin_img_depart_effet_flamme>20</fin_img_depart_effet_flamme>\
					 <debut_coordx_normalis_carrelage>25</debut_coordx_normalis_carrelage>\
					 <fin_coordx_normalis_carrelage>25</fin_coordx_normalis_carrelage>\
					 <debut_val_mini_normalis_carrelage>1</debut_val_mini_normalis_carrelage>\
					 <fin_val_mini_normalis_carrelage>1</fin_val_mini_normalis_carrelage>\
					 <debut_val_maxi_normalis_carrelage>255</debut_val_maxi_normalis_carrelage>\
					 <fin_val_maxi_normalis_carrelage>255</fin_val_maxi_normalis_carrelage>\
					 <debut_canaux_normalis_carrelage>1</debut_canaux_normalis_carrelage>\
					 <fin_canaux_normalis_carrelage>1</fin_canaux_normalis_carrelage>\
					 <debut_taille_larg_grille_fantaisie>10</debut_taille_larg_grille_fantaisie>\
					 <fin_taille_larg_grille_fantaisie>10</fin_taille_larg_grille_fantaisie>\
					 <debut_taille_haut_grille_fantaisie>10</debut_taille_haut_grille_fantaisie>\
					 <fin_taille_haut_grille_fantaisie>10</fin_taille_haut_grille_fantaisie>\
					 <debut_coordx_puzzle_geometric>6</debut_coordx_puzzle_geometric>\
					 <fin_coordx_puzzle_geometric>6</fin_coordx_puzzle_geometric>\
					 <debut_profondeur_mise_en_abyme>20</debut_profondeur_mise_en_abyme>\
					 <fin_profondeur_mise_en_abyme>20</fin_profondeur_mise_en_abyme>\
					 <debut_intensite_mise_en_abyme>60</debut_intensite_mise_en_abyme>\
					 <fin_intensite_mise_en_abyme>60</fin_intensite_mise_en_abyme>\
					 <debut_decalage_largeur_mise_en_abyme>50</debut_decalage_largeur_mise_en_abyme>\
					 <fin_decalage_largeur_mise_en_abyme>50</fin_decalage_largeur_mise_en_abyme>\
					 <debut_opacite_mise_en_abyme>40</debut_opacite_mise_en_abyme>\
					 <fin_opacite_mise_en_abyme>40</fin_opacite_mise_en_abyme>\
					 <debut_flou_abstract_multicolor_1>1</debut_flou_abstract_multicolor_1>\
					 <fin_flou_abstract_multicolor_1>1</fin_flou_abstract_multicolor_1>\
					 <debut_repet_abstract_multicolor_1>500</debut_repet_abstract_multicolor_1>\
					 <fin_repet_abstract_multicolor_1>500</fin_repet_abstract_multicolor_1>\
					 <debut_iteration_abstract_multicolor_1>20</debut_iteration_abstract_multicolor_1>\
					 <fin_iteration_abstract_multicolor_1>20</fin_iteration_abstract_multicolor_1>\
					 <debut_flou_cartographie>300</debut_flou_cartographie>\
					 <fin_flou_cartographie>300</fin_flou_cartographie>\
					 <debut_seuil_cartographie>84</debut_seuil_cartographie>\
					 <fin_seuil_cartographie>84</fin_seuil_cartographie>\
					 <debut_flou_niv_topographie>42</debut_flou_niv_topographie>\
					 <fin_flou_niv_topographie>42</fin_flou_niv_topographie>\
					 <debut_rayon_pochoir_figuration_libre_2>160</debut_rayon_pochoir_figuration_libre_2>\
					 <fin_rayon_pochoir_figuration_libre_2>160</fin_rayon_pochoir_figuration_libre_2>\
					 <debut_douceur_pochoir_figuration_libre_2>30</debut_douceur_pochoir_figuration_libre_2>\
					 <fin_douceur_pochoir_figuration_libre_2>30</fin_douceur_pochoir_figuration_libre_2>\
					 <debut_iterations_figuration_libre_2>8</debut_iterations_figuration_libre_2>\
					 <fin_iterations_figuration_libre_2>8</fin_iterations_figuration_libre_2>\
					 <debut_aliasing_figuration_libre_2>1</debut_aliasing_figuration_libre_2>\
					 <fin_aliasing_figuration_libre_2>1</fin_aliasing_figuration_libre_2>\
					 <debut_type_figuration_libre_2>3</debut_type_figuration_libre_2>\
					 <fin_type_figuration_libre_2>3</fin_type_figuration_libre_2>\
					 <debut_amplitude_rodilius>840</debut_amplitude_rodilius>\
					 <fin_amplitude_rodilius>840</fin_amplitude_rodilius>\
					 <debut_epaisseur_rodilius>200</debut_epaisseur_rodilius>\
					 <fin_epaisseur_rodilius>200</fin_epaisseur_rodilius>\
					 <debut_finesse_rodilius>100</debut_finesse_rodilius>\
					 <fin_finesse_rodilius>100</fin_finesse_rodilius>\
					 <debut_orientations_rodilius>5</debut_orientations_rodilius>\
					 <fin_orientations_rodilius>5</fin_orientations_rodilius>\
					 <debut_courbure_rodilius>30</debut_courbure_rodilius>\
					 <fin_courbure_rodilius>30</fin_courbure_rodilius>\
					 <debut_eff_spec_amp_turb_eau_1>1200</debut_eff_spec_amp_turb_eau_1>\
					 <fin_eff_spec_amp_turb_eau_1>1200</fin_eff_spec_amp_turb_eau_1>\
					 <debut_eff_spec_amp_turb_eau_2>3000</debut_eff_spec_amp_turb_eau_2>\
					 <fin_eff_spec_amp_turb_eau_2>3000</fin_eff_spec_amp_turb_eau_2>\
					 <debut_eff_spec_douc_turb_eau_2>150</debut_eff_spec_douc_turb_eau_2>\
					 <fin_eff_spec_douc_turb_eau_2>150</fin_eff_spec_douc_turb_eau_2>\
					 <debut_fact_zoom_avant>100</debut_fact_zoom_avant>\
					 <fin_fact_zoom_avant>100</fin_fact_zoom_avant>\
					 <debut_pos_horizontale_fact_zoom_avant>50</debut_pos_horizontale_fact_zoom_avant>\
					 <fin_pos_horizontale_fact_zoom_avant>50</fin_pos_horizontale_fact_zoom_avant>\
					 <debut_pos_verticale_fact_zoom_avant>50</debut_pos_verticale_fact_zoom_avant>\
					 <fin_pos_verticale_fact_zoom_avant>50</fin_pos_verticale_fact_zoom_avant>\
                    </image_filtres_image>\
                    <image_masque_alpha_3d>\
                        <methode>methode1</methode>\
                        <masque>masque_alpha</masque>\
                        <qualite>bonne</qualite>\
                        <nettete>par_defaut</nettete>\
                        <reglage>fond_bleu</reglage>\
                        <forme_fond>fon_noir_for_blanch</forme_fond>\
                        <teinte_debut></teinte_debut>\
                        <saturation_debut></saturation_debut>\
                        <luminosite></luminosite>\
                        <saturation_fin></saturation_fin>\
                        <teinte_fin></teinte_fin>\
                    </image_masque_alpha_3d>\
                    <image_pour_le_web>\
                        <methode>gif_anime</methode>\
                        <nombre_morceaux_vertical></nombre_morceaux_vertical>\
                        <nombre_morceaux_horizontal></nombre_morceaux_horizontal>\
                        <nombre_couleurs></nombre_couleurs>\
                        <nouvelle_largeur></nouvelle_largeur>\
                        <delai></delai>\
                        <haut_carte_et_reflex>5000</haut_carte_et_reflex>\
                        <attenuation_carte_et_reflex>100</attenuation_carte_et_reflex>\
                        <ampl_vagues_carte_et_reflex>1</ampl_vagues_carte_et_reflex>\
                        <douc_vagues_carte_et_reflex>1</douc_vagues_carte_et_reflex>\
                        <angl_vert_carte_et_reflex>1000</angl_vert_carte_et_reflex>\
                        <angl_horiz_carte_et_reflex>1300</angl_horiz_carte_et_reflex>\
                        <focale_carte_et_reflex>500</focale_carte_et_reflex>\
                    </image_pour_le_web>\
                    <image_redimensionner>\
                        <methode>gif_anime</methode>\
                        <largeur_ratio></largeur_ratio>\
                        <largeur_sans_ratio></largeur_sans_ratio>\
                        <longueur_sans_ratio></longueur_sans_ratio>\
                    </image_redimensionner>\
                    <image_changer_format>\
                        <format>.jpg</format>\
                    </image_changer_format>\
                    <image_planche-contact>\
                        <format>.jpg</format>\
                        <orientation>form_port</orientation>\
					 <taille>taille_planche_842x595</taille>\
                        <couleur_fond>blanc</couleur_fond>\
                        <passage_image>1</passage_image>\
                        <largeur_marge>10</largeur_marge>\
                        <nombre_images_largeur>4</nombre_images_largeur>\
                        <nombre_images_longueur>6</nombre_images_longueur>\
                    </image_planche-contact>\
                    <image_multiplication>\
                        <mult_duree_sec></mult_duree_sec>\
                        <mult_nbre_img_sec></mult_nbre_img_sec>\
                        <mult_format_ext>.jpg</mult_format_ext>\
                        <mult_action_a_effectuer></mult_action_a_effectuer>\
                    </image_multiplication>\
                    <image_image_composite>\
                    </image_image_composite>\
                    <image_transition_spirale>\
                    </image_transition_spirale>\
                    <image_transition_fondu>\
                    </image_transition_fondu>\
                    <image_renommer>\
                        <increment>1</increment>\
                        <classement></classement>\
                    </image_renommer>\
                    <son_musique_encodage>\
                        <format>wav</format>\
                    </son_musique_encodage>\
                    <son_joindre_multiple_fichier_audio>\
                        <format>wav</format>\
                    </son_joindre_multiple_fichier_audio>\
                    <son_normaliser_convertir_musique_ou_son>\
                        <format>wav</format>\
                    </son_normaliser_convertir_musique_ou_son>\
                    <son_decoupe_musiques_et_sons>\
                        <format>wav</format>\
                    </son_decoupe_musiques_et_sons>\
				  <videoporamaconfig>\
					 <imgmgkdir>/usr/bin/</imgmgkdir>\
					 <mjpegtoolsdir>/usr/bin/</mjpegtoolsdir>\
					 <soxdir>/usr/bin/</soxdir>\
					 <time>5</time>\
					 <typet>1</typet>\
					 <speedt>2</speedt>\
					 <bgcolor>0</bgcolor>\
				  </videoporamaconfig>\
            </ekdconfig>"
        


    def init(configPath = None):
        if not configPath:
            configPath = EkdConfig.defaultLocation

        EkdConfig.initVars()
        EkdConfig.location = configPath
        EkdConfig.creationFichierConf()
        EkdConfig.configuration = minidom.parseString(EkdConfig.defaultConf.encode("utf8"))
        EkdConfig.completerFichierConf()

    init = staticmethod(init)

    def initVars():
        ### Sections de la configuration
        EkdConfig.SECTIONS = {
            u"general" : _(u"Général"),
            u"animation_encodage_general" : _(u"Vidéo:Encodage général"),
            u"animation_encodage_web" : _(u"Vidéo:Encodage Web"),
            u"animation_encodage_hd" : _(u"Vidéo:Encodage HD"),
            u"animation_filtresvideo" : _(u"Vidéo:Filtres"),
            u"animation_montage_video_seul": _(u"Vidéo:Montage vidéo seulement"),
            u"animation_montage_video_et_audio": _(u"Vidéo:Montage vidéo et audio"),
            u"animation_decouper_une_video" : _(u"Vidéo:Découpage d'une vidéo"),
            u"animation_separer_audio_et_video": _(u"Vidéo:Séparation audio-vidéo"),
            u"animation_convertir_des_images_en_video" : _(u"Vidéo:Conversion d'images en vidéo"),
            u"animation_convertir_une_video_en_images" : _(u"Vidéo:Conversion d'une vidéo en images"),
            u"animation_reglages_divers": _(u"Vidéo:Nombre d'image par seconde"),
            u"animation_conversion_video_16_9_4_3" : _(u"Vidéo:Convertir une vidéo en 16/9 ou 4/3"),
            u"videoporamaconfig" : _(u"Vidéo:Diaporama d'images en vidéo"),
            u"image_planche-contact": _(u"Image:Planche contact"),
            u"image_changer_format": _(u"Image:Changer de format"),
            u"image_redimensionner" : _(u"Image:Redimension"),
            u"image_renommer": _(u"Image:Renommage d'images"),
            u"image_pour_le_web" : _(u"Image:Pour le Web "),
            u"image_multiplication": _(u"Image:Multiplication d'images"),
            u"image_filtres_image": _(u"Image:Filtres d'images"),
            u"image_masque_alpha_3d" : _(u"Image:Masque alpha 3D"),
            u"image_image_composite" : _(u"Image:Image composite"),
            u"image_transition_fondu" : _(u"Image:Transition fondu enchainé"),
            u"image_transition_spirale" : _(u"Image:Transition spirale"),
            u"son_musique_encodage": _(u"Audio:Transcodage audio"),
            u"son_joindre_multiple_fichier_audio": _(u"Audio:Joindre plusieurs fichiers audio"),
            u"son_decoupe_musiques_et_sons" : _(u"Audio:Découpe dans un fichier audio"),
            u"son_normaliser_convertir_musique_ou_son": _(u"Audio:Nomaliser et convertir un fichier audio")
            }
        ### Sections de la configuration
        EkdConfig.PROPERTIES = {
            u"charger_split": _(u"Charger la disposition des fenêtres"),
            u"display_mode": _(u"Mode d'affichage"),
            u"show_warning_messages": _(u"Voir les avertissements"),
            u"effacer_config": _(u"Réinitialiser la configuration"),
            u"boite_de_dialogue_de_fermeture": _(u"Confirmer la sauvegarde avant fermeture"),
            u'sauvegarder_parametres': _(u"Sauvegarder les paramêtres"),
            u"temporaire": _(u"Répertoire temporaire"),
            u"video_input_path": _(u"Répertoire de chargement des vidéos"),
            u"sound_input_path": _(u"Répertoire de chargement des sons"),
            u"image_input_path": _(u"Répertoire de chargement des images"),
            u"video_output_path": _(u"Répertoire de sauvegarde des vidéos"),
            u"sound_output_path": _(u"Répertoire de sauvegarde des sons"),
            u"image_output_path": _(u"Répertoire de sauvegarde des images"),
            u"show_hidden_files": _(u"Afficher les fichiers cachés"),
            u"imgmgkdir": _(u"Répertoire de ffmpeg"), u"soxdir": _(u"Répertoire de SoX"),
            u"mjpegtoolsdir": _(u"Répertoire de mjpegtools"),
	    u"codec_shockwave_swf_ffmpeg": _(u"ShockwaveSwf"),
            u"macromediaflashvideo": _(u"MacroMediaFlash"),
	    u"codec_transport_stream_ts_ffmpeg": _(u"TransportStream"),
            u"codecmpeg1": _(u"Mpeg1"),  u"codecwmv2": _(u"WMV2"),
            u"codecmpeg2": _(u"Mpeg2"), u"codecdivx4": _(u"Divx4"),
            u"codecmotionjpeg": _(u"Motion Jpeg"), u"codecoggtheora": _(u"Ogg Theora"),
            u"codec_vob_ffmpeg": _(u"FFMpeg"), u"mult_nbre_img_sec": _(u"Nombre d'images par seconde"),
            u"mult_duree_sec": _(u"Durée"), u"nbr_img_sec": _(u"Nombre d'images par seconde"),
            u"nbr_img_sec_mpeg1video": _(u"Nombre d'images par seconde"), u"increment": _(u"Incrémentation") ,
            u"delai": _(u"Délai"), u"nombre_couleurs": _(u"Nomde de couleurs"), u"nombre_morceaux_horizontal": _(u"Nombre de morceaux horizontal"),
            u"nombre_morceaux_vertical": _(u"Nombre de morceaux vertical"),
            u"nouvelle_largeur": _(u"Nouvelle largeur"), u"spin": _(u"Spin"), u"largeur_sans_ratio": _(u"Largeur sans ratio"),
            u"longueur_sans_ratio": _(u"Longueur sans ratio"),
            u"largeur_ratio": _(u"Largeur avec ratio"), u"valeur_bruit_luma": _(u"Valeur du bruit luma"),
            u"valeur_bruit_chroma": _(u"Valeur du bruit chroma"), u"luminosite": _(u"Luminosité"),
            u"contraste": _(u"Contraste"), u"decouper_largeur": _(u"Découper la largeur"), u"decouper_hauteur": _(u"Découper la hauteur"),
            u"decouper_position_largeur": _(u"Découper la position en largeur"),
            u"decouper_position_hauteur": _(u"Découper la position en hauteur"), u"couleur": _(u"Couleur"), u"saturation": _(u"Saturation"),
            u"flou_boite_rayon": _(u"Rayon du flou"),
            u"flou_boite_puissance": _(u"Puissance"), u"resolution_redim_largeur": _(u"Redimention largeur"),
                                                        u"resolution_redim_hauteur": _(u"Redimention hauteur"),
            u"contraste_couleur": _(u"Contraste"), u"sepia": _(u"Sepia"), u"charcoal_traits_noirs": _(u"Traits noirs"), u"edge": _(u"Edge"),
            u"huile": _(u"Huile"), u"gamma": _(u"Gamma"), u"fonce_clair": _(u"Foncé clair"), u"liquidite": _(u"Liquidité"),
            u"bas_relief": _(u"Bas relief"), u"charcoal_crayon": _(u"Crayon charcoal"), u"spread_crayon": _(u"Crayon spread"),
            u"radius": _(u"Rayon"), u"sigma": _(u"Sigma"), u"precision_trait": _(u"Précision du trait"),
            u"largeur_trait": _(u"Largeur du trait"), u"seuillage_bas": _(u"Seuillage bas"), u"seuillage_haut": _(u"Seuillage haut"),
            u"intensite_du_trait": _(u"Intensité du trait"), u"reduction_couleur": _(u"Réduction de la couleur"),
            u"peinture_huile": _(u"Peinture à l'huile"), u"passage_image": _(u"Passage de l'image"),
            u"largeur_marge": _(u"Largeur de l'image"), u"nombre_images_largeur": _(u"Nombre d'images en largeur"),
            u"nombre_images_longueur": _(u"Nombre d'images en longueur"), u"time": _(u"Temps"),
            u"typet": _(u"Type transition"), u"speedt": _(u"Vitesse de transition"),
            u"reso3gp": _(u"Résolution pour le codec 3gp"),
            u"resoamv": _(u"Résolution pour le codec amv"),
            u"qtstyle": _(u"Style QT"), u"codec": _(u"Codec"),
            u"bgcolor": _(u"Couleur de fond"), u"couleur_11": _(u"Couleur 11"), u"couleur_12": _(u"Couleur 12"),
            u"couleur_13": _(u"Couleur 13"), u"couleur_21": _(u"Couleur 21"), u"couleur_22": _(u"Couleur 22"),
            u"couleur_23": _(u"Couleur 23"), u"couleur_31": _(u"Couleur 31"),
            u"couleur_32": _(u"Couleur 32"), u"couleur_33": _(u"Couleur 33"),
            u"taille_mini_forme": _(u"Taille minimale"), u"taille_maxi_forme": _(u"Taille maximale"),
            u"coul_omb_lum_a_la_coul_11": _(u"Ombre Couleur 11"), u"coul_omb_lum_a_la_coul_12": _(u"Ombre Couleur 12"),
            u"coul_omb_lum_a_la_coul_21": _(u"Ombre Couleur 21"),
            u"coul_omb_lum_a_la_coul_22": _(u"Ombre Couleur 22"),
            u"coul_omb_lum_a_la_coul_31": _(u"Ombre Couleur 31"),
            u"coul_omb_lum_a_la_coul_32": _(u"Ombre Couleur 32"),
            u"coul_omb_lum_a_la_coul_41": _(u"Ombre Couleur 41"),
            u"coul_omb_lum_a_la_coul_42": _(u"Ombre Couleur 42"),
            u"coul_contour_couleur_00": _(u"Contour couleur 00"),
            u"coul_contour_couleur_11": _(u"Contour couleur 11"),
            u"coul_contour_couleur_12": _(u"Contour couleur 12"),
            u"coul_contour_couleur_13": _(u"Contour couleur 13"),
            u"coul_contour_couleur_21": _(u"Contour couleur 21"),
            u"coul_contour_couleur_22": _(u"Contour couleur 22"),
            u"coul_contour_couleur_23": _(u"Contour couleur 23"),
            u"coul_contour_couleur_31": _(u"Contour couleur 31"),
            u"coul_contour_couleur_32": _(u"Contour couleur 32"),
            u"coul_contour_couleur_33": _(u"Contour couleur 33"),
            u"coul_contour_couleur_41": _(u"Contour couleur 41"),
            u"coul_contour_couleur_42": _(u"Contour couleur 42"),
            u"coul_contour_couleur_43": _(u"Contour couleur 43"),
            u"ignore_case": _(u"Tri sensible à la casse"),
            u"interval_speed": _(u"Vitesse de lecture des images (ms)"),
            u"mkvvideo": _(u"Codec Vidéo Matroska"),
            u"mkvaudio": _(u"Codec Audio Matroska"),
	    u"dvd_mode": _(u"Codec DVD Mode"),
	    u"dvd_apparence": _(u"Codec DVD Apparence"),
	    u"choix_desentrelacement_ffmpeg": _(u"Choix du desentrelacement"),
	    u"choix_desentrelacement_mencoder_particulier": _(u"Choix du desentrelacement"),
	    u"choix_desentrelacement_mencoder_tous": _(u"Choix du desentrelacement"),
            u"taille_video_general_ffmpeg": _(u"Dimension de la vidéo"),
            u"taille_video_general_mencoder": _(u"Dimension de la vidéo"),
            u"taille_video_avi_raw_mencoder": _(u"Dimension de la vidéo"),
            u"taille_video_xvid_mencoder": _(u"Dimension de la vidéo")
            }

        ## Chk ne peut pas être enlevé car utilisé dans vidéoporama, il faut supprimer les référence de cette
        ## option dans videoporama avant de pouvoir la retirer - Travail effectué -> chk retiré
        EkdConfig.PROPERTIES_MASK = [ u"sources", u"codec", u"chk", u"sauvegarder_parametres" ]
        if os.name == 'nt':
            EkdConfig.PROPERTIES_MASK.extend([u"imgmgkdir", u"mjpegtoolsdir", u"soxdir", u"show_hidden_files"])
        EkdConfig.SECTION_MASK = [
            u"animation_encodage_general", u"animation_encodage_web", u"animation_encodage_hd",
            u"animation_filtresvideo", u"animation_montage_video_seul",
            u"animation_montage_video_et_audio", u"animation_decouper_une_video" ,
            u"animation_separer_audio_et_video", u"animation_convertir_des_images_en_video" ,
            u"animation_convertir_une_video_en_images", u"animation_reglages_divers",
            u"animation_conversion_video_16_9_4_3", u"image_planche-contact",
            u"image_changer_format", u"image_redimensionner", u"image_renommer",u"image_image_composite",
            u"image_transition_fondu", u"image_transition_spirale", u"image_pour_le_web", u"image_multiplication",
            u"image_filtres_image",  u"image_masque_alpha_3d", u"son_musique_encodage",
            u"son_joindre_multiple_fichier_audio",  u"son_decoupe_musiques_et_sons",
            u"son_normaliser_convertir_musique_ou_son"
            ]

        EkdConfig.BOOLEAN_PROPERTIES = [ u"charger_split", u"effacer_config", u"boite_de_dialogue_de_fermeture",
                               u'sauvegarder_parametres', u"show_hidden_files", u"show_warning_messages", u"ignore_case" ]

        EkdConfig.STYLE_PROPERTIES = { u"qtstyle": map(str, QStyleFactory.keys()),
                                       u"codec" : ['copie', 'avirawsanscompression', 'codec_dv_ffmpeg',
                                                   'codec_mov_ffmpeg', 'codec_hfyu_ffmpeg', 'codecmotionjpeg',
                                                   'codecoggtheora', 'codec_vob_ffmpeg', 'codecmpeg2',
                                                   'codech264mpeg4', 'codech264mpeg4_ext_h264', 'codecxvid',
                                                   'codecdivx4', 'codecmpeg1', 'macromediaflashvideo',
                                                   'codecwmv2', 'codec_3GP_ffmpeg', 'codec_AMV_ffmpeg'],
                                       u"display_mode": [ "auto", "1280x800", "1024x768", "1024x600", "800x600", "800x480"]
                                       }
        
	# Le désentrelacement est à gérer dans les fichiers: gui_modules_animation/animation_encodage_general.py
	#  (fonction desentrelacementParticulierMencoder) et moteur_modules_common/EkdConfig.py (ici)
	# Pour le désentrelacement avec Mencoder, voir: http://forum.doom9.org/archive/index.php/t-163989.html

	EkdConfig.CODEC_PROPERTIES = {
            u"reso3gp": [u'128x96', u'176x144', u'352x288',  u'704x576'],
            u"resoamv": [u'128x90', u'128x128', u'160x120',  u'208x176'],
            u"taille_video_general_ffmpeg": [u'', u'-s 3840x2160 -aspect 16:9', u'-s 4096x2160 -aspect 1.8962962962962964', u'-s 4096x1716 -aspect 2.386946386946387', u'-s 3996x2160 -aspect 1.85', u'-s 2716x1524 -aspect 1.7821522309711286', u'-s 2716x1440 -aspect 1.886111111111111', u'-s 2048x1080 -aspect 1.8962962962962964', u'-s 2048x858 -aspect 2.386946386946387', u'-s 1998x1080 -aspect 1.85', u'-s 1920x1440 -aspect 4:3', u'-s 1920x1080 -aspect 16:9', u'-s 1280x720 -aspect 16:9', u'-s 960x540 -aspect 16:9', u'-s 854x480 -aspect 16:9', u'-s 1024x576 -aspect 16:9', u'-s 768x576 -aspect 4:3', u'-s scale=720:576', u'-s 384x288 -aspect 4:3', u'-s 352x288', u'-s 320x240 -aspect 4:3', u'-s 720x480', u'-s 640x480 -aspect 4:3', u'-s 512x384 -aspect 4:3', u'-s 480x480', u'-s 352x240', u'-s 7680x4800', u'-s 6400x4096', u'-s 5120x4096', u'-s 3840x2400', u'-s 3200x2048', u'-s 2560x2048', u'-s 2560x1600', u'-s 2048x1536 -aspect 4:3', u'-s 1920x1200', u'-s 1600x1024', u'-s 1366x768 -aspect 16:9', u'-s 1280x1024', u'-s 1600x1200 -aspect 4:3', u'-s 1024x768 -aspect 4:3', u'-s 800x600 -aspect 4:3', u'-s 640x350', u'-s 640x480 -aspect 4:3', u'-s 160x120 -aspect 4:3', u'-s 800x480 -aspect 16:10'], \
            u"taille_video_general_mencoder": [u'', u'-vf scale=3840:2160', u'-vf scale=4096:2160', u'-vf scale=4096:1716', u'-vf scale=3996:2160', u'-vf scale=2716:1524', u'-vf scale=2716:1440', u'-vf scale=2048:1080', u'-vf scale=2048:858', u'-vf scale=1998:1080', u'-vf scale=1920:1440', u'-vf scale=1920:1080', u'-vf scale=1280:720', u'-vf scale=960:540', u'-vf scale=854:480', u'-vf scale=1024:576', u'-vf scale=768:576', u'-vf scale=720:576', u'-vf scale=384:288', u'-vf scale=352:288', u'-vf scale=320:240', u'-vf scale=720:480', u'-vf scale=640:480', u'-vf scale=512:384', u'-vf scale=480:480', u'-vf scale=352:240', u'-vf scale=7680:4800', u'-vf scale=6400:4096', u'-vf scale=5120:4096', u'-vf scale=3840:2400', u'-vf scale=3200:2048', u'-vf scale=2560:2048', u'-vf scale=2560:1600', u'-vf scale=2048:1536', u'-vf scale=1920:1200', u'-vf scale=1600:1024', u'-vf scale=1366:768', u'-vf scale=1280:1024', u'-vf scale=1600:1200', u'-vf scale=1024:768', u'-vf scale=800:600', u'-vf scale=640:350', u'-vf scale=640:480', u'-vf scale=160:120', u'-vf scale=800:480'], \
            u"taille_video_avi_raw_mencoder": [u'', u'scale=3840:2160,', u'scale=4096:2160,', u'scale=4096:1716,', u'scale=3996:2160,', u'scale=2716:1524,', u'scale=2716:1440,', u'scale=2048:1080,', u'scale=2048:858,', u'scale=1998:1080,', u'scale=1920:1440,', u'scale=1920:1080,', u'scale=1280:720,', u'scale=960:540,', u'scale=854:480,', u'scale=1024:576,', u'scale=768:576,', u'scale=720:576,', u'scale=384:288,', u'scale=352:288,', u'scale=320:240,', u'scale=720:480,', u'scale=640:480,', u'scale=512:384,', u'scale=480:480,', u'scale=352:240,', u'scale=7680:4800,', u'scale=6400:4096,', u'scale=5120:4096,', u'scale=3840:2400,', u'scale=3200:2048,', u'scale=2560:2048,', u'scale=2560:1600,', u'scale=2048:1536,', u'scale=1920:1200,', u'scale=1600:1024,', u'scale=1366:768,', u'scale=1280:1024,', u'scale=1600:1200,', u'scale=1024:768,', u'scale=800:600,', u'scale=640:350,', u'scale=640:480,', u'scale=160:120,', u'scale=800:480,'],\
	    u"taille_video_xvid_mencoder": [u'', u'-vf scale=3840:2160', u'-vf scale=4096:2160', u'-vf scale=4096:1716', u'-vf scale=3996:2160', u'-vf scale=2716:1524', u'-vf scale=2716:1440', u'-vf scale=2048:1080', u'-vf scale=2048:858', u'-vf scale=1998:1080', u'-vf scale=1920:1440', '-vf scale=1920:1080', '-vf scale=1280:720', '-vf scale=960:540', '-vf scale=854:480', '-vf scale=1024:576', '-vf scale=768:576', '-vf scale=720:576', '-vf scale=384:288', '-vf scale=352:288', '-vf scale=320:240', '-vf scale=720:480', '-vf scale=640:480', '-vf scale=512:384', '-vf scale=480:480', '-vf scale=352:240', '-vf scale=7680:4800', '-vf scale=6400:4096', '-vf scale=5120:4096', '-vf scale=3840:2400', '-vf scale=3200:2048', '-vf scale=2560:2048', '-vf scale=2560:1600', '-vf scale=2048:1536', '-vf scale=1920:1200', '-vf scale=1600:1024', '-vf scale=1366:768', '-vf scale=1280:1024', '-vf scale=1600:1200', '-vf scale=1024:768', '-vf scale=800:600', '-vf scale=640:350', '-vf scale=640:480', '-vf scale=160:120', '-vf scale=800:480'],\
            u"choix_desentrelacement_ffmpeg": [u"", u"-vf yadif"],
	    u"choix_desentrelacement_mencoder_particulier": [u"", u"-vf yadif=0"],
	    u"choix_desentrelacement_mencoder_tous": [u"", u",yadif=0"],
	    u"mkvaudio":[ u'', u'pcm_s16be', u'flac', u'ac3', u'mp2', u'vorbis', u'wmav2', u'wmav2', u'libmp3lame'],
            u"mkvvideo": [ u'', u'ffv1', u'mpeg2video', u'h263p', u'mpeg4', u'msmpeg4v2', u'mpeg1video', u'wmv2'],
	    u"dvd_mode": [u'-target pal-dvd', u'-target ntsc-dvd'],
	    u"dvd_apparence": [u'', u' 4:3', u' 16:9'],
            u"speedt": [u'Très lent', u'Lent', u'Moyen', u'Moyen+', u'Rapide', u'Très rapide'],
            u"typet": [u'Aucun', u'Fondu', u'Apparaît', u'Disparaît', u'Slide', u'Cube', u'Pousser', u'Luma'] }

        EkdConfig.PATH_PROPERTIES = [ u"temporaire", u"video_input_path", u"sound_input_path", u"image_input_path",
                                      u"video_output_path", u"sound_output_path", u"image_output_path",
                                      u"imgmgkdir", u"soxdir", u"mjpegtoolsdir"]

        EkdConfig.COLOR_PROPERTIES = [ u"bgcolor", u"couleur_11", u"couleur_12",
                                       u"couleur_13", u"couleur_21", u"couleur_22", u"couleur_23", u"couleur_31",
                                       u"couleur_32", u"couleur_33", u"taille_mini_forme", u"taille_maxi_forme",
                                       u"coul_omb_lum_a_la_coul_11", u"coul_omb_lum_a_la_coul_12", u"coul_omb_lum_a_la_coul_21",
                                       u"coul_omb_lum_a_la_coul_22", u"coul_omb_lum_a_la_coul_31", u"coul_omb_lum_a_la_coul_32",
                                       u"coul_omb_lum_a_la_coul_41", u"coul_omb_lum_a_la_coul_42",
                                       u"coul_contour_couleur_00", u"coul_contour_couleur_11", u"coul_contour_couleur_12",
                                       u"coul_contour_couleur_13", u"coul_contour_couleur_21", u"coul_contour_couleur_22",
                                       u"coul_contour_couleur_23", u"coul_contour_couleur_31", u"coul_contour_couleur_32",
                                       u"coul_contour_couleur_33", u"coul_contour_couleur_41", u"coul_contour_couleur_42",
                                       u"coul_contour_couleur_43"]

        EkdConfig.NUM_PROPERTIES = [ u"macromediaflashvideo", u"codecmpeg1", u"codecmpeg2", u"codecdivx4", u"codecwmv2",
                           u"codecmotionjpeg", u"codecoggtheora", u"codec_vob_ffmpeg", u"mult_nbre_img_sec",
                           u"mult_duree_sec", u"nbr_img_sec", u"nbr_img_sec_mpeg1video", u"increment", u"delai",
                           u"nombre_couleurs", u"nombre_morceaux_horizontal", u"nombre_morceaux_vertical",
                           u"nouvelle_largeur", u"spin", u"largeur_sans_ratio", u"longueur_sans_ratio",
                           u"largeur_ratio", u"valeur_bruit_luma", u"valeur_bruit_chroma", u"luminosite",
                           u"contraste", u"decouper_largeur", u"decouper_hauteur", u"decouper_position_largeur",
                           u"decouper_position_hauteur", u"couleur", u"saturation", u"flou_boite_rayon",
                           u"flou_boite_puissance", u"resolution_redim_largeur", u"resolution_redim_hauteur",
                           u"contraste_couleur", u"sepia", u"charcoal_traits_noirs", u"edge",
                           u"huile", u"gamma", u"fonce_clair", u"liquidite", u"bas_relief",
                           u"charcoal_crayon", u"spread_crayon", u"radius", u"sigma", u"precision_trait",
                           u"largeur_trait", u"seuillage_bas", u"seuillage_haut", u"intensite_du_trait",
                           u"reduction_couleur", u"peinture_huile", u"passage_image",
                           u"largeur_marge", u"nombre_images_largeur", u"nombre_images_longueur",
                           u"time" ]

        EkdConfig.TIME_PROPERTIES = [ u"interval_speed" ]
    initVars = staticmethod(initVars)

    def creationFichierConf(config=None):
        """
        Crée le fichier de configuration s'il n'existe pas, on le crée
        """
        if not config:
            config = EkdConfig.defaultLocation
        try:
            file(config)
        except:
            configdir = os.path.dirname(config)
            if not os.path.isdir(configdir):
                os.makedirs(configdir)
            default = EkdConfig.newSection("ekdconfig")
            fd=open(config,'w')
            fd.write(default.toprettyxml(encoding=EkdConfig.coding))
            fd.close()
    creationFichierConf = staticmethod(creationFichierConf)

    def completerConf(config):
        """
        On sépare la gestion de la complétion de la configuration
        """

        for mainsec in EkdConfig.configuration.childNodes[0].childNodes:
            # Pour chacune des sections par défaut
            for section in mainsec.childNodes:
                sectionName = section.parentNode.tagName.strip()

                # Est-ce que la section existe dans le fichier de conf ?
                try:
                    EkdConfig.getConfigSection(sectionName, config)
                except:
                    EkdPrintConfig(u"DEBUG:: On crée la section %s"% sectionName)
                    config.childNodes[0].appendChild(EkdConfig.newSection(sectionName))

                # Vérification des propriétés:
                #       * Récupérer l'ensemble des propriété par défaut
                #       * Pour chaque propriété de la conf par défaut, si la propriété n'existe pas dans la conf spécifiée, il faut la créer
                for option in section.childNodes: # est-ce que toutes les options existent?
                    optionName = option.parentNode.tagName.strip()
                    try:
                        EkdConfig.get(sectionName, optionName, config)
                    except:
                        try :
                            value = EkdConfig.get(sectionName, optionName).strip()
                        except:
                            EkdPrintConfig(u"Pb lors de la récupération de : %s - %s"% (sectionName, optionName) )
                        EkdPrintConfig(u"DEBUG:: Option non trouvée, on la définie à : %s"% value)
                        EkdConfig.set(sectionName, optionName, value, config)
    completerConf = staticmethod(completerConf)

    def completerFichierConf(configfile=None):
        """
        Si le fichier de configuration est incomplet on y ajoute des paramètres
        """

        if not configfile:
            configfile = EkdConfig.location
            EkdPrintConfig(u"DEBUG:: Completion du fichier de config : %s"% configfile)
        try:
            userConf = minidom.parse(configfile)
        except Exception, e:
            EkdPrintConfig(u"Probleme lors du parsing de la configuration : %s"% configfile)
            userConf = EkdConfig.configuration

        EkdConfig.completerConf(userConf)
        EkdConfig.configuration = userConf
        EkdConfig.save(configfile, EkdConfig.configuration)
    completerFichierConf = staticmethod(completerFichierConf)

    def save(configfile=None, config=None):
        """
        Sauve le fichier de configuration
        """
        if configfile == None :
            configfile = EkdConfig.location
        if config == None :
            config = EkdConfig.configuration

        ## Nettoyage avant écriture
        EkdConfig.cleanConfig("\t", "\n", config)
        try :
            fd=open(configfile,'w')
            fd.write(config.toprettyxml(encoding=EkdConfig.coding))
            fd.close()
        except Exception, e:
            EkdPrintConfig(u"Erreur lors de la sauvegarde du fichier de configuration : %s"% configfile)
            raise e
    save = staticmethod(save)


    def cleanConfig(indent="",newl="", config=None):
        '''
        Cette fonction permet de nettoyer, des espaces supplémentaires, la configuration avant de l'écrire
        '''
        if config == None :
            config = EkdConfig.configuration
        node=config.documentElement
        EkdConfig.cleanNode(node,indent,newl)
    cleanConfig = staticmethod(cleanConfig)

    def cleanNode(currentNode,indent,newl):
        '''
        Cette fonction permet de nettoyer, des espaces supplémentaires, des noeuds de la configuration avant de l'écrire
        '''
        filter=indent+newl
        if currentNode.hasChildNodes:
            for node in currentNode.childNodes:
                if node.nodeType == 3:
                    node.nodeValue = node.nodeValue.lstrip(filter).strip(filter)
                    if node.nodeValue == "":
                        currentNode.removeChild(node)
        for node in currentNode.childNodes:
            EkdConfig.cleanNode(node,indent,newl)
    cleanNode = staticmethod(cleanNode)


    def get(sectionName, proprieteName, config=None):
        """
        Renvoie la valeur de la propriété choisie dans la section donnée
        """
        if not config:
            config = EkdConfig.configuration
        try :
            domSection = EkdConfig.getConfigSection(sectionName, config)
            value = EkdConfig.getConfigPropriete(domSection, proprieteName).childNodes[0].data.strip()
            return unicode(value)
        except Exception, e :
            EkdPrintConfig(u"Erreur dans la récupération de la propriété : %s dans la section : %s"% (proprieteName, sectionName))
            raise e
    get = staticmethod(get)

    def set(sectionName, proprieteName, value, config=None):
        """
        Définie une nouvelle valeur pour la propriété donnée dans la section choisie
        """
        if config == None :
            config = EkdConfig.configuration
        try:
            domSection = EkdConfig.getConfigSection(sectionName, config)
        except:
            domSection = config.childNodes[0].childNodes[0].appendChild(EkdConfig.newSection(sectionName))
        try:
            oldProp = EkdConfig.getConfigPropriete(domSection, proprieteName)
        except:
            None

        newProp = EkdConfig.newPropriete(proprieteName, value)
        try:
            domSection.removeChild(oldProp)
        except:
            None
        domSection.appendChild(newProp)
    set = staticmethod(set)

    def newPropriete(proprieteName, value):
        """
        Crée une nouvelle propriété text Xml
        """
        try:
            doc = minidom.Document()
            prop = doc.createElement(proprieteName)
            val = doc.createTextNode(unicode(value))
            prop.appendChild(val)
            return prop
        except Exception, e:
            EkdPrintConfig(u"Erreur dans la création de la propriété : %s"% proprieteName)
            raise e
    newPropriete = staticmethod(newPropriete)

    def newSection(sectionName):
        """
        Crée une nouvelle section dans le fichier de configuration courant
        """
        doc = minidom.Document()
        section = doc.createElement(sectionName)
        return section
    newSection = staticmethod(newSection)

    def getConfigSection(sectionName, config=None):
        """
        Renvoie la section Xml correspondant au nom de section donnée
        """
        if not config:
            config = EkdConfig.configuration
        try:
            return config.getElementsByTagName(sectionName)[0]
        except Exception, e:
            EkdPrintConfig(u"Erreur dans la récupération de la section : %s"% sectionName)
            raise  e
    getConfigSection = staticmethod(getConfigSection)

    def getConfigPropriete(section, proprieteName):
        """
        Renvoie la propriété Xml de la section donnée
        """
        try:
            return section.getElementsByTagName(proprieteName)[0]
        except Exception, e:
            raise e
    getConfigPropriete = staticmethod(getConfigPropriete)

    def printConfig():
        """
        Affiche la sortie xml de la configuration actuelle
        """
        EkdPrintConfig(EkdConfig.configuration.toprettyxml(encoding=EkdConfig.coding))
    printConfig = staticmethod(printConfig)

    def getTempDir():
        """
        Renvoie le répertoire temporaire pour l'utilisateur courant
        """
        try :
            tmpBase = EkdConfig.get("general", "temporaire")
        except :
            tmpBase = unicode(QDir.homePath() + os.sep + 'ekd_tmp')
            EkdConfig.set("general", "temporaire", tmpBase)
        tmp = tmpBase + os.sep + "ekd_" + getpass.getuser()
        return unicode(tmp)
    getTempDir = staticmethod(getTempDir)

    def getAllProperties(section):
        """
        Renvoie un tableau associatif contenant l'ensemble des propriétés de la section
        en paramètre
        """
        sectionProperties = {}
        try:
            proprietes = section.getElementsByTagName("*")
        except Exception, e:
            raise e
        for prop in proprietes :
            try:
                sectionProperties[prop.tagName] = prop.childNodes[0].data.strip()
            except :
                sectionProperties[prop.tagName] = ""
        return sectionProperties
    getAllProperties = staticmethod(getAllProperties)

    def purge(config=None):
        """
        Supprime le fichier de configuration
        """
        if not config:
            config = EkdConfig.defaultLocation
        try:
            os.unlink(config)
        except OSError, e:
            EkdPrintConfig(_(u"Impossible de purger la configuration %s" % e))
    purge = staticmethod(purge)
