#!/usr/bin/python
# -*- coding: utf-8 -*-
"""
    EkdProcess permet de gérer les processus dans l'ensemble du code d'Ekd
"""

import subprocess, os


def EkdProcess( command, output = subprocess.PIPE, outputerr = subprocess.PIPE,
                stdinput = None, universal_newlines = True, bufsize = 0 ):
    """
        Fonction permettant de lancer un processus via subprocess.Popen
    """
    if os.name == 'nt' : # Adaptation du code pour la version Win créée avec py2exe
        if stdinput == None :
            stdinput =  file('nul','a')
        if output == None :
            output =  file('nul','a')
        if outputerr == None :
            outputerr =  file('nul','a')

    try:
        process = subprocess.Popen( command, shell = True, stdin = stdinput,
                                    stdout = output, stderr = outputerr,
                                    universal_newlines = universal_newlines,
                                    bufsize = bufsize,
                                    preexec_fn = os.setsid)
    except AttributeError :
        process = subprocess.Popen( command, shell = True, stdin = stdinput,
                                    stdout = output, stderr = outputerr,
                                    universal_newlines = universal_newlines,
                                    bufsize = bufsize)
    return process
    
    
def EkdSubprocessCall(command, shell = True):
    """
    Fonction pour le remplacement de os.system(commande) et utilisant subprocess
    Dans le fichier py concerné il faut d'abord importer cette fonction:
    from moteur_modules_common.EkdProcess import EkdProcess, EkdSubprocessCall
    La commande peut être ensuite définie comme ceci:
    p =  EkdSubprocessCall((la_commande+les_paramètres).encode(EkdConfig.coding))
    """
    if os.name == 'nt' :
        process = subprocess.call(command, stdin=file('nul','a'), stdout=file('nul','a'), stderr=file('nul','a'), shell = True)
    else :
        process = subprocess.call(command, shell = True)
	
