# -*- coding: utf-8 -*-
# This file is part of ekd - diaporama video module - This module is an integration of videoporama
# Videoporama is a program to make diaporama export in video file
# Copyright (C) 2007-2009  Olivier Ponchaut <opvg@edpnet.be>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.


from PyQt4.QtCore import *
from PyQt4.QtGui import *

class Ui_Videoporama(QWidget):
    def __init__(self,parent=None) :
        QWidget.__init__(self)
        vbox=QVBoxLayout(self)

        # frame function
        self.function=QGroupBox(parent)
        sizePolicy = QSizePolicy(QSizePolicy.Expanding, QSizePolicy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        self.function.setMinimumSize(QSize(400, 65))
        self.function.setMaximumSize(QSize(16777215, 65))
        self.function.setSizePolicy(sizePolicy)

        # Layout horizontal pour placer les boutons dans la groupBox
        hboxFunction=QHBoxLayout(self.function)
        # bouton fleche gauche
        self.actionMove_left = QToolButton(self.function)
        icon = QIcon()
        icon.addPixmap(QPixmap("Icones/gauche.png"), QIcon.Normal, QIcon.Off)
        self.actionMove_left.setIcon(icon)
        self.actionMove_left.setObjectName("actionMove_left")

        # bouton fleche droite
        self.actionMove_right = QToolButton(self.function)
        icon1 = QIcon()
        icon1.addPixmap(QPixmap("Icones/droite.png"), QIcon.Normal, QIcon.Off)
        self.actionMove_right.setIcon(icon1)
        self.actionMove_right.setObjectName("actionMove_right")

        # bouton serieBut
        self.serieBut = QToolButton(self.function)
        icon2 = QIcon()
        icon2.addPixmap(QPixmap("Icones/pictures.png"), QIcon.Normal, QIcon.Off)
        self.serieBut.setIcon(icon2)
        self.serieBut.setObjectName("serieBut")

        # ajout des boutons dans le layout horizontal
        hboxFunction.addWidget(self.actionMove_left)
        hboxFunction.addSpacing(4)
        hboxFunction.addWidget(self.actionMove_right)
        hboxFunction.addStretch(4)
        hboxFunction.addWidget(self.serieBut)
        hboxFunction.addStretch(50)


        # Ajout informations sur la durée du montage
        self.dureelab = QLabel()
        self.dureelab.setMinimumSize(QSize(140, 25))
        self.dureelab.setMaximumSize(QSize(300, 25))
        self.duration = QLabel()
        self.duration.setMinimumSize(QSize(140, 25))
        self.duration.setMaximumSize(QSize(300, 25))
        hboxFunction.addWidget(self.dureelab)
        hboxFunction.addSpacing(4)
        hboxFunction.addWidget(self.duration)      

        # Ajout du cadre fonction au layout vertical général
        vbox.addWidget(self.function)

        # Timeline 
        self.timeline = QTableWidget(parent)
        sizePolicy = QSizePolicy(QSizePolicy.Expanding, QSizePolicy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(80)
        sizePolicy.setHeightForWidth(self.timeline.sizePolicy().hasHeightForWidth())
        self.timeline.setSizePolicy(sizePolicy)
        self.timeline.setMinimumSize(QSize(400, 80))
        self.timeline.setMaximumSize(QSize(16777215, 80))
        self.timeline.setObjectName("timeline")
        self.timeline.setColumnCount(0)
        self.timeline.setRowCount(1)
        self.timeline.horizontalHeader().hide()
        self.timeline.verticalHeader().hide()

        # Ajout de la timeline dans le layout global
        vbox.addWidget(self.timeline)

        # Ajout du graphicView + tabBox dans un layout horizontal
        hboxView=QHBoxLayout()
        self.groupBox = QGroupBox(parent)
        sizePolicy = QSizePolicy(QSizePolicy.Expanding, QSizePolicy.Expanding)
        sizePolicy.setHorizontalStretch(2)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.groupBox.sizePolicy().hasHeightForWidth())
        self.groupBox.setSizePolicy(sizePolicy)
        self.groupBox.setMinimumSize(QSize(280, 180))
        self.groupBox.setObjectName("groupBox")

        # Ajout du QGraphicsView de prévisualisation
        boxPrev = QHBoxLayout()
        self.groupBox.setLayout(boxPrev)
        self.preview = QGraphicsView(self.groupBox)
        sizePolicy = QSizePolicy(QSizePolicy.Expanding, QSizePolicy.Expanding)
        sizePolicy.setHorizontalStretch(1)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.preview.sizePolicy().hasHeightForWidth())
        self.preview.setSizePolicy(sizePolicy)
        self.preview.setMinimumSize(QSize(260, 160))
        self.preview.setObjectName("preview")
        boxPrev.addWidget(self.preview)
        # TabWidget
        self.option = QTabWidget(parent)
        sizePolicy = QSizePolicy(QSizePolicy.Expanding, QSizePolicy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.option.sizePolicy().hasHeightForWidth())
        self.option.setSizePolicy(sizePolicy)
        self.option.setMinimumSize(QSize(430, 260))
        self.option.setMaximumSize(QSize(530, 500))
        self.option.setObjectName("option")

        hboxView.addWidget(self.groupBox)
        hboxView.addWidget(self.option)
        vbox.addLayout(hboxView)

        self.tab = QWidget()
        self.tab.setObjectName("tab")
        self.verticalLayout = QVBoxLayout(self.tab)
        self.verticalLayout.setObjectName("verticalLayout")
        self.groupBox_6 = QGroupBox(self.tab)
        self.groupBox_6.setObjectName("groupBox_6")
        self.gridLayout = QGridLayout(self.groupBox_6)
        self.gridLayout.setMargin(1)
        self.gridLayout.setSpacing(2)
        self.gridLayout.setObjectName("gridLayout")
        self.label_11 = QLabel(self.groupBox_6)
        self.label_11.setObjectName("label_11")
        self.gridLayout.addWidget(self.label_11, 0, 0, 1, 1)
        self.imgformat = QComboBox(self.groupBox_6)
        self.imgformat.setMinimumSize(QSize(0, 26))
        self.imgformat.setObjectName("imgformat")
        self.imgformat.addItem(QString())
        self.imgformat.addItem(QString())
        self.gridLayout.addWidget(self.imgformat, 0, 1, 1, 1)
        self.label_2 = QLabel(self.groupBox_6)
        self.label_2.setObjectName("label_2")
        self.gridLayout.addWidget(self.label_2, 1, 0, 1, 1)
        self.videof = QComboBox(self.groupBox_6)
        self.videof.setMinimumSize(QSize(0, 26))
        self.videof.setObjectName("videof")
        self.videof.addItem(QString())
        self.videof.addItem(QString())
        self.videof.addItem(QString())
        self.videof.addItem(QString())
        self.videof.addItem(QString())
        self.videof.addItem(QString())
        self.videof.addItem(QString())
        self.gridLayout.addWidget(self.videof, 1, 1, 1, 1)
        self.label_9 = QLabel(self.groupBox_6)
        self.label_9.setObjectName("label_9")
        self.gridLayout.addWidget(self.label_9, 2, 0, 1, 1)
        self.outputfileformat = QComboBox(self.groupBox_6)
        self.outputfileformat.setMinimumSize(QSize(0, 26))
        self.outputfileformat.setObjectName("outputfileformat")
        self.gridLayout.addWidget(self.outputfileformat, 2, 1, 1, 1)
        self.verticalLayout.addWidget(self.groupBox_6)
        self.groupBox_5 = QGroupBox(self.tab)
        self.groupBox_5.setObjectName("groupBox_5")
        self.horizontalLayout_2 = QHBoxLayout(self.groupBox_5)
        self.horizontalLayout_2.setSpacing(2)
        self.horizontalLayout_2.setMargin(1)
        self.horizontalLayout_2.setObjectName("horizontalLayout_2")
        self.label_8 = QLabel(self.groupBox_5)
        self.label_8.setObjectName("label_8")
        self.horizontalLayout_2.addWidget(self.label_8)
        self.soundfile = QLineEdit(self.groupBox_5)
        self.soundfile.setMinimumSize(QSize(0, 26))
        self.soundfile.setObjectName("soundfile")
        self.horizontalLayout_2.addWidget(self.soundfile)
        self.soundfilea = QToolButton(self.groupBox_5)
        self.soundfilea.setObjectName("soundfilea")
        self.horizontalLayout_2.addWidget(self.soundfilea)
        self.verticalLayout.addWidget(self.groupBox_5)
        spacerItem = QSpacerItem(20, 40, QSizePolicy.Minimum, QSizePolicy.Expanding)
        self.verticalLayout.addItem(spacerItem)
        self.option.addTab(self.tab, "")
        self.tabimage = QWidget()
        self.tabimage.setObjectName("tabimage")
        self.groupBox_3 = QGroupBox(self.tabimage)
        self.groupBox_3.setGeometry(QRect(10, 10, 401, 108))
        sizePolicy = QSizePolicy(QSizePolicy.Preferred, QSizePolicy.Preferred)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.groupBox_3.sizePolicy().hasHeightForWidth())
        self.groupBox_3.setSizePolicy(sizePolicy)
        self.groupBox_3.setMinimumSize(QSize(0, 0))
        self.groupBox_3.setObjectName("groupBox_3")
        self.gridLayout_3 = QGridLayout(self.groupBox_3)
        self.gridLayout_3.setMargin(1)
        self.gridLayout_3.setSpacing(2)
        self.gridLayout_3.setObjectName("gridLayout_3")
        self.label_3 = QLabel(self.groupBox_3)
        self.label_3.setObjectName("label_3")
        self.gridLayout_3.addWidget(self.label_3, 0, 0, 1, 1)
        self.time = QSpinBox(self.groupBox_3)
        sizePolicy = QSizePolicy(QSizePolicy.Preferred, QSizePolicy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.time.sizePolicy().hasHeightForWidth())
        self.time.setSizePolicy(sizePolicy)
        self.time.setMinimumSize(QSize(0, 26))
        self.time.setObjectName("time")
        self.gridLayout_3.addWidget(self.time, 0, 1, 1, 1)
        self.label_4 = QLabel(self.groupBox_3)
        self.label_4.setObjectName("label_4")
        self.gridLayout_3.addWidget(self.label_4, 1, 0, 1, 1)
        self.horizontalLayout_4 = QHBoxLayout()
        self.horizontalLayout_4.setObjectName("horizontalLayout_4")
        self.bgfile = QLineEdit(self.groupBox_3)
        self.bgfile.setMinimumSize(QSize(0, 26))
        self.bgfile.setObjectName("bgfile")
        self.horizontalLayout_4.addWidget(self.bgfile)
        self.bgfilea = QToolButton(self.groupBox_3)
        self.bgfilea.setObjectName("bgfilea")
        self.horizontalLayout_4.addWidget(self.bgfilea)
        self.gridLayout_3.addLayout(self.horizontalLayout_4, 1, 1, 1, 1)
        self.label_5 = QLabel(self.groupBox_3)
        self.label_5.setObjectName("label_5")
        self.gridLayout_3.addWidget(self.label_5, 2, 0, 1, 1)
        self.horizontalLayout_3 = QHBoxLayout()
        self.horizontalLayout_3.setObjectName("horizontalLayout_3")
        self.bgcolor = QLineEdit(self.groupBox_3)
        sizePolicy = QSizePolicy(QSizePolicy.Expanding, QSizePolicy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.bgcolor.sizePolicy().hasHeightForWidth())
        self.bgcolor.setSizePolicy(sizePolicy)
        self.bgcolor.setMinimumSize(QSize(0, 26))
        self.bgcolor.setObjectName("bgcolor")
        self.horizontalLayout_3.addWidget(self.bgcolor)
        self.bgcolora = QToolButton(self.groupBox_3)
        self.bgcolora.setObjectName("bgcolora")
        self.horizontalLayout_3.addWidget(self.bgcolora)
        self.gridLayout_3.addLayout(self.horizontalLayout_3, 2, 1, 1, 1)
        self.groupBox_4 = QGroupBox(self.tabimage)
        self.groupBox_4.setGeometry(QRect(10, 130, 401, 104))
        sizePolicy = QSizePolicy(QSizePolicy.Preferred, QSizePolicy.Preferred)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.groupBox_4.sizePolicy().hasHeightForWidth())
        self.groupBox_4.setSizePolicy(sizePolicy)
        self.groupBox_4.setMinimumSize(QSize(0, 0))
        self.groupBox_4.setObjectName("groupBox_4")
        self.gridLayout_2 = QGridLayout(self.groupBox_4)
        self.gridLayout_2.setMargin(1)
        self.gridLayout_2.setSpacing(2)
        self.gridLayout_2.setObjectName("gridLayout_2")
        self.label_10 = QLabel(self.groupBox_4)
        self.label_10.setObjectName("label_10")
        self.gridLayout_2.addWidget(self.label_10, 0, 0, 1, 1)
        self.speedt = QComboBox(self.groupBox_4)
        self.speedt.setMinimumSize(QSize(0, 26))
        self.speedt.setObjectName("speedt")
        self.speedt.addItem(QString())
        self.speedt.addItem(QString())
        self.speedt.addItem(QString())
        self.speedt.addItem(QString())
        self.speedt.addItem(QString())
        self.speedt.addItem(QString())
        self.gridLayout_2.addWidget(self.speedt, 0, 1, 1, 1)
        self.label_6 = QLabel(self.groupBox_4)
        self.label_6.setObjectName("label_6")
        self.gridLayout_2.addWidget(self.label_6, 1, 0, 1, 1)
        self.typet = QComboBox(self.groupBox_4)
        self.typet.setMinimumSize(QSize(0, 26))
        self.typet.setObjectName("typet")
        self.gridLayout_2.addWidget(self.typet, 1, 1, 1, 1)
        self.label_7 = QLabel(self.groupBox_4)
        self.label_7.setObjectName("label_7")
        self.gridLayout_2.addWidget(self.label_7, 2, 0, 1, 1)
        self.transiopt = QComboBox(self.groupBox_4)
        self.transiopt.setMinimumSize(QSize(0, 26))
        self.transiopt.setObjectName("transiopt")
        self.gridLayout_2.addWidget(self.transiopt, 2, 1, 1, 1)
        self.option.addTab(self.tabimage, "")
        self.tabtext = QWidget()
        self.tabtext.setObjectName("tabtext")
        self.horizontalLayout_5 = QHBoxLayout(self.tabtext)
        self.horizontalLayout_5.setSpacing(2)
        self.horizontalLayout_5.setMargin(1)
        self.horizontalLayout_5.setObjectName("horizontalLayout_5")
        self.gridLayout_5 = QGridLayout()
        self.gridLayout_5.setSpacing(2)
        self.gridLayout_5.setObjectName("gridLayout_5")
        self.fontComboBox = QFontComboBox(self.tabtext)
        self.fontComboBox.setMinimumSize(QSize(0, 26))
        self.fontComboBox.setObjectName("fontComboBox")
        self.gridLayout_5.addWidget(self.fontComboBox, 0, 0, 1, 1)
        self.fontSize = QComboBox(self.tabtext)
        self.fontSize.setObjectName("fontSize")
        self.gridLayout_5.addWidget(self.fontSize, 0, 1, 1, 1)
        self.textEdit = QTextEdit(self.tabtext)
        font = QFont()
        font.setFamily("Arial")
        font.setPointSize(12)
        self.textEdit.setFont(font)
        self.textEdit.setObjectName("textEdit")
        self.gridLayout_5.addWidget(self.textEdit, 1, 0, 1, 2)
        self.horizontalLayout_5.addLayout(self.gridLayout_5)
        self.gridLayout_4 = QGridLayout()
        self.gridLayout_4.setSpacing(2)
        self.gridLayout_4.setObjectName("gridLayout_4")
        self.fontColor = QLineEdit(self.tabtext)
        self.fontColor.setMinimumSize(QSize(0, 26))
        self.fontColor.setObjectName("fontColor")
        self.gridLayout_4.addWidget(self.fontColor, 0, 1, 1, 2)
        self.fontColorB = QToolButton(self.tabtext)
        self.fontColorB.setObjectName("fontColorB")
        self.gridLayout_4.addWidget(self.fontColorB, 0, 3, 1, 1)
        self.bold = QToolButton(self.tabtext)
        icon2 = QIcon()
        icon2.addPixmap(QPixmap("Icones/text_bold.png"), QIcon.Normal, QIcon.Off)
        self.bold.setIcon(icon2)
        self.bold.setCheckable(True)
        self.bold.setChecked(False)
        self.bold.setObjectName("bold")
        self.gridLayout_4.addWidget(self.bold, 1, 1, 1, 1)
        self.Italic = QToolButton(self.tabtext)
        icon3 = QIcon()
        icon3.addPixmap(QPixmap("Icones/text_italic.png"), QIcon.Normal, QIcon.Off)
        self.Italic.setIcon(icon3)
        self.Italic.setCheckable(True)
        self.Italic.setObjectName("Italic")
        self.gridLayout_4.addWidget(self.Italic, 1, 2, 1, 1)
        self.Souligne = QToolButton(self.tabtext)
        icon4 = QIcon()
        icon4.addPixmap(QPixmap("Icones/text_underline.png"), QIcon.Normal, QIcon.Off)
        self.Souligne.setIcon(icon4)
        self.Souligne.setCheckable(True)
        self.Souligne.setObjectName("Souligne")
        self.gridLayout_4.addWidget(self.Souligne, 1, 3, 1, 1)
        self.textLeft = QToolButton(self.tabtext)
        icon5 = QIcon()
        icon5.addPixmap(QPixmap("Icones/text_align_left.png"), QIcon.Normal, QIcon.Off)
        self.textLeft.setIcon(icon5)
        self.textLeft.setCheckable(True)
        self.textLeft.setChecked(True)
        self.textLeft.setAutoExclusive(True)
        self.textLeft.setObjectName("textLeft")
        self.gridLayout_4.addWidget(self.textLeft, 2, 1, 1, 1)
        self.textCenter = QToolButton(self.tabtext)
        icon6 = QIcon()
        icon6.addPixmap(QPixmap("Icones/text_align_center.png"), QIcon.Normal, QIcon.Off)
        self.textCenter.setIcon(icon6)
        self.textCenter.setCheckable(True)
        self.textCenter.setAutoExclusive(True)
        self.textCenter.setObjectName("textCenter")
        self.gridLayout_4.addWidget(self.textCenter, 2, 2, 1, 1)
        self.textRight = QToolButton(self.tabtext)
        icon7 = QIcon()
        icon7.addPixmap(QPixmap("Icones/text_align_right.png"), QIcon.Normal, QIcon.Off)
        self.textRight.setIcon(icon7)
        self.textRight.setCheckable(True)
        self.textRight.setAutoExclusive(True)
        self.textRight.setObjectName("textRight")
        self.gridLayout_4.addWidget(self.textRight, 2, 3, 1, 1)
        self.addText = QToolButton(self.tabtext)
        icon8 = QIcon()
        icon8.addPixmap(QPixmap("Icones/vcard_add.png"), QIcon.Normal, QIcon.Off)
        self.addText.setIcon(icon8)
        self.addText.setObjectName("addText")
        self.gridLayout_4.addWidget(self.addText, 3, 1, 1, 1)
        self.updateText = QToolButton(self.tabtext)
        icon9 = QIcon()
        icon9.addPixmap(QPixmap("Icones/vcard_edit.png"), QIcon.Normal, QIcon.Off)
        self.updateText.setIcon(icon9)
        self.updateText.setObjectName("updateText")
        self.gridLayout_4.addWidget(self.updateText, 3, 2, 1, 1)
        self.deleteText = QToolButton(self.tabtext)
        icon10 = QIcon()
        icon10.addPixmap(QPixmap("Icones/vcard_delete.png"), QIcon.Normal, QIcon.Off)
        self.deleteText.setIcon(icon10)
        self.deleteText.setObjectName("deleteText")
        self.gridLayout_4.addWidget(self.deleteText, 3, 3, 1, 1)
        spacerItem1 = QSpacerItem(20, 40, QSizePolicy.Minimum, QSizePolicy.Expanding)
        self.gridLayout_4.addItem(spacerItem1, 4, 2, 1, 1)
        self.emptyText = QToolButton(self.tabtext)
        icon11 = QIcon()
        icon11.addPixmap(QPixmap("Icones/textfield_delete.png"), QIcon.Normal, QIcon.Off)
        self.emptyText.setIcon(icon11)
        self.emptyText.setObjectName("emptyText")
        self.gridLayout_4.addWidget(self.emptyText, 0, 0, 1, 1)
        self.horizontalLayout_5.addLayout(self.gridLayout_4)
        self.option.addTab(self.tabtext, "")
        self.tabzoom = QWidget()
        self.tabzoom.setObjectName("tabzoom")
        self.verticalLayout_7 = QVBoxLayout(self.tabzoom)
        self.verticalLayout_7.setSpacing(2)
        self.verticalLayout_7.setMargin(1)
        self.verticalLayout_7.setObjectName("verticalLayout_7")
        self.horizontalLayout_11 = QHBoxLayout()
        self.horizontalLayout_11.setSpacing(2)
        self.horizontalLayout_11.setObjectName("horizontalLayout_11")
        self.chkZoom = QCheckBox(self.tabzoom)
        self.chkZoom.setObjectName("chkZoom")
        self.horizontalLayout_11.addWidget(self.chkZoom)
        self.validZoom = QPushButton(self.tabzoom)
        icon12 = QIcon()
        icon12.addPixmap(QPixmap("Icones/ok.png"), QIcon.Normal, QIcon.Off)
        self.validZoom.setIcon(icon12)
        self.validZoom.setObjectName("validZoom")
        self.horizontalLayout_11.addWidget(self.validZoom)
        self.verticalLayout_7.addLayout(self.horizontalLayout_11)
        self.horizontalLayout_10 = QHBoxLayout()
        self.horizontalLayout_10.setSpacing(2)
        self.horizontalLayout_10.setObjectName("horizontalLayout_10")
        self.groupBox_7 = QGroupBox(self.tabzoom)
        self.groupBox_7.setAutoFillBackground(False)
        self.groupBox_7.setStyleSheet("""color: rgb(255, 0, 0);
""")
        self.groupBox_7.setObjectName("groupBox_7")
        self.verticalLayout_4 = QVBoxLayout(self.groupBox_7)
        self.verticalLayout_4.setObjectName("verticalLayout_4")
        self.horizontalLayout_7 = QHBoxLayout()
        self.horizontalLayout_7.setObjectName("horizontalLayout_7")
        self.label_13 = QLabel(self.groupBox_7)
        self.label_13.setStyleSheet("color: rgb(0, 0, 0);")
        self.label_13.setObjectName("label_13")
        self.horizontalLayout_7.addWidget(self.label_13)
        self.startZoomSize = QSpinBox(self.groupBox_7)
        self.startZoomSize.setProperty("value", QVariant(50))
        self.startZoomSize.setObjectName("startZoomSize")
        self.horizontalLayout_7.addWidget(self.startZoomSize)
        self.label_16 = QLabel(self.groupBox_7)
        self.label_16.setStyleSheet("color: rgb(0, 0, 0);")
        self.label_16.setObjectName("label_16")
        self.horizontalLayout_7.addWidget(self.label_16)
        self.verticalLayout_4.addLayout(self.horizontalLayout_7)
        self.startZoomView = QLabel(self.groupBox_7)
        self.startZoomView.setObjectName("startZoomView")
        self.verticalLayout_4.addWidget(self.startZoomView)
        spacerItem2 = QSpacerItem(20, 40, QSizePolicy.Minimum, QSizePolicy.Expanding)
        self.verticalLayout_4.addItem(spacerItem2)
        self.horizontalLayout_10.addWidget(self.groupBox_7)
        self.groupBox_8 = QGroupBox(self.tabzoom)
        self.groupBox_8.setStyleSheet("color: rgb(0, 0, 255);")
        self.groupBox_8.setObjectName("groupBox_8")
        self.verticalLayout_3 = QVBoxLayout(self.groupBox_8)
        self.verticalLayout_3.setObjectName("verticalLayout_3")
        self.horizontalLayout_6 = QHBoxLayout()
        self.horizontalLayout_6.setObjectName("horizontalLayout_6")
        self.label_14 = QLabel(self.groupBox_8)
        self.label_14.setStyleSheet("color: rgb(0, 0, 0);")
        self.label_14.setObjectName("label_14")
        self.horizontalLayout_6.addWidget(self.label_14)
        self.endZoomSize = QSpinBox(self.groupBox_8)
        self.endZoomSize.setProperty("value", QVariant(50))
        self.endZoomSize.setObjectName("endZoomSize")
        self.horizontalLayout_6.addWidget(self.endZoomSize)
        self.label_15 = QLabel(self.groupBox_8)
        self.label_15.setStyleSheet("color: rgb(0, 0, 0);")
        self.label_15.setObjectName("label_15")
        self.horizontalLayout_6.addWidget(self.label_15)
        self.verticalLayout_3.addLayout(self.horizontalLayout_6)
        self.endZoomView = QLabel(self.groupBox_8)
        self.endZoomView.setObjectName("endZoomView")
        self.verticalLayout_3.addWidget(self.endZoomView)
        spacerItem3 = QSpacerItem(20, 40, QSizePolicy.Minimum, QSizePolicy.Expanding)
        self.verticalLayout_3.addItem(spacerItem3)
        self.horizontalLayout_10.addWidget(self.groupBox_8)
        self.verticalLayout_7.addLayout(self.horizontalLayout_10)
        self.option.addTab(self.tabzoom, "")
        self.option.setCurrentIndex(0)
