#!/usr/bin/python
# -*- coding: utf-8 -*-

class SpecialDureeVideoSec(object):
	"Détection durée vidéo avec certaines versions de FFmpeg pour un transcodage en WebM"
  
	def __init__(self, dureeVideo):
		# Initialisation
		self.dureeVideo = dureeVideo
		
	def calculDureeSec(self):
		
		# Constitution d'une liste avec les valeurs de heure, 
		# minute, seconde sous cette forme ['00', '01', '47.9']
		lCalc = "".join(self.dureeVideo).split(':')

		lSecond = []

		# Les données de temps affichées ds FFmpeg ne sont pas directement exploitables
		# Il y a des choses à transformer ... surtout si on trouve des '00'
		if lCalc[0][0] == '0': 
			lCalc[0] = float(lCalc[0][1])
			lSecond.append(float(lCalc[0]))
		elif lCalc[0][0] != '0':
			lSecond.append(float(lCalc[0]))
		if lCalc[1][0] == '0': 
			lCalc[1]=float(lCalc[1][1])
			lSecond.append(float(lCalc[1]))
		elif lCalc[1][0] != '0':
			lSecond.append(float(lCalc[1]))
		if lCalc[2][0] == '0': 
			lCalc[2] = float(lCalc[2][1])
			lSecond.append(float(lCalc[2]))
		elif lCalc[2][0] != '0':
			lSecond.append(float(lCalc[2]))
			
		# Calcul de la durée de la vidéo en secondes
		self.dureeVideoSec = str(float((lSecond[0] * 3600.0) + (lSecond[1] * 60.0) + lSecond[2]))
		
		return self.dureeVideoSec